/* color.c generated by valac 0.20.1, the Vala compiler
 * generated from color.vala, do not modify */

/*
 * Extension to Gdk.Color which has support for an alpha channel.
 *
 * Copyright (C) 2008, 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <float.h>
#include <math.h>


#define DESKTOP_AGNOSTIC_TYPE_COLOR (desktop_agnostic_color_get_type ())
#define DESKTOP_AGNOSTIC_COLOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_AGNOSTIC_TYPE_COLOR, DesktopAgnosticColor))
#define DESKTOP_AGNOSTIC_COLOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_AGNOSTIC_TYPE_COLOR, DesktopAgnosticColorClass))
#define DESKTOP_AGNOSTIC_IS_COLOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_AGNOSTIC_TYPE_COLOR))
#define DESKTOP_AGNOSTIC_IS_COLOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_AGNOSTIC_TYPE_COLOR))
#define DESKTOP_AGNOSTIC_COLOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_AGNOSTIC_TYPE_COLOR, DesktopAgnosticColorClass))

typedef struct _DesktopAgnosticColor DesktopAgnosticColor;
typedef struct _DesktopAgnosticColorClass DesktopAgnosticColorClass;
typedef struct _DesktopAgnosticColorPrivate DesktopAgnosticColorPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

typedef enum  {
	DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR_INVALID_INPUT,
	DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR_INVALID_ALPHA
} DesktopAgnosticColorParseError;
#define DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR desktop_agnostic_color_parse_error_quark ()
struct _DesktopAgnosticColor {
	GObject parent_instance;
	DesktopAgnosticColorPrivate * priv;
};

struct _DesktopAgnosticColorClass {
	GObjectClass parent_class;
};

struct _DesktopAgnosticColorPrivate {
	GdkColor _color;
	gushort _alpha;
};


static gpointer desktop_agnostic_color_parent_class = NULL;

GQuark desktop_agnostic_color_parse_error_quark (void);
GType desktop_agnostic_color_get_type (void) G_GNUC_CONST;
#define DESKTOP_AGNOSTIC_COLOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DESKTOP_AGNOSTIC_TYPE_COLOR, DesktopAgnosticColorPrivate))
enum  {
	DESKTOP_AGNOSTIC_COLOR_DUMMY_PROPERTY,
	DESKTOP_AGNOSTIC_COLOR_COLOR,
	DESKTOP_AGNOSTIC_COLOR_RED,
	DESKTOP_AGNOSTIC_COLOR_GREEN,
	DESKTOP_AGNOSTIC_COLOR_BLUE,
	DESKTOP_AGNOSTIC_COLOR_ALPHA
};
#define DESKTOP_AGNOSTIC_COLOR_HTML_STRING "#%02hx%02hx%02hx%02hx"
#define DESKTOP_AGNOSTIC_COLOR_HTML_SCALE ((gushort) 256)
static gushort desktop_agnostic_color_ushortify (DesktopAgnosticColor* self, guint value, GError** error);
DesktopAgnosticColor* desktop_agnostic_color_new (GdkColor* color, gushort alpha);
DesktopAgnosticColor* desktop_agnostic_color_construct (GType object_type, GdkColor* color, gushort alpha);
DesktopAgnosticColor* desktop_agnostic_color_new_from_values (gushort red, gushort green, gushort blue, gushort alpha);
DesktopAgnosticColor* desktop_agnostic_color_construct_from_values (GType object_type, gushort red, gushort green, gushort blue, gushort alpha);
DesktopAgnosticColor* desktop_agnostic_color_new_from_string (const gchar* spec, GError** error);
DesktopAgnosticColor* desktop_agnostic_color_construct_from_string (GType object_type, const gchar* spec, GError** error);
gchar* desktop_agnostic_color_to_html_color (DesktopAgnosticColor* self);
guint desktop_agnostic_color_get_red (DesktopAgnosticColor* self);
guint desktop_agnostic_color_get_green (DesktopAgnosticColor* self);
guint desktop_agnostic_color_get_blue (DesktopAgnosticColor* self);
gchar* desktop_agnostic_color_to_string (DesktopAgnosticColor* self);
void desktop_agnostic_color_get_cairo_color (DesktopAgnosticColor* self, gdouble* red, gdouble* green, gdouble* blue, gdouble* alpha);
gdouble desktop_agnostic_color_gdk_value_to_cairo (gushort value);
void desktop_agnostic_color_set_cairo_color (DesktopAgnosticColor* self, gdouble red, gdouble green, gdouble blue, gdouble alpha);
gushort desktop_agnostic_color_cairo_value_to_gdk (gdouble value);
void desktop_agnostic_color_set_red (DesktopAgnosticColor* self, guint value);
void desktop_agnostic_color_set_green (DesktopAgnosticColor* self, guint value);
void desktop_agnostic_color_set_blue (DesktopAgnosticColor* self, guint value);
void desktop_agnostic_color_get_color (DesktopAgnosticColor* self, GdkColor* result);
void desktop_agnostic_color_set_color (DesktopAgnosticColor* self, GdkColor* value);
guint desktop_agnostic_color_get_alpha (DesktopAgnosticColor* self);
void desktop_agnostic_color_set_alpha (DesktopAgnosticColor* self, guint value);
static void desktop_agnostic_color_finalize (GObject* obj);
static void _vala_desktop_agnostic_color_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_desktop_agnostic_color_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GQuark desktop_agnostic_color_parse_error_quark (void) {
	return g_quark_from_static_string ("desktop_agnostic_color_parse_error-quark");
}


static gushort desktop_agnostic_color_ushortify (DesktopAgnosticColor* self, guint value, GError** error) {
	gushort result = 0U;
	gboolean _tmp0_ = FALSE;
	guint _tmp1_;
	gboolean _tmp4_;
	guint _tmp7_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp1_ = value;
	if (_tmp1_ < ((guint) 0)) {
		_tmp0_ = TRUE;
	} else {
		guint _tmp2_;
		gushort _tmp3_;
		_tmp2_ = value;
		_tmp3_ = G_MAXUSHORT;
		_tmp0_ = _tmp2_ > ((guint) _tmp3_);
	}
	_tmp4_ = _tmp0_;
	if (_tmp4_) {
		gushort _tmp5_;
		GError* _tmp6_;
		_tmp5_ = G_MAXUSHORT;
		_tmp6_ = g_error_new (DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR, DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR_INVALID_INPUT, "RGB values must be between 0 and %hu.", _tmp5_);
		_inner_error_ = _tmp6_;
		if (_inner_error_->domain == DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return 0U;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0U;
		}
	}
	_tmp7_ = value;
	result = (gushort) _tmp7_;
	return result;
}


DesktopAgnosticColor* desktop_agnostic_color_construct (GType object_type, GdkColor* color, gushort alpha) {
	DesktopAgnosticColor * self = NULL;
	GdkColor _tmp0_;
	gushort _tmp1_;
	g_return_val_if_fail (color != NULL, NULL);
	self = (DesktopAgnosticColor*) g_object_new (object_type, NULL);
	_tmp0_ = *color;
	self->priv->_color = _tmp0_;
	_tmp1_ = alpha;
	self->priv->_alpha = _tmp1_;
	return self;
}


DesktopAgnosticColor* desktop_agnostic_color_new (GdkColor* color, gushort alpha) {
	return desktop_agnostic_color_construct (DESKTOP_AGNOSTIC_TYPE_COLOR, color, alpha);
}


DesktopAgnosticColor* desktop_agnostic_color_construct_from_values (GType object_type, gushort red, gushort green, gushort blue, gushort alpha) {
	DesktopAgnosticColor * self = NULL;
	gushort _tmp0_;
	gushort _tmp1_;
	gushort _tmp2_;
	gushort _tmp3_;
	self = (DesktopAgnosticColor*) g_object_new (object_type, NULL);
	memset (&self->priv->_color, 0, sizeof (GdkColor));
	_tmp0_ = red;
	self->priv->_color.red = (guint16) _tmp0_;
	_tmp1_ = green;
	self->priv->_color.green = (guint16) _tmp1_;
	_tmp2_ = blue;
	self->priv->_color.blue = (guint16) _tmp2_;
	_tmp3_ = alpha;
	self->priv->_alpha = _tmp3_;
	return self;
}


DesktopAgnosticColor* desktop_agnostic_color_new_from_values (gushort red, gushort green, gushort blue, gushort alpha) {
	return desktop_agnostic_color_construct_from_values (DESKTOP_AGNOSTIC_TYPE_COLOR, red, green, blue, alpha);
}


/**
     * Parses color from string.
     * @see Gdk.Color.parse
     */
static gunichar string_get_char (const gchar* self, glong index) {
	gunichar result = 0U;
	glong _tmp0_;
	gunichar _tmp1_ = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = index;
	_tmp1_ = g_utf8_get_char (((gchar*) self) + _tmp0_);
	result = _tmp1_;
	return result;
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* end;
	gchar* _tmp3_;
	_tmp0_ = str;
	_tmp1_ = maxlen;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	end = _tmp2_;
	_tmp3_ = end;
	if (_tmp3_ == NULL) {
		glong _tmp4_;
		_tmp4_ = maxlen;
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = end;
		_tmp6_ = str;
		result = (glong) (_tmp5_ - _tmp6_);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	gboolean _tmp3_;
	glong _tmp9_;
	glong _tmp15_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = offset;
	if (_tmp1_ >= ((glong) 0)) {
		glong _tmp2_;
		_tmp2_ = len;
		_tmp0_ = _tmp2_ >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		glong _tmp4_;
		glong _tmp5_;
		glong _tmp6_ = 0L;
		_tmp4_ = offset;
		_tmp5_ = len;
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
		string_length = _tmp6_;
	} else {
		gint _tmp7_;
		gint _tmp8_;
		_tmp7_ = strlen (self);
		_tmp8_ = _tmp7_;
		string_length = (glong) _tmp8_;
	}
	_tmp9_ = offset;
	if (_tmp9_ < ((glong) 0)) {
		glong _tmp10_;
		glong _tmp11_;
		glong _tmp12_;
		_tmp10_ = string_length;
		_tmp11_ = offset;
		offset = _tmp10_ + _tmp11_;
		_tmp12_ = offset;
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
	} else {
		glong _tmp13_;
		glong _tmp14_;
		_tmp13_ = offset;
		_tmp14_ = string_length;
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
	}
	_tmp15_ = len;
	if (_tmp15_ < ((glong) 0)) {
		glong _tmp16_;
		glong _tmp17_;
		_tmp16_ = string_length;
		_tmp17_ = offset;
		len = _tmp16_ - _tmp17_;
	}
	_tmp18_ = offset;
	_tmp19_ = len;
	_tmp20_ = string_length;
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
	_tmp21_ = offset;
	_tmp22_ = len;
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
	result = _tmp23_;
	return result;
}


static const gchar* string_offset (const gchar* self, glong offset) {
	const gchar* result = NULL;
	glong _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = offset;
	result = (const gchar*) (((gchar*) self) + _tmp0_);
	return result;
}


DesktopAgnosticColor* desktop_agnostic_color_construct_from_string (GType object_type, const gchar* spec, GError** error) {
	DesktopAgnosticColor * self = NULL;
	gushort _tmp0_;
	gchar* color_data = NULL;
	const gchar* _tmp1_;
	gunichar _tmp2_ = 0U;
	const gchar* _tmp48_;
	GdkColor _tmp49_ = {0};
	gboolean _tmp50_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (spec != NULL, NULL);
	self = (DesktopAgnosticColor*) g_object_new (object_type, NULL);
	memset (&self->priv->_color, 0, sizeof (GdkColor));
	_tmp0_ = G_MAXUSHORT;
	self->priv->_alpha = _tmp0_;
	_tmp1_ = spec;
	_tmp2_ = string_get_char (_tmp1_, (glong) 0);
	if (_tmp2_ == ((gunichar) '#')) {
		gsize cd_len;
		const gchar* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* color_hex;
		const gchar* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		gsize _tmp10_;
		gboolean _tmp12_;
		gboolean _tmp14_;
		gsize _tmp16_;
		gsize hex_len;
		gsize _tmp17_;
		gsize offset;
		const gchar* _tmp18_;
		gsize _tmp19_;
		gchar* _tmp20_ = NULL;
		gchar* rgb_hex;
		const gchar* _tmp21_;
		gsize _tmp22_;
		const gchar* _tmp23_ = NULL;
		const gchar* alpha_hex;
		const gchar* _tmp24_;
		gsize _tmp25_;
		gchar* _tmp26_ = NULL;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gint _tmp32_ = 0;
		gboolean _tmp33_;
		gsize _tmp36_;
		gushort bits;
		gushort _tmp37_;
		gushort _tmp38_;
		const gchar* _tmp44_;
		gchar* _tmp45_;
		cd_len = (gsize) 0;
		_tmp3_ = spec;
		_tmp4_ = string_substring (_tmp3_, (glong) 1, (glong) (-1));
		color_hex = _tmp4_;
		_tmp5_ = color_hex;
		_tmp6_ = strlen (_tmp5_);
		_tmp7_ = _tmp6_;
		cd_len = (gsize) _tmp7_;
		_tmp10_ = cd_len;
		if ((_tmp10_ % 4) != ((gsize) 0)) {
			_tmp9_ = TRUE;
		} else {
			gsize _tmp11_;
			_tmp11_ = cd_len;
			_tmp9_ = _tmp11_ < ((gsize) 4);
		}
		_tmp12_ = _tmp9_;
		if (_tmp12_) {
			_tmp8_ = TRUE;
		} else {
			gsize _tmp13_;
			_tmp13_ = cd_len;
			_tmp8_ = _tmp13_ > ((gsize) 16);
		}
		_tmp14_ = _tmp8_;
		if (_tmp14_) {
			GError* _tmp15_;
			_tmp15_ = g_error_new_literal (DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR, DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR_INVALID_INPUT, "Invalid input size.");
			_inner_error_ = _tmp15_;
			if (_inner_error_->domain == DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (color_hex);
				_g_free0 (color_data);
				_g_object_unref0 (self);
				return NULL;
			} else {
				_g_free0 (color_hex);
				_g_free0 (color_data);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp16_ = cd_len;
		hex_len = _tmp16_ / 4;
		_tmp17_ = hex_len;
		offset = _tmp17_ * 3;
		_tmp18_ = color_hex;
		_tmp19_ = offset;
		_tmp20_ = string_substring (_tmp18_, (glong) 0, (glong) _tmp19_);
		rgb_hex = _tmp20_;
		_tmp21_ = color_hex;
		_tmp22_ = offset;
		_tmp23_ = string_offset (_tmp21_, (glong) _tmp22_);
		alpha_hex = _tmp23_;
		_tmp24_ = alpha_hex;
		_tmp25_ = hex_len;
		_tmp26_ = g_strdup_printf ("%" G_GSIZE_FORMAT, _tmp25_);
		_tmp27_ = _tmp26_;
		_tmp28_ = g_strconcat ("%", _tmp27_, NULL);
		_tmp29_ = _tmp28_;
		_tmp30_ = g_strconcat (_tmp29_, "hx", NULL);
		_tmp31_ = _tmp30_;
		_tmp32_ = sscanf (_tmp24_, _tmp31_, &self->priv->_alpha);
		_tmp33_ = _tmp32_ == 0;
		_g_free0 (_tmp31_);
		_g_free0 (_tmp29_);
		_g_free0 (_tmp27_);
		if (_tmp33_) {
			const gchar* _tmp34_;
			GError* _tmp35_;
			_tmp34_ = alpha_hex;
			_tmp35_ = g_error_new (DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR, DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR_INVALID_ALPHA, "Could not parse alpha section of input: %s", _tmp34_);
			_inner_error_ = _tmp35_;
			if (_inner_error_->domain == DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (rgb_hex);
				_g_free0 (color_hex);
				_g_free0 (color_data);
				_g_object_unref0 (self);
				return NULL;
			} else {
				_g_free0 (rgb_hex);
				_g_free0 (color_hex);
				_g_free0 (color_data);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp36_ = cd_len;
		bits = (gushort) _tmp36_;
		_tmp37_ = self->priv->_alpha;
		_tmp38_ = bits;
		self->priv->_alpha = (gushort) (_tmp37_ << (16 - _tmp38_));
		while (TRUE) {
			gushort _tmp39_;
			gushort _tmp40_;
			gushort _tmp41_;
			gushort _tmp42_;
			gushort _tmp43_;
			_tmp39_ = bits;
			if (!(((gint) _tmp39_) < 16)) {
				break;
			}
			_tmp40_ = self->priv->_alpha;
			_tmp41_ = self->priv->_alpha;
			_tmp42_ = bits;
			self->priv->_alpha = _tmp40_ | (_tmp41_ >> _tmp42_);
			_tmp43_ = bits;
			bits = (gushort) (_tmp43_ * 2);
		}
		_tmp44_ = rgb_hex;
		_tmp45_ = g_strconcat ("#", _tmp44_, NULL);
		_g_free0 (color_data);
		color_data = _tmp45_;
		_g_free0 (rgb_hex);
		_g_free0 (color_hex);
	} else {
		const gchar* _tmp46_;
		gchar* _tmp47_;
		_tmp46_ = spec;
		_tmp47_ = g_strdup (_tmp46_);
		_g_free0 (color_data);
		color_data = _tmp47_;
	}
	_tmp48_ = color_data;
	_tmp50_ = gdk_color_parse (_tmp48_, &_tmp49_);
	self->priv->_color = _tmp49_;
	if (!_tmp50_) {
		const gchar* _tmp51_;
		GError* _tmp52_;
		_tmp51_ = spec;
		_tmp52_ = g_error_new (DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR, DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR_INVALID_INPUT, "Could not parse color string: %s", _tmp51_);
		_inner_error_ = _tmp52_;
		if (_inner_error_->domain == DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (color_data);
			_g_object_unref0 (self);
			return NULL;
		} else {
			_g_free0 (color_data);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_g_free0 (color_data);
	return self;
}


DesktopAgnosticColor* desktop_agnostic_color_new_from_string (const gchar* spec, GError** error) {
	return desktop_agnostic_color_construct_from_string (DESKTOP_AGNOSTIC_TYPE_COLOR, spec, error);
}


gchar* desktop_agnostic_color_to_html_color (DesktopAgnosticColor* self) {
	gchar* result = NULL;
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	gushort _tmp6_;
	gchar* _tmp7_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = desktop_agnostic_color_get_red (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = desktop_agnostic_color_get_green (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = desktop_agnostic_color_get_blue (self);
	_tmp5_ = _tmp4_;
	_tmp6_ = self->priv->_alpha;
	_tmp7_ = g_strdup_printf (DESKTOP_AGNOSTIC_COLOR_HTML_STRING, _tmp1_ / DESKTOP_AGNOSTIC_COLOR_HTML_SCALE, _tmp3_ / DESKTOP_AGNOSTIC_COLOR_HTML_SCALE, _tmp5_ / DESKTOP_AGNOSTIC_COLOR_HTML_SCALE, _tmp6_ / DESKTOP_AGNOSTIC_COLOR_HTML_SCALE);
	result = _tmp7_;
	return result;
}


/**
     * Behaves the same as Gdk.Color.to_string (), except that it adds
     * alpha data.
     * @see Gdk.Color.to_string
     */
gchar* desktop_agnostic_color_to_string (DesktopAgnosticColor* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* gdk_str;
	gushort _tmp1_;
	gchar* _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gdk_color_to_string (&self->priv->_color);
	gdk_str = _tmp0_;
	_tmp1_ = self->priv->_alpha;
	_tmp2_ = g_strdup_printf ("%s%04x", gdk_str, (guint) _tmp1_);
	result = _tmp2_;
	_g_free0 (gdk_str);
	return result;
}


/**
     * Returns the color values as doubles, where 0.0 < value <= 1.0.
     */
void desktop_agnostic_color_get_cairo_color (DesktopAgnosticColor* self, gdouble* red, gdouble* green, gdouble* blue, gdouble* alpha) {
	gdouble _vala_red = 0.0;
	gdouble _vala_green = 0.0;
	gdouble _vala_blue = 0.0;
	gdouble _vala_alpha = 0.0;
	g_return_if_fail (self != NULL);
	if ((&_vala_red) != NULL) {
		guint _tmp0_;
		guint _tmp1_;
		gdouble _tmp2_ = 0.0;
		_tmp0_ = desktop_agnostic_color_get_red (self);
		_tmp1_ = _tmp0_;
		_tmp2_ = desktop_agnostic_color_gdk_value_to_cairo ((gushort) _tmp1_);
		_vala_red = _tmp2_;
	}
	if ((&_vala_green) != NULL) {
		guint _tmp3_;
		guint _tmp4_;
		gdouble _tmp5_ = 0.0;
		_tmp3_ = desktop_agnostic_color_get_green (self);
		_tmp4_ = _tmp3_;
		_tmp5_ = desktop_agnostic_color_gdk_value_to_cairo ((gushort) _tmp4_);
		_vala_green = _tmp5_;
	}
	if ((&_vala_blue) != NULL) {
		guint _tmp6_;
		guint _tmp7_;
		gdouble _tmp8_ = 0.0;
		_tmp6_ = desktop_agnostic_color_get_blue (self);
		_tmp7_ = _tmp6_;
		_tmp8_ = desktop_agnostic_color_gdk_value_to_cairo ((gushort) _tmp7_);
		_vala_blue = _tmp8_;
	}
	if ((&_vala_alpha) != NULL) {
		gushort _tmp9_;
		gdouble _tmp10_ = 0.0;
		_tmp9_ = self->priv->_alpha;
		_tmp10_ = desktop_agnostic_color_gdk_value_to_cairo (_tmp9_);
		_vala_alpha = _tmp10_;
	}
	if (red) {
		*red = _vala_red;
	}
	if (green) {
		*green = _vala_green;
	}
	if (blue) {
		*blue = _vala_blue;
	}
	if (alpha) {
		*alpha = _vala_alpha;
	}
}


/**
     * Sets the color with values as doubles, where 0.0 < value <= 1.0.
     */
void desktop_agnostic_color_set_cairo_color (DesktopAgnosticColor* self, gdouble red, gdouble green, gdouble blue, gdouble alpha) {
	gboolean _tmp0_ = FALSE;
	gdouble _tmp1_;
	gboolean _tmp3_;
	gboolean _tmp6_ = FALSE;
	gdouble _tmp7_;
	gboolean _tmp9_;
	gboolean _tmp12_ = FALSE;
	gdouble _tmp13_;
	gboolean _tmp15_;
	gboolean _tmp18_ = FALSE;
	gdouble _tmp19_;
	gboolean _tmp21_;
	g_return_if_fail (self != NULL);
	_tmp1_ = red;
	if (_tmp1_ > ((gdouble) 0.0f)) {
		gdouble _tmp2_;
		_tmp2_ = red;
		_tmp0_ = _tmp2_ <= ((gdouble) 1.0f);
	} else {
		_tmp0_ = FALSE;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		gdouble _tmp4_;
		gushort _tmp5_ = 0U;
		_tmp4_ = red;
		_tmp5_ = desktop_agnostic_color_cairo_value_to_gdk (_tmp4_);
		desktop_agnostic_color_set_red (self, (guint) _tmp5_);
	}
	_tmp7_ = green;
	if (_tmp7_ > ((gdouble) 0.0f)) {
		gdouble _tmp8_;
		_tmp8_ = green;
		_tmp6_ = _tmp8_ <= ((gdouble) 1.0f);
	} else {
		_tmp6_ = FALSE;
	}
	_tmp9_ = _tmp6_;
	if (_tmp9_) {
		gdouble _tmp10_;
		gushort _tmp11_ = 0U;
		_tmp10_ = green;
		_tmp11_ = desktop_agnostic_color_cairo_value_to_gdk (_tmp10_);
		desktop_agnostic_color_set_green (self, (guint) _tmp11_);
	}
	_tmp13_ = blue;
	if (_tmp13_ > ((gdouble) 0.0f)) {
		gdouble _tmp14_;
		_tmp14_ = blue;
		_tmp12_ = _tmp14_ <= ((gdouble) 1.0f);
	} else {
		_tmp12_ = FALSE;
	}
	_tmp15_ = _tmp12_;
	if (_tmp15_) {
		gdouble _tmp16_;
		gushort _tmp17_ = 0U;
		_tmp16_ = blue;
		_tmp17_ = desktop_agnostic_color_cairo_value_to_gdk (_tmp16_);
		desktop_agnostic_color_set_blue (self, (guint) _tmp17_);
	}
	_tmp19_ = alpha;
	if (_tmp19_ > ((gdouble) 0.0f)) {
		gdouble _tmp20_;
		_tmp20_ = alpha;
		_tmp18_ = _tmp20_ <= ((gdouble) 1.0f);
	} else {
		_tmp18_ = FALSE;
	}
	_tmp21_ = _tmp18_;
	if (_tmp21_) {
		gdouble _tmp22_;
		gushort _tmp23_ = 0U;
		_tmp22_ = alpha;
		_tmp23_ = desktop_agnostic_color_cairo_value_to_gdk (_tmp22_);
		self->priv->_alpha = _tmp23_;
	}
}


/**
     * Converts a single RGBA value for cairo to its GDK/Pango equivalent.
     */
gushort desktop_agnostic_color_cairo_value_to_gdk (gdouble value) {
	gushort result = 0U;
	gdouble _tmp0_;
	glong _tmp1_ = 0L;
	_tmp0_ = value;
	_tmp1_ = lround (_tmp0_ * 65536);
	result = (gushort) (_tmp1_ - 1);
	return result;
}


/**
     * Converts a single RGBA value for GDK/Pango to its cairo equivalent.
     */
gdouble desktop_agnostic_color_gdk_value_to_cairo (gushort value) {
	gdouble result = 0.0;
	gushort _tmp0_;
	_tmp0_ = value;
	result = (_tmp0_ + 1) / 65536.0;
	return result;
}


void desktop_agnostic_color_get_color (DesktopAgnosticColor* self, GdkColor* result) {
	GdkColor _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_color;
	*result = _tmp0_;
	return;
}


void desktop_agnostic_color_set_color (DesktopAgnosticColor* self, GdkColor* value) {
	GdkColor _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = *value;
	self->priv->_color = _tmp0_;
	g_object_notify ((GObject *) self, "color");
}


guint desktop_agnostic_color_get_red (DesktopAgnosticColor* self) {
	guint result;
	GdkColor _tmp0_;
	guint16 _tmp1_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_color;
	_tmp1_ = _tmp0_.red;
	result = (guint) _tmp1_;
	return result;
}


void desktop_agnostic_color_set_red (DesktopAgnosticColor* self, guint value) {
	guint _tmp0_;
	gushort _tmp1_ = 0U;
	gushort _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = desktop_agnostic_color_ushortify (self, _tmp0_, &_inner_error_);
	_tmp2_ = _tmp1_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	self->priv->_color.red = (guint16) _tmp2_;
	g_object_notify ((GObject *) self, "red");
}


guint desktop_agnostic_color_get_green (DesktopAgnosticColor* self) {
	guint result;
	GdkColor _tmp0_;
	guint16 _tmp1_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_color;
	_tmp1_ = _tmp0_.green;
	result = (guint) _tmp1_;
	return result;
}


void desktop_agnostic_color_set_green (DesktopAgnosticColor* self, guint value) {
	guint _tmp0_;
	gushort _tmp1_ = 0U;
	gushort _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = desktop_agnostic_color_ushortify (self, _tmp0_, &_inner_error_);
	_tmp2_ = _tmp1_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	self->priv->_color.green = (guint16) _tmp2_;
	g_object_notify ((GObject *) self, "green");
}


guint desktop_agnostic_color_get_blue (DesktopAgnosticColor* self) {
	guint result;
	GdkColor _tmp0_;
	guint16 _tmp1_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_color;
	_tmp1_ = _tmp0_.blue;
	result = (guint) _tmp1_;
	return result;
}


void desktop_agnostic_color_set_blue (DesktopAgnosticColor* self, guint value) {
	guint _tmp0_;
	gushort _tmp1_ = 0U;
	gushort _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = desktop_agnostic_color_ushortify (self, _tmp0_, &_inner_error_);
	_tmp2_ = _tmp1_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	self->priv->_color.blue = (guint16) _tmp2_;
	g_object_notify ((GObject *) self, "blue");
}


guint desktop_agnostic_color_get_alpha (DesktopAgnosticColor* self) {
	guint result;
	gushort _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_alpha;
	result = (guint) _tmp0_;
	return result;
}


void desktop_agnostic_color_set_alpha (DesktopAgnosticColor* self, guint value) {
	guint _tmp0_;
	gushort _tmp1_ = 0U;
	gushort _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = desktop_agnostic_color_ushortify (self, _tmp0_, &_inner_error_);
	_tmp2_ = _tmp1_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	self->priv->_alpha = _tmp2_;
	g_object_notify ((GObject *) self, "alpha");
}


static void desktop_agnostic_color_class_init (DesktopAgnosticColorClass * klass) {
	desktop_agnostic_color_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DesktopAgnosticColorPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_color_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_desktop_agnostic_color_set_property;
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_color_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_COLOR_COLOR, g_param_spec_boxed ("color", "color", "color", GDK_TYPE_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_COLOR_RED, g_param_spec_uint ("red", "red", "red", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_COLOR_GREEN, g_param_spec_uint ("green", "green", "green", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_COLOR_BLUE, g_param_spec_uint ("blue", "blue", "blue", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_COLOR_ALPHA, g_param_spec_uint ("alpha", "alpha", "alpha", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void desktop_agnostic_color_instance_init (DesktopAgnosticColor * self) {
	gushort _tmp0_;
	self->priv = DESKTOP_AGNOSTIC_COLOR_GET_PRIVATE (self);
	_tmp0_ = G_MAXUSHORT;
	self->priv->_alpha = _tmp0_;
}


static void desktop_agnostic_color_finalize (GObject* obj) {
	DesktopAgnosticColor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_TYPE_COLOR, DesktopAgnosticColor);
	G_OBJECT_CLASS (desktop_agnostic_color_parent_class)->finalize (obj);
}


/**
   * Note: cannot use ushort in properties as Value cannot be mapped to it.
   */
GType desktop_agnostic_color_get_type (void) {
	static volatile gsize desktop_agnostic_color_type_id__volatile = 0;
	if (g_once_init_enter (&desktop_agnostic_color_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticColorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_color_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticColor), 0, (GInstanceInitFunc) desktop_agnostic_color_instance_init, NULL };
		GType desktop_agnostic_color_type_id;
		desktop_agnostic_color_type_id = g_type_register_static (G_TYPE_OBJECT, "DesktopAgnosticColor", &g_define_type_info, 0);
		g_once_init_leave (&desktop_agnostic_color_type_id__volatile, desktop_agnostic_color_type_id);
	}
	return desktop_agnostic_color_type_id__volatile;
}


static void _vala_desktop_agnostic_color_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DesktopAgnosticColor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_TYPE_COLOR, DesktopAgnosticColor);
	switch (property_id) {
		case DESKTOP_AGNOSTIC_COLOR_COLOR:
		{
			GdkColor boxed;
			desktop_agnostic_color_get_color (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case DESKTOP_AGNOSTIC_COLOR_RED:
		g_value_set_uint (value, desktop_agnostic_color_get_red (self));
		break;
		case DESKTOP_AGNOSTIC_COLOR_GREEN:
		g_value_set_uint (value, desktop_agnostic_color_get_green (self));
		break;
		case DESKTOP_AGNOSTIC_COLOR_BLUE:
		g_value_set_uint (value, desktop_agnostic_color_get_blue (self));
		break;
		case DESKTOP_AGNOSTIC_COLOR_ALPHA:
		g_value_set_uint (value, desktop_agnostic_color_get_alpha (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_desktop_agnostic_color_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DesktopAgnosticColor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_TYPE_COLOR, DesktopAgnosticColor);
	switch (property_id) {
		case DESKTOP_AGNOSTIC_COLOR_COLOR:
		desktop_agnostic_color_set_color (self, g_value_get_boxed (value));
		break;
		case DESKTOP_AGNOSTIC_COLOR_RED:
		desktop_agnostic_color_set_red (self, g_value_get_uint (value));
		break;
		case DESKTOP_AGNOSTIC_COLOR_GREEN:
		desktop_agnostic_color_set_green (self, g_value_get_uint (value));
		break;
		case DESKTOP_AGNOSTIC_COLOR_BLUE:
		desktop_agnostic_color_set_blue (self, g_value_get_uint (value));
		break;
		case DESKTOP_AGNOSTIC_COLOR_ALPHA:
		desktop_agnostic_color_set_alpha (self, g_value_get_uint (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



