/* config-impl-keyfile.c generated by valac 0.20.1, the Vala compiler
 * generated from config-impl-keyfile.vala, do not modify */

/*
 * A GKeyFile-based implementation of the Config interface.
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <libdesktop-agnostic/config.h>
#include <libdesktop-agnostic/vfs.h>
#include <stdlib.h>
#include <string.h>
#include <config-notify-delegate.c>
#include <float.h>
#include <math.h>
#include <glib/gstdio.h>


#define DESKTOP_AGNOSTIC_CONFIG_TYPE_GKEY_FILE (desktop_agnostic_config_gkey_file_get_type ())
#define DESKTOP_AGNOSTIC_CONFIG_GKEY_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_GKEY_FILE, DesktopAgnosticConfigGKeyFile))
#define DESKTOP_AGNOSTIC_CONFIG_GKEY_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_AGNOSTIC_CONFIG_TYPE_GKEY_FILE, DesktopAgnosticConfigGKeyFileClass))
#define DESKTOP_AGNOSTIC_CONFIG_IS_GKEY_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_GKEY_FILE))
#define DESKTOP_AGNOSTIC_CONFIG_IS_GKEY_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_AGNOSTIC_CONFIG_TYPE_GKEY_FILE))
#define DESKTOP_AGNOSTIC_CONFIG_GKEY_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_GKEY_FILE, DesktopAgnosticConfigGKeyFileClass))

typedef struct _DesktopAgnosticConfigGKeyFile DesktopAgnosticConfigGKeyFile;
typedef struct _DesktopAgnosticConfigGKeyFileClass DesktopAgnosticConfigGKeyFileClass;
typedef struct _DesktopAgnosticConfigGKeyFilePrivate DesktopAgnosticConfigGKeyFilePrivate;
#define _g_key_file_free0(var) ((var == NULL) ? NULL : (var = (g_key_file_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_value_array_free0(var) ((var == NULL) ? NULL : (var = (g_value_array_free (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _desktop_agnostic_config_notify_delegate_free0(var) ((var == NULL) ? NULL : (var = (desktop_agnostic_config_notify_delegate_free (var), NULL)))

struct _DesktopAgnosticConfigGKeyFile {
	DesktopAgnosticConfigBackend parent_instance;
	DesktopAgnosticConfigGKeyFilePrivate * priv;
};

struct _DesktopAgnosticConfigGKeyFileClass {
	DesktopAgnosticConfigBackendClass parent_class;
};

struct _DesktopAgnosticConfigGKeyFilePrivate {
	GKeyFile* _data;
	DesktopAgnosticVFSFile* _keyfile;
	DesktopAgnosticVFSFileMonitor* _keyfile_monitor;
	gulong _monitor_changed_id;
	gchar* _checksum;
	gboolean _autosave;
	GData* _notifiers;
};


static gpointer desktop_agnostic_config_gkey_file_parent_class = NULL;

GType desktop_agnostic_config_gkey_file_get_type (void) G_GNUC_CONST;
#define DESKTOP_AGNOSTIC_CONFIG_GKEY_FILE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DESKTOP_AGNOSTIC_CONFIG_TYPE_GKEY_FILE, DesktopAgnosticConfigGKeyFilePrivate))
enum  {
	DESKTOP_AGNOSTIC_CONFIG_GKEY_FILE_DUMMY_PROPERTY,
	DESKTOP_AGNOSTIC_CONFIG_GKEY_FILE_NAME
};
static void desktop_agnostic_config_gkey_file_save_config (DesktopAgnosticConfigGKeyFile* self, GError** error);
static void desktop_agnostic_config_gkey_file_update_config (DesktopAgnosticConfigGKeyFile* self, const gchar* group, const gchar* key, GError** error);
static void desktop_agnostic_config_gkey_file_get_data_from_file (DesktopAgnosticConfigGKeyFile* self, DesktopAgnosticVFSFile* file, gchar** contents, gsize* length, gchar** checksum, GError** error);
static void desktop_agnostic_config_gkey_file_load_data (DesktopAgnosticConfigGKeyFile* self, DesktopAgnosticVFSFile* file, GError** error);
static void desktop_agnostic_config_gkey_file_set_value_from_keyfile (DesktopAgnosticConfigGKeyFile* self, GKeyFile* keyfile, const gchar* group, const gchar* key, GError** error);
static GValueArray* desktop_agnostic_config_gkey_file_generate_valuearray_from_keyfile (DesktopAgnosticConfigGKeyFile* self, GKeyFile* keyfile, const gchar* group, const gchar* key, GError** error);
static void desktop_agnostic_config_gkey_file_on_keyfile_changed (DesktopAgnosticConfigGKeyFile* self, DesktopAgnosticVFSFile* file, DesktopAgnosticVFSFile* other, DesktopAgnosticVFSFileMonitorEvent event, DesktopAgnosticVFSFileMonitor* monitor);
static void desktop_agnostic_config_gkey_file_ensure_directory (DesktopAgnosticConfigGKeyFile* self, const gchar* path);
static gboolean desktop_agnostic_config_gkey_file_create_file_monitor (DesktopAgnosticConfigGKeyFile* self);
static void desktop_agnostic_config_gkey_file_real_constructed (GObject* base);
static gboolean _desktop_agnostic_config_gkey_file_create_file_monitor_gsource_func (gpointer self);
static void desktop_agnostic_config_gkey_file_real_reset (DesktopAgnosticConfigBackend* base, GError** error);
static void desktop_agnostic_config_gkey_file_real_notify_add (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, DesktopAgnosticConfigNotifyFunc callback, void* callback_target, GError** error);
static void desktop_agnostic_config_gkey_file_real_notify (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, GError** error);
static void desktop_agnostic_config_gkey_file_real_notify_remove (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, DesktopAgnosticConfigNotifyFunc callback, void* callback_target, GError** error);
static void desktop_agnostic_config_gkey_file_real_remove (DesktopAgnosticConfigBackend* base, GError** error);
static void desktop_agnostic_config_gkey_file_real_get_value (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, GValue* result, GError** error);
static gboolean desktop_agnostic_config_gkey_file_real_get_bool (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, GError** error);
static void desktop_agnostic_config_gkey_file_real_set_bool (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, gboolean value, GError** error);
static gfloat desktop_agnostic_config_gkey_file_real_get_float (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, GError** error);
static void desktop_agnostic_config_gkey_file_real_set_float (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, gfloat value, GError** error);
static gint desktop_agnostic_config_gkey_file_real_get_int (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, GError** error);
static void desktop_agnostic_config_gkey_file_real_set_int (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, gint value, GError** error);
static gchar* desktop_agnostic_config_gkey_file_real_get_string (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, GError** error);
static void desktop_agnostic_config_gkey_file_real_set_string (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, const gchar* value, GError** error);
static GValueArray* desktop_agnostic_config_gkey_file_real_get_list (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, GError** error);
static void desktop_agnostic_config_gkey_file_real_set_list (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, GValueArray* value, GError** error);
static void _vala_array_add1 (gboolean** array, int* length, int* size, gboolean value);
static void _vala_array_add2 (gint** array, int* length, int* size, gint value);
static void _vala_array_add3 (gdouble** array, int* length, int* size, gdouble value);
static void _vala_array_add4 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add5 (gchar*** array, int* length, int* size, gchar* value);
DesktopAgnosticConfigGKeyFile* desktop_agnostic_config_gkey_file_new (void);
DesktopAgnosticConfigGKeyFile* desktop_agnostic_config_gkey_file_construct (GType object_type);
static GObject * desktop_agnostic_config_gkey_file_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void desktop_agnostic_config_gkey_file_finalize (GObject* obj);
static void _vala_desktop_agnostic_config_gkey_file_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
GType register_plugin (void);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


/**
     * Saves the current state of the configuration to the filesystem,
     * suppressing the "changed" signal from the file monitor.
     */
static void desktop_agnostic_config_gkey_file_save_config (DesktopAgnosticConfigGKeyFile* self, GError** error) {
	gchar* data = NULL;
	gsize length = 0UL;
	GKeyFile* _tmp0_;
	gsize _tmp1_ = 0UL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	gsize _tmp4_;
	gchar* _tmp5_ = NULL;
	gulong _tmp6_;
	DesktopAgnosticVFSFile* _tmp9_;
	const gchar* _tmp10_;
	gulong _tmp11_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_data;
	_tmp2_ = g_key_file_to_data (_tmp0_, &_tmp1_, NULL);
	length = _tmp1_;
	_g_free0 (data);
	data = _tmp2_;
	_tmp3_ = data;
	_tmp4_ = length;
	_tmp5_ = g_compute_checksum_for_string (G_CHECKSUM_SHA256, _tmp3_, _tmp4_);
	_g_free0 (self->priv->_checksum);
	self->priv->_checksum = _tmp5_;
	_tmp6_ = self->priv->_monitor_changed_id;
	if (_tmp6_ != ((gulong) 0)) {
		DesktopAgnosticVFSFileMonitor* _tmp7_;
		gulong _tmp8_;
		_tmp7_ = self->priv->_keyfile_monitor;
		_tmp8_ = self->priv->_monitor_changed_id;
		g_signal_handler_block (_tmp7_, _tmp8_);
	}
	_tmp9_ = self->priv->_keyfile;
	_tmp10_ = data;
	desktop_agnostic_vfs_file_replace_contents (_tmp9_, _tmp10_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (data);
		return;
	}
	_tmp11_ = self->priv->_monitor_changed_id;
	if (_tmp11_ != ((gulong) 0)) {
		DesktopAgnosticVFSFileMonitor* _tmp12_;
		gulong _tmp13_;
		_tmp12_ = self->priv->_keyfile_monitor;
		_tmp13_ = self->priv->_monitor_changed_id;
		g_signal_handler_unblock (_tmp12_, _tmp13_);
	}
	_g_free0 (data);
}


/**
     * Saves the current configuration state to the filesystem (if autosave is
     * on) and emits the notify signal.
     */
static void desktop_agnostic_config_gkey_file_update_config (DesktopAgnosticConfigGKeyFile* self, const gchar* group, const gchar* key, GError** error) {
	gboolean _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (group != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = self->priv->_autosave;
	if (_tmp0_) {
		desktop_agnostic_config_gkey_file_save_config (self, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return;
		}
	}
	_tmp1_ = group;
	_tmp2_ = key;
	desktop_agnostic_config_backend_notify ((DesktopAgnosticConfigBackend*) self, _tmp1_, _tmp2_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


static void desktop_agnostic_config_gkey_file_get_data_from_file (DesktopAgnosticConfigGKeyFile* self, DesktopAgnosticVFSFile* file, gchar** contents, gsize* length, gchar** checksum, GError** error) {
	gchar* _vala_contents = NULL;
	gsize _vala_length = 0UL;
	gchar* _vala_checksum = NULL;
	DesktopAgnosticVFSFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gsize _tmp2_ = 0UL;
	gchar* _tmp3_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = file;
	desktop_agnostic_vfs_file_load_contents (_tmp0_, &_tmp1_, &_tmp2_, &_inner_error_);
	_g_free0 (_vala_contents);
	_vala_contents = _tmp1_;
	_vala_length = _tmp2_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp3_ = g_compute_checksum_for_string (G_CHECKSUM_SHA256, _vala_contents, _vala_length);
	_g_free0 (_vala_checksum);
	_vala_checksum = _tmp3_;
	if (contents) {
		*contents = _vala_contents;
	} else {
		_g_free0 (_vala_contents);
	}
	if (length) {
		*length = _vala_length;
	}
	if (checksum) {
		*checksum = _vala_checksum;
	} else {
		_g_free0 (_vala_checksum);
	}
}


static void desktop_agnostic_config_gkey_file_load_data (DesktopAgnosticConfigGKeyFile* self, DesktopAgnosticVFSFile* file, GError** error) {
	gchar* data = NULL;
	gsize length = 0UL;
	DesktopAgnosticVFSFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gsize _tmp2_ = 0UL;
	gchar* _tmp3_ = NULL;
	GKeyFile* _tmp4_;
	const gchar* _tmp5_;
	gsize _tmp6_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = file;
	desktop_agnostic_config_gkey_file_get_data_from_file (self, _tmp0_, &_tmp1_, &_tmp2_, &_tmp3_, &_inner_error_);
	_g_free0 (data);
	data = _tmp1_;
	length = _tmp2_;
	_g_free0 (self->priv->_checksum);
	self->priv->_checksum = _tmp3_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (data);
		return;
	}
	_tmp4_ = self->priv->_data;
	_tmp5_ = data;
	_tmp6_ = length;
	g_key_file_load_from_data (_tmp4_, _tmp5_, (gsize) ((gulong) _tmp6_), G_KEY_FILE_NONE, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (data);
		return;
	}
	_g_free0 (data);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void desktop_agnostic_config_gkey_file_set_value_from_keyfile (DesktopAgnosticConfigGKeyFile* self, GKeyFile* keyfile, const gchar* group, const gchar* key, GError** error) {
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	DesktopAgnosticConfigSchemaOption* _tmp4_ = NULL;
	DesktopAgnosticConfigSchemaOption* _tmp5_;
	DesktopAgnosticConfigSchemaOption* option;
	DesktopAgnosticConfigSchemaOption* _tmp6_;
	GType _tmp7_;
	GType _tmp8_;
	GType type;
	GType _tmp9_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (keyfile != NULL);
	g_return_if_fail (group != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = group;
	_tmp3_ = key;
	_tmp4_ = desktop_agnostic_config_schema_get_option (_tmp1_, _tmp2_, _tmp3_);
	_tmp5_ = _g_object_ref0 (_tmp4_);
	option = _tmp5_;
	_tmp6_ = option;
	_tmp7_ = desktop_agnostic_config_schema_option_get_option_type (_tmp6_);
	_tmp8_ = _tmp7_;
	type = _tmp8_;
	_tmp9_ = type;
	if (_tmp9_ == G_TYPE_BOOLEAN) {
		GKeyFile* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		_tmp10_ = keyfile;
		_tmp11_ = group;
		_tmp12_ = key;
		_tmp13_ = g_key_file_get_boolean (_tmp10_, _tmp11_, _tmp12_, &_inner_error_);
		_tmp14_ = _tmp13_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (option);
			return;
		}
		_tmp15_ = group;
		_tmp16_ = key;
		desktop_agnostic_config_backend_set_bool ((DesktopAgnosticConfigBackend*) self, _tmp15_, _tmp16_, _tmp14_, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (option);
			return;
		}
	} else {
		GType _tmp17_;
		_tmp17_ = type;
		if (_tmp17_ == G_TYPE_INT) {
			GKeyFile* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			gint _tmp21_ = 0;
			gint _tmp22_;
			const gchar* _tmp23_;
			const gchar* _tmp24_;
			_tmp18_ = keyfile;
			_tmp19_ = group;
			_tmp20_ = key;
			_tmp21_ = g_key_file_get_integer (_tmp18_, _tmp19_, _tmp20_, &_inner_error_);
			_tmp22_ = _tmp21_;
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (option);
				return;
			}
			_tmp23_ = group;
			_tmp24_ = key;
			desktop_agnostic_config_backend_set_int ((DesktopAgnosticConfigBackend*) self, _tmp23_, _tmp24_, _tmp22_, &_inner_error_);
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (option);
				return;
			}
		} else {
			GType _tmp25_;
			_tmp25_ = type;
			if (_tmp25_ == G_TYPE_FLOAT) {
				GKeyFile* _tmp26_;
				const gchar* _tmp27_;
				const gchar* _tmp28_;
				gdouble _tmp29_ = 0.0;
				gdouble _tmp30_;
				const gchar* _tmp31_;
				const gchar* _tmp32_;
				_tmp26_ = keyfile;
				_tmp27_ = group;
				_tmp28_ = key;
				_tmp29_ = g_key_file_get_double (_tmp26_, _tmp27_, _tmp28_, &_inner_error_);
				_tmp30_ = _tmp29_;
				if (_inner_error_ != NULL) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (option);
					return;
				}
				_tmp31_ = group;
				_tmp32_ = key;
				desktop_agnostic_config_backend_set_float ((DesktopAgnosticConfigBackend*) self, _tmp31_, _tmp32_, (gfloat) _tmp30_, &_inner_error_);
				if (_inner_error_ != NULL) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (option);
					return;
				}
			} else {
				GType _tmp33_;
				_tmp33_ = type;
				if (_tmp33_ == G_TYPE_STRING) {
					GKeyFile* _tmp34_;
					const gchar* _tmp35_;
					const gchar* _tmp36_;
					gchar* _tmp37_ = NULL;
					gchar* _tmp38_;
					const gchar* _tmp39_;
					const gchar* _tmp40_;
					gchar* _tmp41_;
					_tmp34_ = keyfile;
					_tmp35_ = group;
					_tmp36_ = key;
					_tmp37_ = g_key_file_get_string (_tmp34_, _tmp35_, _tmp36_, &_inner_error_);
					_tmp38_ = _tmp37_;
					if (_inner_error_ != NULL) {
						g_propagate_error (error, _inner_error_);
						_g_object_unref0 (option);
						return;
					}
					_tmp39_ = group;
					_tmp40_ = key;
					_tmp41_ = _tmp38_;
					desktop_agnostic_config_backend_set_string ((DesktopAgnosticConfigBackend*) self, _tmp39_, _tmp40_, _tmp41_, &_inner_error_);
					_g_free0 (_tmp41_);
					if (_inner_error_ != NULL) {
						g_propagate_error (error, _inner_error_);
						_g_object_unref0 (option);
						return;
					}
				} else {
					GType _tmp42_;
					_tmp42_ = type;
					if (_tmp42_ == G_TYPE_VALUE_ARRAY) {
						GValueArray* arr = NULL;
						GKeyFile* _tmp43_;
						const gchar* _tmp44_;
						const gchar* _tmp45_;
						GValueArray* _tmp46_ = NULL;
						GValueArray* _tmp47_;
						const gchar* _tmp48_;
						const gchar* _tmp49_;
						GValueArray* _tmp50_;
						_tmp43_ = keyfile;
						_tmp44_ = group;
						_tmp45_ = key;
						_tmp46_ = desktop_agnostic_config_gkey_file_generate_valuearray_from_keyfile (self, _tmp43_, _tmp44_, _tmp45_, &_inner_error_);
						_tmp47_ = _tmp46_;
						if (_inner_error_ != NULL) {
							g_propagate_error (error, _inner_error_);
							_g_value_array_free0 (arr);
							_g_object_unref0 (option);
							return;
						}
						_g_value_array_free0 (arr);
						arr = _tmp47_;
						_tmp48_ = group;
						_tmp49_ = key;
						_tmp50_ = arr;
						desktop_agnostic_config_backend_set_list ((DesktopAgnosticConfigBackend*) self, _tmp48_, _tmp49_, _tmp50_, &_inner_error_);
						if (_inner_error_ != NULL) {
							g_propagate_error (error, _inner_error_);
							_g_value_array_free0 (arr);
							_g_object_unref0 (option);
							return;
						}
						_g_value_array_free0 (arr);
					} else {
						GType _tmp51_;
						DesktopAgnosticConfigSchemaType* _tmp52_ = NULL;
						DesktopAgnosticConfigSchemaType* _tmp53_;
						DesktopAgnosticConfigSchemaType* st;
						DesktopAgnosticConfigSchemaType* _tmp54_;
						GValue val = {0};
						GKeyFile* _tmp58_;
						const gchar* _tmp59_;
						const gchar* _tmp60_;
						gchar* _tmp61_ = NULL;
						gchar* _tmp62_;
						DesktopAgnosticConfigSchemaType* _tmp63_;
						gchar* _tmp64_;
						GValue _tmp65_ = {0};
						GValue _tmp66_;
						GValue _tmp67_;
						const gchar* _tmp68_;
						const gchar* _tmp69_;
						GValue _tmp70_;
						_tmp51_ = type;
						_tmp52_ = desktop_agnostic_config_schema_find_type (_tmp51_);
						_tmp53_ = _g_object_ref0 (_tmp52_);
						st = _tmp53_;
						_tmp54_ = st;
						if (_tmp54_ == NULL) {
							GType _tmp55_;
							const gchar* _tmp56_ = NULL;
							GError* _tmp57_;
							_tmp55_ = type;
							_tmp56_ = g_type_name (_tmp55_);
							_tmp57_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_INVALID_TYPE, "'%s' is an invalid config type.", _tmp56_);
							_inner_error_ = _tmp57_;
							g_propagate_error (error, _inner_error_);
							_g_object_unref0 (st);
							_g_object_unref0 (option);
							return;
						}
						_tmp58_ = keyfile;
						_tmp59_ = group;
						_tmp60_ = key;
						_tmp61_ = g_key_file_get_string (_tmp58_, _tmp59_, _tmp60_, &_inner_error_);
						_tmp62_ = _tmp61_;
						if (_inner_error_ != NULL) {
							g_propagate_error (error, _inner_error_);
							G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
							_g_object_unref0 (st);
							_g_object_unref0 (option);
							return;
						}
						_tmp63_ = st;
						_tmp64_ = _tmp62_;
						desktop_agnostic_config_schema_type_deserialize (_tmp63_, _tmp64_, &_tmp65_, &_inner_error_);
						_tmp66_ = _tmp65_;
						_g_free0 (_tmp64_);
						_tmp67_ = _tmp66_;
						if (_inner_error_ != NULL) {
							g_propagate_error (error, _inner_error_);
							G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
							_g_object_unref0 (st);
							_g_object_unref0 (option);
							return;
						}
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
						val = _tmp67_;
						_tmp68_ = group;
						_tmp69_ = key;
						_tmp70_ = val;
						desktop_agnostic_config_backend_set_value ((DesktopAgnosticConfigBackend*) self, _tmp68_, _tmp69_, &_tmp70_, &_inner_error_);
						if (_inner_error_ != NULL) {
							g_propagate_error (error, _inner_error_);
							G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
							_g_object_unref0 (st);
							_g_object_unref0 (option);
							return;
						}
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
						_g_object_unref0 (st);
					}
				}
			}
		}
	}
	_g_object_unref0 (option);
}


static GValueArray* desktop_agnostic_config_gkey_file_generate_valuearray_from_keyfile (DesktopAgnosticConfigGKeyFile* self, GKeyFile* keyfile, const gchar* group, const gchar* key, GError** error) {
	GValueArray* result = NULL;
	DesktopAgnosticConfigSchemaOption* option = NULL;
	GType list_type = 0UL;
	GValueArray* arr = NULL;
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	DesktopAgnosticConfigSchemaOption* _tmp4_ = NULL;
	DesktopAgnosticConfigSchemaOption* _tmp5_;
	DesktopAgnosticConfigSchemaOption* _tmp6_;
	DesktopAgnosticConfigSchemaOption* _tmp16_;
	GType _tmp17_;
	GType _tmp18_;
	GType _tmp19_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (keyfile != NULL, NULL);
	g_return_val_if_fail (group != NULL, NULL);
	g_return_val_if_fail (key != NULL, NULL);
	_tmp0_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = group;
	_tmp3_ = key;
	_tmp4_ = desktop_agnostic_config_schema_get_option (_tmp1_, _tmp2_, _tmp3_);
	_tmp5_ = _g_object_ref0 (_tmp4_);
	_g_object_unref0 (option);
	option = _tmp5_;
	_tmp6_ = option;
	if (_tmp6_ == NULL) {
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		GError* _tmp9_;
		_tmp7_ = group;
		_tmp8_ = key;
		_tmp9_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, "The key %s/%s is invalid.", _tmp7_, _tmp8_);
		_inner_error_ = _tmp9_;
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (arr);
		_g_object_unref0 (option);
		return NULL;
	} else {
		GKeyFile* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_;
		_tmp10_ = keyfile;
		_tmp11_ = group;
		_tmp12_ = key;
		_tmp13_ = g_key_file_has_key (_tmp10_, _tmp11_, _tmp12_, &_inner_error_);
		_tmp14_ = _tmp13_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_value_array_free0 (arr);
			_g_object_unref0 (option);
			return NULL;
		}
		if (!_tmp14_) {
			GValueArray* _tmp15_;
			_tmp15_ = g_value_array_new ((guint) 0);
			result = _tmp15_;
			_g_value_array_free0 (arr);
			_g_object_unref0 (option);
			return result;
		}
	}
	_tmp16_ = option;
	_tmp17_ = desktop_agnostic_config_schema_option_get_list_type (_tmp16_);
	_tmp18_ = _tmp17_;
	list_type = _tmp18_;
	_tmp19_ = list_type;
	if (_tmp19_ == G_TYPE_BOOLEAN) {
		gboolean* list_data = NULL;
		gint list_data_length1 = 0;
		gint _list_data_size_ = 0;
		GValue val = {0};
		GKeyFile* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		gsize _tmp23_;
		gboolean* _tmp24_ = NULL;
		gboolean* _tmp25_;
		gint _tmp25__length1;
		gint __tmp25__size_;
		gboolean* _tmp26_;
		gint _tmp26__length1;
		GValueArray* _tmp27_;
		gboolean* _tmp28_;
		gint _tmp28__length1;
		_tmp20_ = keyfile;
		_tmp21_ = group;
		_tmp22_ = key;
		_tmp24_ = g_key_file_get_boolean_list (_tmp20_, _tmp21_, _tmp22_, &_tmp23_, &_inner_error_);
		_tmp25_ = _tmp24_;
		_tmp25__length1 = _tmp23_;
		__tmp25__size_ = _tmp25__length1;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
			list_data = (g_free (list_data), NULL);
			_g_value_array_free0 (arr);
			_g_object_unref0 (option);
			return NULL;
		}
		list_data = (g_free (list_data), NULL);
		list_data = _tmp25_;
		list_data_length1 = _tmp25__length1;
		_list_data_size_ = list_data_length1;
		_tmp26_ = list_data;
		_tmp26__length1 = list_data_length1;
		_tmp27_ = g_value_array_new ((guint) _tmp26__length1);
		_g_value_array_free0 (arr);
		arr = _tmp27_;
		_tmp28_ = list_data;
		_tmp28__length1 = list_data_length1;
		{
			gboolean* item_collection = NULL;
			gint item_collection_length1 = 0;
			gint _item_collection_size_ = 0;
			gint item_it = 0;
			item_collection = _tmp28_;
			item_collection_length1 = _tmp28__length1;
			for (item_it = 0; item_it < _tmp28__length1; item_it = item_it + 1) {
				gboolean item = FALSE;
				item = item_collection[item_it];
				{
					gboolean _tmp29_;
					GValue _tmp30_ = {0};
					GValueArray* _tmp31_;
					GValue _tmp32_;
					_tmp29_ = item;
					g_value_init (&_tmp30_, G_TYPE_BOOLEAN);
					g_value_set_boolean (&_tmp30_, _tmp29_);
					G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
					val = _tmp30_;
					_tmp31_ = arr;
					_tmp32_ = val;
					g_value_array_append (_tmp31_, &_tmp32_);
				}
			}
		}
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
		list_data = (g_free (list_data), NULL);
	} else {
		GType _tmp33_;
		_tmp33_ = list_type;
		if (_tmp33_ == G_TYPE_INT) {
			gint* list_data = NULL;
			gint list_data_length1 = 0;
			gint _list_data_size_ = 0;
			GValue val = {0};
			GKeyFile* _tmp34_;
			const gchar* _tmp35_;
			const gchar* _tmp36_;
			gsize _tmp37_;
			gint* _tmp38_ = NULL;
			gint* _tmp39_;
			gint _tmp39__length1;
			gint __tmp39__size_;
			gint* _tmp40_;
			gint _tmp40__length1;
			GValueArray* _tmp41_;
			gint* _tmp42_;
			gint _tmp42__length1;
			_tmp34_ = keyfile;
			_tmp35_ = group;
			_tmp36_ = key;
			_tmp38_ = g_key_file_get_integer_list (_tmp34_, _tmp35_, _tmp36_, &_tmp37_, &_inner_error_);
			_tmp39_ = _tmp38_;
			_tmp39__length1 = _tmp37_;
			__tmp39__size_ = _tmp39__length1;
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
				list_data = (g_free (list_data), NULL);
				_g_value_array_free0 (arr);
				_g_object_unref0 (option);
				return NULL;
			}
			list_data = (g_free (list_data), NULL);
			list_data = _tmp39_;
			list_data_length1 = _tmp39__length1;
			_list_data_size_ = list_data_length1;
			_tmp40_ = list_data;
			_tmp40__length1 = list_data_length1;
			_tmp41_ = g_value_array_new ((guint) _tmp40__length1);
			_g_value_array_free0 (arr);
			arr = _tmp41_;
			_tmp42_ = list_data;
			_tmp42__length1 = list_data_length1;
			{
				gint* item_collection = NULL;
				gint item_collection_length1 = 0;
				gint _item_collection_size_ = 0;
				gint item_it = 0;
				item_collection = _tmp42_;
				item_collection_length1 = _tmp42__length1;
				for (item_it = 0; item_it < _tmp42__length1; item_it = item_it + 1) {
					gint item = 0;
					item = item_collection[item_it];
					{
						gint _tmp43_;
						GValue _tmp44_ = {0};
						GValueArray* _tmp45_;
						GValue _tmp46_;
						_tmp43_ = item;
						g_value_init (&_tmp44_, G_TYPE_INT);
						g_value_set_int (&_tmp44_, _tmp43_);
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
						val = _tmp44_;
						_tmp45_ = arr;
						_tmp46_ = val;
						g_value_array_append (_tmp45_, &_tmp46_);
					}
				}
			}
			G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
			list_data = (g_free (list_data), NULL);
		} else {
			GType _tmp47_;
			_tmp47_ = list_type;
			if (_tmp47_ == G_TYPE_FLOAT) {
				gdouble* list_data = NULL;
				gint list_data_length1 = 0;
				gint _list_data_size_ = 0;
				GValue val = {0};
				GKeyFile* _tmp48_;
				const gchar* _tmp49_;
				const gchar* _tmp50_;
				gsize _tmp51_;
				gdouble* _tmp52_ = NULL;
				gdouble* _tmp53_;
				gint _tmp53__length1;
				gint __tmp53__size_;
				gdouble* _tmp54_;
				gint _tmp54__length1;
				GValueArray* _tmp55_;
				gdouble* _tmp56_;
				gint _tmp56__length1;
				_tmp48_ = keyfile;
				_tmp49_ = group;
				_tmp50_ = key;
				_tmp52_ = g_key_file_get_double_list (_tmp48_, _tmp49_, _tmp50_, &_tmp51_, &_inner_error_);
				_tmp53_ = _tmp52_;
				_tmp53__length1 = _tmp51_;
				__tmp53__size_ = _tmp53__length1;
				if (_inner_error_ != NULL) {
					g_propagate_error (error, _inner_error_);
					G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
					list_data = (g_free (list_data), NULL);
					_g_value_array_free0 (arr);
					_g_object_unref0 (option);
					return NULL;
				}
				list_data = (g_free (list_data), NULL);
				list_data = (gdouble*) _tmp53_;
				list_data_length1 = (_tmp53__length1 * sizeof (gdouble)) / sizeof (gdouble);
				_list_data_size_ = list_data_length1;
				_tmp54_ = list_data;
				_tmp54__length1 = list_data_length1;
				_tmp55_ = g_value_array_new ((guint) _tmp54__length1);
				_g_value_array_free0 (arr);
				arr = _tmp55_;
				_tmp56_ = list_data;
				_tmp56__length1 = list_data_length1;
				{
					gdouble* item_collection = NULL;
					gint item_collection_length1 = 0;
					gint _item_collection_size_ = 0;
					gint item_it = 0;
					item_collection = _tmp56_;
					item_collection_length1 = _tmp56__length1;
					for (item_it = 0; item_it < _tmp56__length1; item_it = item_it + 1) {
						gdouble item = 0.0;
						item = item_collection[item_it];
						{
							gdouble _tmp57_;
							GValue _tmp58_ = {0};
							GValueArray* _tmp59_;
							GValue _tmp60_;
							_tmp57_ = item;
							g_value_init (&_tmp58_, G_TYPE_FLOAT);
							g_value_set_float (&_tmp58_, (gfloat) _tmp57_);
							G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
							val = _tmp58_;
							_tmp59_ = arr;
							_tmp60_ = val;
							g_value_array_append (_tmp59_, &_tmp60_);
						}
					}
				}
				G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
				list_data = (g_free (list_data), NULL);
			} else {
				GType _tmp61_;
				_tmp61_ = list_type;
				if (_tmp61_ == G_TYPE_STRING) {
					gchar** list_data = NULL;
					gint list_data_length1 = 0;
					gint _list_data_size_ = 0;
					GValue val = {0};
					GKeyFile* _tmp62_;
					const gchar* _tmp63_;
					const gchar* _tmp64_;
					gsize _tmp65_;
					gchar** _tmp66_ = NULL;
					gchar** _tmp67_;
					gint _tmp67__length1;
					gint __tmp67__size_;
					gchar** _tmp68_;
					gint _tmp68__length1;
					GValueArray* _tmp69_;
					gchar** _tmp70_;
					gint _tmp70__length1;
					_tmp62_ = keyfile;
					_tmp63_ = group;
					_tmp64_ = key;
					_tmp66_ = g_key_file_get_string_list (_tmp62_, _tmp63_, _tmp64_, &_tmp65_, &_inner_error_);
					_tmp67_ = _tmp66_;
					_tmp67__length1 = _tmp65_;
					__tmp67__size_ = _tmp67__length1;
					if (_inner_error_ != NULL) {
						g_propagate_error (error, _inner_error_);
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
						list_data = (_vala_array_free (list_data, list_data_length1, (GDestroyNotify) g_free), NULL);
						_g_value_array_free0 (arr);
						_g_object_unref0 (option);
						return NULL;
					}
					list_data = (_vala_array_free (list_data, list_data_length1, (GDestroyNotify) g_free), NULL);
					list_data = _tmp67_;
					list_data_length1 = _tmp67__length1;
					_list_data_size_ = list_data_length1;
					_tmp68_ = list_data;
					_tmp68__length1 = list_data_length1;
					_tmp69_ = g_value_array_new ((guint) _tmp68__length1);
					_g_value_array_free0 (arr);
					arr = _tmp69_;
					_tmp70_ = list_data;
					_tmp70__length1 = list_data_length1;
					{
						gchar** item_collection = NULL;
						gint item_collection_length1 = 0;
						gint _item_collection_size_ = 0;
						gint item_it = 0;
						item_collection = _tmp70_;
						item_collection_length1 = _tmp70__length1;
						for (item_it = 0; item_it < _tmp70__length1; item_it = item_it + 1) {
							gchar* _tmp71_;
							gchar* item = NULL;
							_tmp71_ = g_strdup (item_collection[item_it]);
							item = _tmp71_;
							{
								const gchar* _tmp72_;
								GValue _tmp73_ = {0};
								GValueArray* _tmp74_;
								GValue _tmp75_;
								_tmp72_ = item;
								g_value_init (&_tmp73_, G_TYPE_STRING);
								g_value_set_string (&_tmp73_, _tmp72_);
								G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
								val = _tmp73_;
								_tmp74_ = arr;
								_tmp75_ = val;
								g_value_array_append (_tmp74_, &_tmp75_);
								_g_free0 (item);
							}
						}
					}
					G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
					list_data = (_vala_array_free (list_data, list_data_length1, (GDestroyNotify) g_free), NULL);
				} else {
					GType _tmp76_;
					DesktopAgnosticConfigSchemaType* _tmp77_ = NULL;
					DesktopAgnosticConfigSchemaType* _tmp78_;
					DesktopAgnosticConfigSchemaType* st;
					DesktopAgnosticConfigSchemaType* _tmp79_;
					gchar** list_data = NULL;
					gint list_data_length1 = 0;
					gint _list_data_size_ = 0;
					GKeyFile* _tmp83_;
					const gchar* _tmp84_;
					const gchar* _tmp85_;
					gsize _tmp86_;
					gchar** _tmp87_ = NULL;
					gchar** _tmp88_;
					gint _tmp88__length1;
					gint __tmp88__size_;
					gchar** _tmp89_;
					gint _tmp89__length1;
					GValueArray* _tmp90_;
					gchar** _tmp91_;
					gint _tmp91__length1;
					_tmp76_ = list_type;
					_tmp77_ = desktop_agnostic_config_schema_find_type (_tmp76_);
					_tmp78_ = _g_object_ref0 (_tmp77_);
					st = _tmp78_;
					_tmp79_ = st;
					if (_tmp79_ == NULL) {
						GType _tmp80_;
						const gchar* _tmp81_ = NULL;
						GError* _tmp82_;
						_tmp80_ = list_type;
						_tmp81_ = g_type_name (_tmp80_);
						_tmp82_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_INVALID_TYPE, "'%s' is an invalid config type.", _tmp81_);
						_inner_error_ = _tmp82_;
						g_propagate_error (error, _inner_error_);
						_g_object_unref0 (st);
						_g_value_array_free0 (arr);
						_g_object_unref0 (option);
						return NULL;
					}
					_tmp83_ = keyfile;
					_tmp84_ = group;
					_tmp85_ = key;
					_tmp87_ = g_key_file_get_string_list (_tmp83_, _tmp84_, _tmp85_, &_tmp86_, &_inner_error_);
					_tmp88_ = _tmp87_;
					_tmp88__length1 = _tmp86_;
					__tmp88__size_ = _tmp88__length1;
					if (_inner_error_ != NULL) {
						g_propagate_error (error, _inner_error_);
						list_data = (_vala_array_free (list_data, list_data_length1, (GDestroyNotify) g_free), NULL);
						_g_object_unref0 (st);
						_g_value_array_free0 (arr);
						_g_object_unref0 (option);
						return NULL;
					}
					list_data = (_vala_array_free (list_data, list_data_length1, (GDestroyNotify) g_free), NULL);
					list_data = _tmp88_;
					list_data_length1 = _tmp88__length1;
					_list_data_size_ = list_data_length1;
					_tmp89_ = list_data;
					_tmp89__length1 = list_data_length1;
					_tmp90_ = g_value_array_new ((guint) _tmp89__length1);
					_g_value_array_free0 (arr);
					arr = _tmp90_;
					_tmp91_ = list_data;
					_tmp91__length1 = list_data_length1;
					{
						gchar** item_collection = NULL;
						gint item_collection_length1 = 0;
						gint _item_collection_size_ = 0;
						gint item_it = 0;
						item_collection = _tmp91_;
						item_collection_length1 = _tmp91__length1;
						for (item_it = 0; item_it < _tmp91__length1; item_it = item_it + 1) {
							gchar* _tmp92_;
							gchar* item = NULL;
							_tmp92_ = g_strdup (item_collection[item_it]);
							item = _tmp92_;
							{
								DesktopAgnosticConfigSchemaType* _tmp93_;
								const gchar* _tmp94_;
								GValue _tmp95_ = {0};
								GValue _tmp96_;
								GValueArray* _tmp97_;
								GValue _tmp98_;
								_tmp93_ = st;
								_tmp94_ = item;
								desktop_agnostic_config_schema_type_deserialize (_tmp93_, _tmp94_, &_tmp95_, &_inner_error_);
								_tmp96_ = _tmp95_;
								if (_inner_error_ != NULL) {
									g_propagate_error (error, _inner_error_);
									_g_free0 (item);
									list_data = (_vala_array_free (list_data, list_data_length1, (GDestroyNotify) g_free), NULL);
									_g_object_unref0 (st);
									_g_value_array_free0 (arr);
									_g_object_unref0 (option);
									return NULL;
								}
								_tmp97_ = arr;
								_tmp98_ = _tmp96_;
								g_value_array_append (_tmp97_, &_tmp98_);
								G_IS_VALUE (&_tmp98_) ? (g_value_unset (&_tmp98_), NULL) : NULL;
								_g_free0 (item);
							}
						}
					}
					list_data = (_vala_array_free (list_data, list_data_length1, (GDestroyNotify) g_free), NULL);
					_g_object_unref0 (st);
				}
			}
		}
	}
	result = arr;
	_g_object_unref0 (option);
	return result;
}


static void desktop_agnostic_config_gkey_file_on_keyfile_changed (DesktopAgnosticConfigGKeyFile* self, DesktopAgnosticVFSFile* file, DesktopAgnosticVFSFile* other, DesktopAgnosticVFSFileMonitorEvent event, DesktopAgnosticVFSFileMonitor* monitor) {
	DesktopAgnosticVFSFileMonitorEvent _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	g_return_if_fail (monitor != NULL);
	_tmp0_ = event;
	switch (_tmp0_) {
		case DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_CREATED:
		{
			DesktopAgnosticVFSFile* _tmp1_;
			_tmp1_ = file;
			desktop_agnostic_config_gkey_file_load_data (self, _tmp1_, &_inner_error_);
			if (_inner_error_ != NULL) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			break;
		}
		case DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_CHANGED:
		{
			gchar* data = NULL;
			gsize length = 0UL;
			gchar* checksum = NULL;
			DesktopAgnosticVFSFile* _tmp2_;
			gchar* _tmp3_ = NULL;
			gsize _tmp4_ = 0UL;
			gchar* _tmp5_ = NULL;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			_tmp2_ = file;
			desktop_agnostic_config_gkey_file_get_data_from_file (self, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_inner_error_);
			_g_free0 (data);
			data = _tmp3_;
			length = _tmp4_;
			_g_free0 (checksum);
			checksum = _tmp5_;
			if (_inner_error_ != NULL) {
				_g_free0 (checksum);
				_g_free0 (data);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			_tmp6_ = self->priv->_checksum;
			_tmp7_ = checksum;
			if (g_strcmp0 (_tmp6_, _tmp7_) != 0) {
				DesktopAgnosticConfigSchema* _tmp8_;
				DesktopAgnosticConfigSchema* _tmp9_;
				DesktopAgnosticConfigSchema* schema;
				GKeyFile* _tmp10_;
				GKeyFile* new_data;
				GKeyFile* _tmp11_;
				const gchar* _tmp12_;
				gsize _tmp13_;
				DesktopAgnosticConfigSchema* _tmp14_;
				GList* _tmp15_ = NULL;
				_tmp8_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
				_tmp9_ = _tmp8_;
				schema = _tmp9_;
				_tmp10_ = g_key_file_new ();
				new_data = _tmp10_;
				_tmp11_ = new_data;
				_tmp12_ = data;
				_tmp13_ = length;
				g_key_file_load_from_data (_tmp11_, _tmp12_, _tmp13_, G_KEY_FILE_NONE, &_inner_error_);
				if (_inner_error_ != NULL) {
					_g_key_file_free0 (new_data);
					_g_free0 (checksum);
					_g_free0 (data);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
				self->priv->_autosave = FALSE;
				_tmp14_ = schema;
				_tmp15_ = desktop_agnostic_config_schema_get_groups (_tmp14_);
				{
					GList* group_collection = NULL;
					GList* group_it = NULL;
					group_collection = _tmp15_;
					for (group_it = group_collection; group_it != NULL; group_it = group_it->next) {
						const gchar* group = NULL;
						group = (const gchar*) group_it->data;
						{
							DesktopAgnosticConfigSchema* _tmp16_;
							const gchar* _tmp17_;
							GList* _tmp18_ = NULL;
							_tmp16_ = schema;
							_tmp17_ = group;
							_tmp18_ = desktop_agnostic_config_schema_get_keys (_tmp16_, _tmp17_);
							{
								GList* key_collection = NULL;
								GList* key_it = NULL;
								key_collection = _tmp18_;
								for (key_it = key_collection; key_it != NULL; key_it = key_it->next) {
									const gchar* key = NULL;
									key = (const gchar*) key_it->data;
									{
										GKeyFile* _tmp19_;
										const gchar* _tmp20_;
										gboolean _tmp21_ = FALSE;
										_tmp19_ = self->priv->_data;
										_tmp20_ = group;
										_tmp21_ = g_key_file_has_group (_tmp19_, _tmp20_);
										if (_tmp21_) {
											gboolean _tmp22_ = FALSE;
											gboolean _tmp23_ = FALSE;
											GKeyFile* _tmp24_;
											const gchar* _tmp25_;
											const gchar* _tmp26_;
											gboolean _tmp27_ = FALSE;
											gboolean _tmp28_;
											gboolean _tmp41_;
											gboolean _tmp48_;
											_tmp24_ = self->priv->_data;
											_tmp25_ = group;
											_tmp26_ = key;
											_tmp27_ = g_key_file_has_key (_tmp24_, _tmp25_, _tmp26_, &_inner_error_);
											_tmp28_ = _tmp27_;
											if (_inner_error_ != NULL) {
												_g_list_free0 (group_collection);
												_g_key_file_free0 (new_data);
												_g_free0 (checksum);
												_g_free0 (data);
												g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
												g_clear_error (&_inner_error_);
												return;
											}
											if (_tmp28_) {
												GKeyFile* _tmp29_;
												const gchar* _tmp30_;
												const gchar* _tmp31_;
												gchar* _tmp32_ = NULL;
												gchar* _tmp33_;
												GKeyFile* _tmp34_;
												const gchar* _tmp35_;
												const gchar* _tmp36_;
												gchar* _tmp37_ = NULL;
												gchar* _tmp38_;
												gchar* _tmp39_;
												gchar* _tmp40_;
												_tmp29_ = self->priv->_data;
												_tmp30_ = group;
												_tmp31_ = key;
												_tmp32_ = g_key_file_get_value (_tmp29_, _tmp30_, _tmp31_, &_inner_error_);
												_tmp33_ = _tmp32_;
												if (_inner_error_ != NULL) {
													_g_list_free0 (group_collection);
													_g_key_file_free0 (new_data);
													_g_free0 (checksum);
													_g_free0 (data);
													g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
													g_clear_error (&_inner_error_);
													return;
												}
												_tmp34_ = new_data;
												_tmp35_ = group;
												_tmp36_ = key;
												_tmp37_ = g_key_file_get_value (_tmp34_, _tmp35_, _tmp36_, &_inner_error_);
												_tmp38_ = _tmp37_;
												if (_inner_error_ != NULL) {
													_g_list_free0 (group_collection);
													_g_key_file_free0 (new_data);
													_g_free0 (checksum);
													_g_free0 (data);
													g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
													g_clear_error (&_inner_error_);
													return;
												}
												_tmp39_ = _tmp33_;
												_tmp40_ = _tmp38_;
												_tmp23_ = g_strcmp0 (_tmp39_, _tmp40_) != 0;
												_g_free0 (_tmp40_);
												_g_free0 (_tmp39_);
											} else {
												_tmp23_ = FALSE;
											}
											_tmp41_ = _tmp23_;
											if (_tmp41_) {
												_tmp22_ = TRUE;
											} else {
												DesktopAgnosticConfigSchema* _tmp42_;
												const gchar* _tmp43_;
												const gchar* _tmp44_;
												DesktopAgnosticConfigSchemaOption* _tmp45_ = NULL;
												GType _tmp46_;
												GType _tmp47_;
												_tmp42_ = schema;
												_tmp43_ = group;
												_tmp44_ = key;
												_tmp45_ = desktop_agnostic_config_schema_get_option (_tmp42_, _tmp43_, _tmp44_);
												_tmp46_ = desktop_agnostic_config_schema_option_get_option_type (_tmp45_);
												_tmp47_ = _tmp46_;
												_tmp22_ = _tmp47_ == G_TYPE_VALUE_ARRAY;
											}
											_tmp48_ = _tmp22_;
											if (_tmp48_) {
												GKeyFile* _tmp49_;
												const gchar* _tmp50_;
												const gchar* _tmp51_;
												_tmp49_ = new_data;
												_tmp50_ = group;
												_tmp51_ = key;
												desktop_agnostic_config_gkey_file_set_value_from_keyfile (self, _tmp49_, _tmp50_, _tmp51_, &_inner_error_);
												if (_inner_error_ != NULL) {
													_g_list_free0 (group_collection);
													_g_key_file_free0 (new_data);
													_g_free0 (checksum);
													_g_free0 (data);
													g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
													g_clear_error (&_inner_error_);
													return;
												}
											}
										}
									}
								}
							}
						}
					}
					_g_list_free0 (group_collection);
				}
				self->priv->_autosave = TRUE;
				_g_key_file_free0 (new_data);
			}
			_g_free0 (checksum);
			_g_free0 (data);
			break;
		}
		case DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_DELETED:
		{
			desktop_agnostic_config_backend_reset ((DesktopAgnosticConfigBackend*) self, &_inner_error_);
			if (_inner_error_ != NULL) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			break;
		}
		default:
		{
			break;
		}
	}
}


static void desktop_agnostic_config_gkey_file_ensure_directory (DesktopAgnosticConfigGKeyFile* self, const gchar* path) {
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = path;
	_tmp1_ = g_file_test (_tmp0_, G_FILE_TEST_EXISTS);
	if (!_tmp1_) {
		const gchar* _tmp2_;
		gint _tmp3_ = 0;
		gint d_errno;
		gint _tmp4_;
		_tmp2_ = path;
		_tmp3_ = g_mkdir_with_parents (_tmp2_, 0755);
		d_errno = _tmp3_;
		_tmp4_ = d_errno;
		if (_tmp4_ != 0) {
			gint _tmp5_;
			const gchar* _tmp6_ = NULL;
			_tmp5_ = d_errno;
			_tmp6_ = g_strerror (_tmp5_);
			g_critical ("config-impl-keyfile.vala:315: Config file error: %s", _tmp6_);
		}
	}
}


static gboolean desktop_agnostic_config_gkey_file_create_file_monitor (DesktopAgnosticConfigGKeyFile* self) {
	gboolean result = FALSE;
	DesktopAgnosticVFSFile* _tmp0_;
	DesktopAgnosticVFSFileMonitor* _tmp1_ = NULL;
	DesktopAgnosticVFSFileMonitor* _tmp2_;
	gulong _tmp3_ = 0UL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_keyfile;
	_tmp1_ = desktop_agnostic_vfs_file_monitor (_tmp0_);
	_g_object_unref0 (self->priv->_keyfile_monitor);
	self->priv->_keyfile_monitor = _tmp1_;
	_tmp2_ = self->priv->_keyfile_monitor;
	_tmp3_ = g_signal_connect_swapped (_tmp2_, "changed", (GCallback) desktop_agnostic_config_gkey_file_on_keyfile_changed, self);
	self->priv->_monitor_changed_id = _tmp3_;
	result = FALSE;
	return result;
}


/**
     * Determines the path to the config file and creates/loads it.
     */
static gboolean _desktop_agnostic_config_gkey_file_create_file_monitor_gsource_func (gpointer self) {
	gboolean result;
	result = desktop_agnostic_config_gkey_file_create_file_monitor (self);
	return result;
}


static void desktop_agnostic_config_gkey_file_real_constructed (GObject* base) {
	DesktopAgnosticConfigGKeyFile * self;
	gchar* base_path = NULL;
	gchar* path = NULL;
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
	DesktopAgnosticConfigSchema* _tmp2_;
	DesktopAgnosticConfigSchema* schema;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp23_;
	DesktopAgnosticVFSFile* _tmp24_ = NULL;
	DesktopAgnosticVFSFile* _tmp25_;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticConfigGKeyFile*) base;
	_tmp0_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	schema = _tmp2_;
	_tmp3_ = g_get_user_config_dir ();
	_tmp4_ = g_build_filename (_tmp3_, "desktop-agnostic", NULL);
	_g_free0 (base_path);
	base_path = _tmp4_;
	_tmp5_ = desktop_agnostic_config_backend_get_instance_id ((DesktopAgnosticConfigBackend*) self);
	_tmp6_ = _tmp5_;
	if (_tmp6_ == NULL) {
		const gchar* _tmp7_;
		DesktopAgnosticConfigSchema* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_ = NULL;
		gchar* _tmp12_;
		gchar* _tmp13_ = NULL;
		_tmp7_ = base_path;
		_tmp8_ = schema;
		_tmp9_ = desktop_agnostic_config_schema_get_app_name (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = g_strdup_printf ("%s.ini", _tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = g_build_filename (_tmp7_, _tmp12_, NULL);
		_g_free0 (path);
		path = _tmp13_;
		_g_free0 (_tmp12_);
	} else {
		const gchar* _tmp14_;
		DesktopAgnosticConfigSchema* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_ = NULL;
		gchar* _tmp21_;
		gchar* _tmp22_ = NULL;
		_tmp14_ = base_path;
		_tmp15_ = schema;
		_tmp16_ = desktop_agnostic_config_schema_get_app_name (_tmp15_);
		_tmp17_ = _tmp16_;
		_tmp18_ = desktop_agnostic_config_backend_get_instance_id ((DesktopAgnosticConfigBackend*) self);
		_tmp19_ = _tmp18_;
		_tmp20_ = g_strdup_printf ("%s-%s.ini", _tmp17_, _tmp19_);
		_tmp21_ = _tmp20_;
		_tmp22_ = g_build_filename (_tmp14_, "instances", _tmp21_, NULL);
		_g_free0 (path);
		path = _tmp22_;
		_g_free0 (_tmp21_);
	}
	_tmp23_ = path;
	_tmp24_ = desktop_agnostic_vfs_file_new_for_path (_tmp23_, &_inner_error_);
	_tmp25_ = _tmp24_;
	if (_inner_error_ != NULL) {
		_g_object_unref0 (schema);
		_g_free0 (path);
		_g_free0 (base_path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_object_unref0 (self->priv->_keyfile);
	self->priv->_keyfile = _tmp25_;
	{
		DesktopAgnosticVFSFile* _tmp26_;
		gboolean _tmp27_ = FALSE;
		_tmp26_ = self->priv->_keyfile;
		_tmp27_ = desktop_agnostic_vfs_file_exists (_tmp26_);
		if (_tmp27_) {
			DesktopAgnosticVFSFile* _tmp28_;
			_tmp28_ = self->priv->_keyfile;
			desktop_agnostic_config_gkey_file_load_data (self, _tmp28_, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch0_g_error;
			}
		} else {
			const gchar* _tmp29_;
			gchar* _tmp30_ = NULL;
			gchar* _tmp31_;
			_tmp29_ = path;
			_tmp30_ = g_path_get_dirname (_tmp29_);
			_tmp31_ = _tmp30_;
			desktop_agnostic_config_gkey_file_ensure_directory (self, _tmp31_);
			_g_free0 (_tmp31_);
			desktop_agnostic_config_backend_reset ((DesktopAgnosticConfigBackend*) self, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch0_g_error;
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp32_;
		const gchar* _tmp33_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp32_ = err;
		_tmp33_ = _tmp32_->message;
		g_critical ("config-impl-keyfile.vala:369: Config error: %s", _tmp33_);
		_g_error_free0 (err);
	}
	__finally0:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (schema);
		_g_free0 (path);
		_g_free0 (base_path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _desktop_agnostic_config_gkey_file_create_file_monitor_gsource_func, g_object_ref (self), g_object_unref);
	_g_object_unref0 (schema);
	_g_free0 (path);
	_g_free0 (base_path);
}


static void desktop_agnostic_config_gkey_file_real_reset (DesktopAgnosticConfigBackend* base, GError** error) {
	DesktopAgnosticConfigGKeyFile * self;
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
	DesktopAgnosticConfigSchema* schema;
	DesktopAgnosticConfigSchema* _tmp2_;
	DesktopAgnosticConfigSchema* _tmp4_;
	GList* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticConfigGKeyFile*) base;
	_tmp0_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
	_tmp1_ = _tmp0_;
	schema = _tmp1_;
	_tmp2_ = schema;
	if (_tmp2_ == NULL) {
		GError* _tmp3_;
		_tmp3_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_NO_SCHEMA, "The schema was not loaded.");
		_inner_error_ = _tmp3_;
		g_propagate_error (error, _inner_error_);
		return;
	}
	self->priv->_autosave = FALSE;
	_tmp4_ = schema;
	_tmp5_ = desktop_agnostic_config_schema_get_groups (_tmp4_);
	{
		GList* group_collection = NULL;
		GList* group_it = NULL;
		group_collection = _tmp5_;
		for (group_it = group_collection; group_it != NULL; group_it = group_it->next) {
			const gchar* group = NULL;
			group = (const gchar*) group_it->data;
			{
				DesktopAgnosticConfigSchema* _tmp6_;
				const gchar* _tmp7_;
				GList* _tmp8_ = NULL;
				_tmp6_ = schema;
				_tmp7_ = group;
				_tmp8_ = desktop_agnostic_config_schema_get_keys (_tmp6_, _tmp7_);
				{
					GList* key_collection = NULL;
					GList* key_it = NULL;
					key_collection = _tmp8_;
					for (key_it = key_collection; key_it != NULL; key_it = key_it->next) {
						const gchar* key = NULL;
						key = (const gchar*) key_it->data;
						{
							DesktopAgnosticConfigSchema* _tmp9_;
							const gchar* _tmp10_;
							const gchar* _tmp11_;
							DesktopAgnosticConfigSchemaOption* _tmp12_ = NULL;
							DesktopAgnosticConfigSchemaOption* _tmp13_;
							DesktopAgnosticConfigSchemaOption* option;
							gboolean _tmp14_ = FALSE;
							const gchar* _tmp15_;
							const gchar* _tmp16_;
							gboolean _tmp20_;
							_tmp9_ = schema;
							_tmp10_ = group;
							_tmp11_ = key;
							_tmp12_ = desktop_agnostic_config_schema_get_option (_tmp9_, _tmp10_, _tmp11_);
							_tmp13_ = _g_object_ref0 (_tmp12_);
							option = _tmp13_;
							_tmp15_ = desktop_agnostic_config_backend_get_instance_id ((DesktopAgnosticConfigBackend*) self);
							_tmp16_ = _tmp15_;
							if (_tmp16_ == NULL) {
								_tmp14_ = TRUE;
							} else {
								DesktopAgnosticConfigSchemaOption* _tmp17_;
								gboolean _tmp18_;
								gboolean _tmp19_;
								_tmp17_ = option;
								_tmp18_ = desktop_agnostic_config_schema_option_get_per_instance (_tmp17_);
								_tmp19_ = _tmp18_;
								_tmp14_ = _tmp19_;
							}
							_tmp20_ = _tmp14_;
							if (_tmp20_) {
								const gchar* _tmp21_;
								const gchar* _tmp22_;
								DesktopAgnosticConfigSchemaOption* _tmp23_;
								GValue _tmp24_;
								GValue _tmp25_;
								_tmp21_ = group;
								_tmp22_ = key;
								_tmp23_ = option;
								desktop_agnostic_config_schema_option_get_default_value (_tmp23_, &_tmp24_);
								_tmp25_ = _tmp24_;
								desktop_agnostic_config_backend_set_value ((DesktopAgnosticConfigBackend*) self, _tmp21_, _tmp22_, &_tmp25_, &_inner_error_);
								if (_inner_error_ != NULL) {
									g_propagate_error (error, _inner_error_);
									_g_object_unref0 (option);
									_g_list_free0 (group_collection);
									return;
								}
							}
							_g_object_unref0 (option);
						}
					}
				}
			}
		}
		_g_list_free0 (group_collection);
	}
	self->priv->_autosave = TRUE;
	desktop_agnostic_config_gkey_file_save_config (self, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


static void desktop_agnostic_config_gkey_file_real_notify_add (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, DesktopAgnosticConfigNotifyFunc callback, void* callback_target, GError** error) {
	DesktopAgnosticConfigGKeyFile * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* full_key;
	gconstpointer _tmp3_ = NULL;
	GSList* funcs;
	DesktopAgnosticConfigNotifyFunc _tmp4_;
	void* _tmp4__target;
	DesktopAgnosticConfigNotifyDelegate* _tmp5_;
	DesktopAgnosticConfigNotifyDelegate* data;
	DesktopAgnosticConfigNotifyDelegate* _tmp6_;
	self = (DesktopAgnosticConfigGKeyFile*) base;
	g_return_if_fail (group != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = group;
	_tmp1_ = key;
	_tmp2_ = g_strdup_printf ("%s/%s", _tmp0_, _tmp1_);
	full_key = _tmp2_;
	_tmp3_ = g_datalist_get_data (&self->priv->_notifiers, full_key);
	funcs = (GSList*) _tmp3_;
	_tmp4_ = callback;
	_tmp4__target = callback_target;
	_tmp5_ = desktop_agnostic_config_notify_delegate_new (_tmp4_, _tmp4__target);
	data = _tmp5_;
	_tmp6_ = data;
	data = NULL;
	funcs = g_slist_append (funcs, _tmp6_);
	g_datalist_set_data (&self->priv->_notifiers, full_key, funcs);
	_desktop_agnostic_config_notify_delegate_free0 (data);
	_g_free0 (full_key);
}


static void desktop_agnostic_config_gkey_file_real_notify (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, GError** error) {
	DesktopAgnosticConfigGKeyFile * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* full_key;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GValue _tmp5_ = {0};
	GValue value;
	gconstpointer _tmp6_ = NULL;
	GSList* funcs;
	GSList* _tmp7_;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticConfigGKeyFile*) base;
	g_return_if_fail (group != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = group;
	_tmp1_ = key;
	_tmp2_ = g_strdup_printf ("%s/%s", _tmp0_, _tmp1_);
	full_key = _tmp2_;
	_tmp3_ = group;
	_tmp4_ = key;
	desktop_agnostic_config_backend_get_value ((DesktopAgnosticConfigBackend*) self, _tmp3_, _tmp4_, &_tmp5_, &_inner_error_);
	value = _tmp5_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (full_key);
		return;
	}
	_tmp6_ = g_datalist_get_data (&self->priv->_notifiers, full_key);
	funcs = (GSList*) _tmp6_;
	_tmp7_ = funcs;
	{
		GSList* data_collection = NULL;
		GSList* data_it = NULL;
		data_collection = _tmp7_;
		for (data_it = data_collection; data_it != NULL; data_it = data_it->next) {
			DesktopAgnosticConfigNotifyDelegate* data = NULL;
			data = (DesktopAgnosticConfigNotifyDelegate*) data_it->data;
			{
				DesktopAgnosticConfigNotifyDelegate* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				GValue _tmp11_;
				_tmp8_ = data;
				_tmp9_ = group;
				_tmp10_ = key;
				_tmp11_ = value;
				desktop_agnostic_config_notify_delegate_execute (_tmp8_, _tmp9_, _tmp10_, &_tmp11_);
			}
		}
	}
	G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
	_g_free0 (full_key);
}


static void desktop_agnostic_config_gkey_file_real_notify_remove (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, DesktopAgnosticConfigNotifyFunc callback, void* callback_target, GError** error) {
	DesktopAgnosticConfigGKeyFile * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* full_key;
	const gchar* _tmp3_;
	gconstpointer _tmp4_ = NULL;
	GSList* funcs;
	DesktopAgnosticConfigNotifyFunc _tmp5_;
	void* _tmp5__target;
	DesktopAgnosticConfigNotifyDelegate* _tmp6_;
	DesktopAgnosticConfigNotifyDelegate* ndata;
	GSList* node = NULL;
	GSList* _tmp7_;
	DesktopAgnosticConfigNotifyDelegate* _tmp8_;
	GSList* _tmp9_ = NULL;
	GSList* _tmp10_;
	self = (DesktopAgnosticConfigGKeyFile*) base;
	g_return_if_fail (group != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = group;
	_tmp1_ = key;
	_tmp2_ = g_strdup_printf ("%s/%s", _tmp0_, _tmp1_);
	full_key = _tmp2_;
	_tmp3_ = full_key;
	_tmp4_ = g_datalist_get_data (&self->priv->_notifiers, _tmp3_);
	funcs = (GSList*) _tmp4_;
	_tmp5_ = callback;
	_tmp5__target = callback_target;
	_tmp6_ = desktop_agnostic_config_notify_delegate_new (_tmp5_, _tmp5__target);
	ndata = _tmp6_;
	_tmp7_ = funcs;
	_tmp8_ = ndata;
	_tmp9_ = g_slist_find_custom (_tmp7_, _tmp8_, (GCompareFunc) desktop_agnostic_config_notify_delegate_compare);
	node = _tmp9_;
	_tmp10_ = node;
	if (_tmp10_ != NULL) {
		GSList* _tmp11_;
		GSList* _tmp12_;
		const gchar* _tmp13_;
		GSList* _tmp14_;
		_tmp11_ = node;
		_desktop_agnostic_config_notify_delegate_free0 (_tmp11_->data);
		_tmp11_->data = NULL;
		_tmp12_ = node;
		funcs = g_slist_delete_link (funcs, _tmp12_);
		_tmp13_ = full_key;
		_tmp14_ = funcs;
		g_datalist_set_data (&self->priv->_notifiers, _tmp13_, _tmp14_);
	}
	_desktop_agnostic_config_notify_delegate_free0 (ndata);
	_g_free0 (full_key);
}


/**
     * Removes the config file from the file system. Implies reset(), but does
     * not save to disk.
     */
static void desktop_agnostic_config_gkey_file_real_remove (DesktopAgnosticConfigBackend* base, GError** error) {
	DesktopAgnosticConfigGKeyFile * self;
	DesktopAgnosticVFSFile* _tmp0_;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticConfigGKeyFile*) base;
	_tmp0_ = self->priv->_keyfile;
	desktop_agnostic_vfs_file_remove (_tmp0_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	desktop_agnostic_config_backend_reset ((DesktopAgnosticConfigBackend*) self, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


static void desktop_agnostic_config_gkey_file_real_get_value (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, GValue* result, GError** error) {
	DesktopAgnosticConfigGKeyFile * self;
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
	DesktopAgnosticConfigSchema* _tmp2_;
	DesktopAgnosticConfigSchema* schema;
	DesktopAgnosticConfigSchema* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	DesktopAgnosticConfigSchemaOption* _tmp6_ = NULL;
	DesktopAgnosticConfigSchemaOption* _tmp7_;
	DesktopAgnosticConfigSchemaOption* option;
	GType option_type = 0UL;
	GValue _result_ = {0};
	DesktopAgnosticConfigSchemaOption* _tmp8_;
	DesktopAgnosticConfigSchemaOption* _tmp10_;
	GType _tmp11_;
	GType _tmp12_;
	GType _tmp13_;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticConfigGKeyFile*) base;
	g_return_if_fail (group != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	schema = _tmp2_;
	_tmp3_ = schema;
	_tmp4_ = group;
	_tmp5_ = key;
	_tmp6_ = desktop_agnostic_config_schema_get_option (_tmp3_, _tmp4_, _tmp5_);
	_tmp7_ = _g_object_ref0 (_tmp6_);
	option = _tmp7_;
	_tmp8_ = option;
	if (_tmp8_ == NULL) {
		GError* _tmp9_;
		_tmp9_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, "Could not find group and/or key in schema.");
		_inner_error_ = _tmp9_;
		g_propagate_error (error, _inner_error_);
		G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
		_g_object_unref0 (option);
		_g_object_unref0 (schema);
		return;
	}
	_tmp10_ = option;
	_tmp11_ = desktop_agnostic_config_schema_option_get_option_type (_tmp10_);
	_tmp12_ = _tmp11_;
	option_type = _tmp12_;
	_tmp13_ = option_type;
	if (_tmp13_ == G_TYPE_BOOLEAN) {
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_;
		GValue _tmp18_ = {0};
		_tmp14_ = group;
		_tmp15_ = key;
		_tmp16_ = desktop_agnostic_config_backend_get_bool ((DesktopAgnosticConfigBackend*) self, _tmp14_, _tmp15_, &_inner_error_);
		_tmp17_ = _tmp16_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
			_g_object_unref0 (option);
			_g_object_unref0 (schema);
			return;
		}
		g_value_init (&_tmp18_, G_TYPE_BOOLEAN);
		g_value_set_boolean (&_tmp18_, _tmp17_);
		G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
		_result_ = _tmp18_;
	} else {
		GType _tmp19_;
		_tmp19_ = option_type;
		if (_tmp19_ == G_TYPE_FLOAT) {
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gfloat _tmp22_ = 0.0F;
			gfloat _tmp23_;
			GValue _tmp24_ = {0};
			_tmp20_ = group;
			_tmp21_ = key;
			_tmp22_ = desktop_agnostic_config_backend_get_float ((DesktopAgnosticConfigBackend*) self, _tmp20_, _tmp21_, &_inner_error_);
			_tmp23_ = _tmp22_;
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
				_g_object_unref0 (option);
				_g_object_unref0 (schema);
				return;
			}
			g_value_init (&_tmp24_, G_TYPE_FLOAT);
			g_value_set_float (&_tmp24_, _tmp23_);
			G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
			_result_ = _tmp24_;
		} else {
			GType _tmp25_;
			_tmp25_ = option_type;
			if (_tmp25_ == G_TYPE_INT) {
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				gint _tmp28_ = 0;
				gint _tmp29_;
				GValue _tmp30_ = {0};
				_tmp26_ = group;
				_tmp27_ = key;
				_tmp28_ = desktop_agnostic_config_backend_get_int ((DesktopAgnosticConfigBackend*) self, _tmp26_, _tmp27_, &_inner_error_);
				_tmp29_ = _tmp28_;
				if (_inner_error_ != NULL) {
					g_propagate_error (error, _inner_error_);
					G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
					_g_object_unref0 (option);
					_g_object_unref0 (schema);
					return;
				}
				g_value_init (&_tmp30_, G_TYPE_INT);
				g_value_set_int (&_tmp30_, _tmp29_);
				G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
				_result_ = _tmp30_;
			} else {
				GType _tmp31_;
				_tmp31_ = option_type;
				if (_tmp31_ == G_TYPE_STRING) {
					const gchar* _tmp32_;
					const gchar* _tmp33_;
					gchar* _tmp34_ = NULL;
					gchar* _tmp35_;
					GValue _tmp36_ = {0};
					_tmp32_ = group;
					_tmp33_ = key;
					_tmp34_ = desktop_agnostic_config_backend_get_string ((DesktopAgnosticConfigBackend*) self, _tmp32_, _tmp33_, &_inner_error_);
					_tmp35_ = _tmp34_;
					if (_inner_error_ != NULL) {
						g_propagate_error (error, _inner_error_);
						G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
						_g_object_unref0 (option);
						_g_object_unref0 (schema);
						return;
					}
					g_value_init (&_tmp36_, G_TYPE_STRING);
					g_value_take_string (&_tmp36_, _tmp35_);
					G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
					_result_ = _tmp36_;
				} else {
					GType _tmp37_;
					_tmp37_ = option_type;
					if (_tmp37_ == G_TYPE_VALUE_ARRAY) {
						const gchar* _tmp38_;
						const gchar* _tmp39_;
						GValueArray* _tmp40_ = NULL;
						GValueArray* _tmp41_;
						GValue _tmp42_ = {0};
						_tmp38_ = group;
						_tmp39_ = key;
						_tmp40_ = desktop_agnostic_config_backend_get_list ((DesktopAgnosticConfigBackend*) self, _tmp38_, _tmp39_, &_inner_error_);
						_tmp41_ = _tmp40_;
						if (_inner_error_ != NULL) {
							g_propagate_error (error, _inner_error_);
							G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
							_g_object_unref0 (option);
							_g_object_unref0 (schema);
							return;
						}
						g_value_init (&_tmp42_, G_TYPE_VALUE_ARRAY);
						g_value_take_boxed (&_tmp42_, _tmp41_);
						G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
						_result_ = _tmp42_;
					} else {
						DesktopAgnosticConfigSchema* _tmp43_;
						DesktopAgnosticConfigSchema* _tmp44_;
						GType _tmp45_;
						DesktopAgnosticConfigSchemaType* _tmp46_ = NULL;
						DesktopAgnosticConfigSchemaType* _tmp47_;
						DesktopAgnosticConfigSchemaType* st;
						DesktopAgnosticConfigSchemaType* _tmp48_;
						_tmp43_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
						_tmp44_ = _tmp43_;
						_tmp45_ = option_type;
						_tmp46_ = desktop_agnostic_config_schema_find_type (_tmp45_);
						_tmp47_ = _g_object_ref0 (_tmp46_);
						st = _tmp47_;
						_tmp48_ = st;
						if (_tmp48_ == NULL) {
							GType _tmp49_;
							const gchar* _tmp50_ = NULL;
							GError* _tmp51_;
							_tmp49_ = option_type;
							_tmp50_ = g_type_name (_tmp49_);
							_tmp51_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_INVALID_TYPE, "'%s' is an invalid config type.", _tmp50_);
							_inner_error_ = _tmp51_;
							g_propagate_error (error, _inner_error_);
							_g_object_unref0 (st);
							G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
							_g_object_unref0 (option);
							_g_object_unref0 (schema);
							return;
						} else {
							const gchar* _tmp52_;
							const gchar* _tmp53_;
							gchar* _tmp54_ = NULL;
							gchar* _tmp55_;
							DesktopAgnosticConfigSchemaType* _tmp56_;
							gchar* _tmp57_;
							GValue _tmp58_ = {0};
							GValue _tmp59_;
							GValue _tmp60_;
							_tmp52_ = group;
							_tmp53_ = key;
							_tmp54_ = desktop_agnostic_config_backend_get_string ((DesktopAgnosticConfigBackend*) self, _tmp52_, _tmp53_, &_inner_error_);
							_tmp55_ = _tmp54_;
							if (_inner_error_ != NULL) {
								g_propagate_error (error, _inner_error_);
								_g_object_unref0 (st);
								G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
								_g_object_unref0 (option);
								_g_object_unref0 (schema);
								return;
							}
							_tmp56_ = st;
							_tmp57_ = _tmp55_;
							desktop_agnostic_config_schema_type_deserialize (_tmp56_, _tmp57_, &_tmp58_, &_inner_error_);
							_tmp59_ = _tmp58_;
							_g_free0 (_tmp57_);
							_tmp60_ = _tmp59_;
							if (_inner_error_ != NULL) {
								g_propagate_error (error, _inner_error_);
								_g_object_unref0 (st);
								G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
								_g_object_unref0 (option);
								_g_object_unref0 (schema);
								return;
							}
							G_IS_VALUE (&_result_) ? (g_value_unset (&_result_), NULL) : NULL;
							_result_ = _tmp60_;
						}
						_g_object_unref0 (st);
					}
				}
			}
		}
	}
	*result = _result_;
	_g_object_unref0 (option);
	_g_object_unref0 (schema);
	return;
}


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


static gboolean desktop_agnostic_config_gkey_file_real_get_bool (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, GError** error) {
	DesktopAgnosticConfigGKeyFile * self;
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticConfigGKeyFile*) base;
	g_return_val_if_fail (group != NULL, FALSE);
	g_return_val_if_fail (key != NULL, FALSE);
	{
		GKeyFile* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_;
		_tmp0_ = self->priv->_data;
		_tmp1_ = group;
		_tmp2_ = key;
		_tmp3_ = g_key_file_get_boolean (_tmp0_, _tmp1_, _tmp2_, &_inner_error_);
		_tmp4_ = _tmp3_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		result = _tmp4_;
		return result;
	}
	goto __finally1;
	__catch1_g_key_file_error:
	{
		GError* err = NULL;
		gboolean _tmp5_ = FALSE;
		GError* _tmp6_;
		gboolean _tmp8_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = err;
		if (g_error_matches (_tmp6_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_GROUP_NOT_FOUND)) {
			_tmp5_ = TRUE;
		} else {
			GError* _tmp7_;
			_tmp7_ = err;
			_tmp5_ = g_error_matches (_tmp7_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_KEY_NOT_FOUND);
		}
		_tmp8_ = _tmp5_;
		if (_tmp8_) {
			GError* _tmp9_;
			const gchar* _tmp10_;
			GError* _tmp11_;
			_tmp9_ = err;
			_tmp10_ = _tmp9_->message;
			_tmp11_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, _tmp10_);
			_inner_error_ = _tmp11_;
			_g_error_free0 (err);
			goto __finally1;
		} else {
			GError* _tmp12_;
			GError* _tmp13_;
			_tmp12_ = err;
			_tmp13_ = _g_error_copy0 (_tmp12_);
			_inner_error_ = _tmp13_;
			_g_error_free0 (err);
			goto __finally1;
		}
		_g_error_free0 (err);
	}
	__finally1:
	g_propagate_error (error, _inner_error_);
	return FALSE;
}


static void desktop_agnostic_config_gkey_file_real_set_bool (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, gboolean value, GError** error) {
	DesktopAgnosticConfigGKeyFile * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GKeyFile* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp10_;
	gboolean _tmp16_;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticConfigGKeyFile*) base;
	g_return_if_fail (group != NULL);
	g_return_if_fail (key != NULL);
	_tmp2_ = self->priv->_data;
	_tmp3_ = group;
	_tmp4_ = g_key_file_has_group (_tmp2_, _tmp3_);
	if (!_tmp4_) {
		_tmp1_ = TRUE;
	} else {
		GKeyFile* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_;
		_tmp5_ = self->priv->_data;
		_tmp6_ = group;
		_tmp7_ = key;
		_tmp8_ = g_key_file_has_key (_tmp5_, _tmp6_, _tmp7_, &_inner_error_);
		_tmp9_ = _tmp8_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return;
		}
		_tmp1_ = !_tmp9_;
	}
	_tmp10_ = _tmp1_;
	if (_tmp10_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_;
		gboolean _tmp15_;
		_tmp11_ = group;
		_tmp12_ = key;
		_tmp13_ = desktop_agnostic_config_backend_get_bool ((DesktopAgnosticConfigBackend*) self, _tmp11_, _tmp12_, &_inner_error_);
		_tmp14_ = _tmp13_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return;
		}
		_tmp15_ = value;
		_tmp0_ = _tmp14_ != _tmp15_;
	}
	_tmp16_ = _tmp0_;
	if (_tmp16_) {
		GKeyFile* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gboolean _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		_tmp17_ = self->priv->_data;
		_tmp18_ = group;
		_tmp19_ = key;
		_tmp20_ = value;
		g_key_file_set_boolean (_tmp17_, _tmp18_, _tmp19_, _tmp20_);
		_tmp21_ = group;
		_tmp22_ = key;
		desktop_agnostic_config_gkey_file_update_config (self, _tmp21_, _tmp22_, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return;
		}
	}
}


static gfloat desktop_agnostic_config_gkey_file_real_get_float (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, GError** error) {
	DesktopAgnosticConfigGKeyFile * self;
	gfloat result = 0.0F;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticConfigGKeyFile*) base;
	g_return_val_if_fail (group != NULL, 0.0F);
	g_return_val_if_fail (key != NULL, 0.0F);
	{
		GKeyFile* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gdouble _tmp3_ = 0.0;
		gdouble _tmp4_;
		_tmp0_ = self->priv->_data;
		_tmp1_ = group;
		_tmp2_ = key;
		_tmp3_ = g_key_file_get_double (_tmp0_, _tmp1_, _tmp2_, &_inner_error_);
		_tmp4_ = _tmp3_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch2_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0.0F;
		}
		result = (gfloat) _tmp4_;
		return result;
	}
	goto __finally2;
	__catch2_g_key_file_error:
	{
		GError* err = NULL;
		gboolean _tmp5_ = FALSE;
		GError* _tmp6_;
		gboolean _tmp8_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = err;
		if (g_error_matches (_tmp6_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_GROUP_NOT_FOUND)) {
			_tmp5_ = TRUE;
		} else {
			GError* _tmp7_;
			_tmp7_ = err;
			_tmp5_ = g_error_matches (_tmp7_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_KEY_NOT_FOUND);
		}
		_tmp8_ = _tmp5_;
		if (_tmp8_) {
			GError* _tmp9_;
			const gchar* _tmp10_;
			GError* _tmp11_;
			_tmp9_ = err;
			_tmp10_ = _tmp9_->message;
			_tmp11_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, _tmp10_);
			_inner_error_ = _tmp11_;
			_g_error_free0 (err);
			goto __finally2;
		} else {
			GError* _tmp12_;
			GError* _tmp13_;
			_tmp12_ = err;
			_tmp13_ = _g_error_copy0 (_tmp12_);
			_inner_error_ = _tmp13_;
			_g_error_free0 (err);
			goto __finally2;
		}
		_g_error_free0 (err);
	}
	__finally2:
	if (_inner_error_->domain == DESKTOP_AGNOSTIC_CONFIG_ERROR) {
		g_propagate_error (error, _inner_error_);
		return 0.0F;
	} else {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0.0F;
	}
}


static void desktop_agnostic_config_gkey_file_real_set_float (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, gfloat value, GError** error) {
	DesktopAgnosticConfigGKeyFile * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GKeyFile* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp10_;
	gboolean _tmp16_;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticConfigGKeyFile*) base;
	g_return_if_fail (group != NULL);
	g_return_if_fail (key != NULL);
	_tmp2_ = self->priv->_data;
	_tmp3_ = group;
	_tmp4_ = g_key_file_has_group (_tmp2_, _tmp3_);
	if (!_tmp4_) {
		_tmp1_ = TRUE;
	} else {
		GKeyFile* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_;
		_tmp5_ = self->priv->_data;
		_tmp6_ = group;
		_tmp7_ = key;
		_tmp8_ = g_key_file_has_key (_tmp5_, _tmp6_, _tmp7_, &_inner_error_);
		_tmp9_ = _tmp8_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return;
		}
		_tmp1_ = !_tmp9_;
	}
	_tmp10_ = _tmp1_;
	if (_tmp10_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gfloat _tmp13_ = 0.0F;
		gfloat _tmp14_;
		gfloat _tmp15_;
		_tmp11_ = group;
		_tmp12_ = key;
		_tmp13_ = desktop_agnostic_config_backend_get_float ((DesktopAgnosticConfigBackend*) self, _tmp11_, _tmp12_, &_inner_error_);
		_tmp14_ = _tmp13_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return;
		}
		_tmp15_ = value;
		_tmp0_ = _tmp14_ != _tmp15_;
	}
	_tmp16_ = _tmp0_;
	if (_tmp16_) {
		GKeyFile* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gfloat _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		_tmp17_ = self->priv->_data;
		_tmp18_ = group;
		_tmp19_ = key;
		_tmp20_ = value;
		g_key_file_set_double (_tmp17_, _tmp18_, _tmp19_, (gdouble) _tmp20_);
		_tmp21_ = group;
		_tmp22_ = key;
		desktop_agnostic_config_gkey_file_update_config (self, _tmp21_, _tmp22_, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return;
		}
	}
}


static gint desktop_agnostic_config_gkey_file_real_get_int (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, GError** error) {
	DesktopAgnosticConfigGKeyFile * self;
	gint result = 0;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticConfigGKeyFile*) base;
	g_return_val_if_fail (group != NULL, 0);
	g_return_val_if_fail (key != NULL, 0);
	{
		GKeyFile* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gint _tmp3_ = 0;
		gint _tmp4_;
		_tmp0_ = self->priv->_data;
		_tmp1_ = group;
		_tmp2_ = key;
		_tmp3_ = g_key_file_get_integer (_tmp0_, _tmp1_, _tmp2_, &_inner_error_);
		_tmp4_ = _tmp3_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch3_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0;
		}
		result = _tmp4_;
		return result;
	}
	goto __finally3;
	__catch3_g_key_file_error:
	{
		GError* err = NULL;
		gboolean _tmp5_ = FALSE;
		GError* _tmp6_;
		gboolean _tmp8_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = err;
		if (g_error_matches (_tmp6_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_GROUP_NOT_FOUND)) {
			_tmp5_ = TRUE;
		} else {
			GError* _tmp7_;
			_tmp7_ = err;
			_tmp5_ = g_error_matches (_tmp7_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_KEY_NOT_FOUND);
		}
		_tmp8_ = _tmp5_;
		if (_tmp8_) {
			GError* _tmp9_;
			const gchar* _tmp10_;
			GError* _tmp11_;
			_tmp9_ = err;
			_tmp10_ = _tmp9_->message;
			_tmp11_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, _tmp10_);
			_inner_error_ = _tmp11_;
			_g_error_free0 (err);
			goto __finally3;
		} else {
			GError* _tmp12_;
			GError* _tmp13_;
			_tmp12_ = err;
			_tmp13_ = _g_error_copy0 (_tmp12_);
			_inner_error_ = _tmp13_;
			_g_error_free0 (err);
			goto __finally3;
		}
		_g_error_free0 (err);
	}
	__finally3:
	g_propagate_error (error, _inner_error_);
	return 0;
}


static void desktop_agnostic_config_gkey_file_real_set_int (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, gint value, GError** error) {
	DesktopAgnosticConfigGKeyFile * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GKeyFile* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp10_;
	gboolean _tmp16_;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticConfigGKeyFile*) base;
	g_return_if_fail (group != NULL);
	g_return_if_fail (key != NULL);
	_tmp2_ = self->priv->_data;
	_tmp3_ = group;
	_tmp4_ = g_key_file_has_group (_tmp2_, _tmp3_);
	if (!_tmp4_) {
		_tmp1_ = TRUE;
	} else {
		GKeyFile* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_;
		_tmp5_ = self->priv->_data;
		_tmp6_ = group;
		_tmp7_ = key;
		_tmp8_ = g_key_file_has_key (_tmp5_, _tmp6_, _tmp7_, &_inner_error_);
		_tmp9_ = _tmp8_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return;
		}
		_tmp1_ = !_tmp9_;
	}
	_tmp10_ = _tmp1_;
	if (_tmp10_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gint _tmp13_ = 0;
		gint _tmp14_;
		gint _tmp15_;
		_tmp11_ = group;
		_tmp12_ = key;
		_tmp13_ = desktop_agnostic_config_backend_get_int ((DesktopAgnosticConfigBackend*) self, _tmp11_, _tmp12_, &_inner_error_);
		_tmp14_ = _tmp13_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return;
		}
		_tmp15_ = value;
		_tmp0_ = _tmp14_ != _tmp15_;
	}
	_tmp16_ = _tmp0_;
	if (_tmp16_) {
		GKeyFile* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gint _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		_tmp17_ = self->priv->_data;
		_tmp18_ = group;
		_tmp19_ = key;
		_tmp20_ = value;
		g_key_file_set_integer (_tmp17_, _tmp18_, _tmp19_, _tmp20_);
		_tmp21_ = group;
		_tmp22_ = key;
		desktop_agnostic_config_gkey_file_update_config (self, _tmp21_, _tmp22_, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return;
		}
	}
}


static gchar* desktop_agnostic_config_gkey_file_real_get_string (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, GError** error) {
	DesktopAgnosticConfigGKeyFile * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticConfigGKeyFile*) base;
	g_return_val_if_fail (group != NULL, NULL);
	g_return_val_if_fail (key != NULL, NULL);
	{
		GKeyFile* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		_tmp0_ = self->priv->_data;
		_tmp1_ = group;
		_tmp2_ = key;
		_tmp3_ = g_key_file_get_string (_tmp0_, _tmp1_, _tmp2_, &_inner_error_);
		_tmp4_ = _tmp3_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch4_g_key_file_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = _tmp4_;
		return result;
	}
	goto __finally4;
	__catch4_g_key_file_error:
	{
		GError* err = NULL;
		gboolean _tmp5_ = FALSE;
		GError* _tmp6_;
		gboolean _tmp8_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = err;
		if (g_error_matches (_tmp6_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_GROUP_NOT_FOUND)) {
			_tmp5_ = TRUE;
		} else {
			GError* _tmp7_;
			_tmp7_ = err;
			_tmp5_ = g_error_matches (_tmp7_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_KEY_NOT_FOUND);
		}
		_tmp8_ = _tmp5_;
		if (_tmp8_) {
			GError* _tmp9_;
			const gchar* _tmp10_;
			GError* _tmp11_;
			_tmp9_ = err;
			_tmp10_ = _tmp9_->message;
			_tmp11_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, _tmp10_);
			_inner_error_ = _tmp11_;
			_g_error_free0 (err);
			goto __finally4;
		} else {
			GError* _tmp12_;
			GError* _tmp13_;
			_tmp12_ = err;
			_tmp13_ = _g_error_copy0 (_tmp12_);
			_inner_error_ = _tmp13_;
			_g_error_free0 (err);
			goto __finally4;
		}
		_g_error_free0 (err);
	}
	__finally4:
	g_propagate_error (error, _inner_error_);
	return NULL;
}


static void desktop_agnostic_config_gkey_file_real_set_string (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, const gchar* value, GError** error) {
	DesktopAgnosticConfigGKeyFile * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GKeyFile* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp10_;
	gboolean _tmp17_;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticConfigGKeyFile*) base;
	g_return_if_fail (group != NULL);
	g_return_if_fail (key != NULL);
	g_return_if_fail (value != NULL);
	_tmp2_ = self->priv->_data;
	_tmp3_ = group;
	_tmp4_ = g_key_file_has_group (_tmp2_, _tmp3_);
	if (!_tmp4_) {
		_tmp1_ = TRUE;
	} else {
		GKeyFile* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_;
		_tmp5_ = self->priv->_data;
		_tmp6_ = group;
		_tmp7_ = key;
		_tmp8_ = g_key_file_has_key (_tmp5_, _tmp6_, _tmp7_, &_inner_error_);
		_tmp9_ = _tmp8_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return;
		}
		_tmp1_ = !_tmp9_;
	}
	_tmp10_ = _tmp1_;
	if (_tmp10_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		_tmp11_ = group;
		_tmp12_ = key;
		_tmp13_ = desktop_agnostic_config_backend_get_string ((DesktopAgnosticConfigBackend*) self, _tmp11_, _tmp12_, &_inner_error_);
		_tmp14_ = _tmp13_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return;
		}
		_tmp15_ = _tmp14_;
		_tmp16_ = value;
		_tmp0_ = g_strcmp0 (_tmp15_, _tmp16_) != 0;
		_g_free0 (_tmp15_);
	}
	_tmp17_ = _tmp0_;
	if (_tmp17_) {
		GKeyFile* _tmp18_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		_tmp18_ = self->priv->_data;
		_tmp19_ = group;
		_tmp20_ = key;
		_tmp21_ = value;
		g_key_file_set_string (_tmp18_, _tmp19_, _tmp20_, _tmp21_);
		_tmp22_ = group;
		_tmp23_ = key;
		desktop_agnostic_config_gkey_file_update_config (self, _tmp22_, _tmp23_, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return;
		}
	}
}


static GValueArray* desktop_agnostic_config_gkey_file_real_get_list (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, GError** error) {
	DesktopAgnosticConfigGKeyFile * self;
	GValueArray* result = NULL;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticConfigGKeyFile*) base;
	g_return_val_if_fail (group != NULL, NULL);
	g_return_val_if_fail (key != NULL, NULL);
	{
		GKeyFile* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		GValueArray* _tmp3_ = NULL;
		GValueArray* _tmp4_;
		_tmp0_ = self->priv->_data;
		_tmp1_ = group;
		_tmp2_ = key;
		_tmp3_ = desktop_agnostic_config_gkey_file_generate_valuearray_from_keyfile (self, _tmp0_, _tmp1_, _tmp2_, &_inner_error_);
		_tmp4_ = _tmp3_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch5_g_key_file_error;
			}
			goto __finally5;
		}
		result = _tmp4_;
		return result;
	}
	goto __finally5;
	__catch5_g_key_file_error:
	{
		GError* err = NULL;
		gboolean _tmp5_ = FALSE;
		GError* _tmp6_;
		gboolean _tmp8_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = err;
		if (g_error_matches (_tmp6_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_GROUP_NOT_FOUND)) {
			_tmp5_ = TRUE;
		} else {
			GError* _tmp7_;
			_tmp7_ = err;
			_tmp5_ = g_error_matches (_tmp7_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_KEY_NOT_FOUND);
		}
		_tmp8_ = _tmp5_;
		if (_tmp8_) {
			GError* _tmp9_;
			const gchar* _tmp10_;
			GError* _tmp11_;
			_tmp9_ = err;
			_tmp10_ = _tmp9_->message;
			_tmp11_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND, _tmp10_);
			_inner_error_ = _tmp11_;
			_g_error_free0 (err);
			goto __finally5;
		} else {
			GError* _tmp12_;
			GError* _tmp13_;
			_tmp12_ = err;
			_tmp13_ = _g_error_copy0 (_tmp12_);
			_inner_error_ = _tmp13_;
			_g_error_free0 (err);
			goto __finally5;
		}
		_g_error_free0 (err);
	}
	__finally5:
	g_propagate_error (error, _inner_error_);
	return NULL;
}


static void _vala_array_add1 (gboolean** array, int* length, int* size, gboolean value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gboolean, *array, *size);
	}
	(*array)[(*length)++] = value;
}


static void _vala_array_add2 (gint** array, int* length, int* size, gint value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gint, *array, *size);
	}
	(*array)[(*length)++] = value;
}


static void _vala_array_add3 (gdouble** array, int* length, int* size, gdouble value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gdouble, *array, *size);
	}
	(*array)[(*length)++] = value;
}


static void _vala_array_add4 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add5 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void desktop_agnostic_config_gkey_file_real_set_list (DesktopAgnosticConfigBackend* base, const gchar* group, const gchar* key, GValueArray* value, GError** error) {
	DesktopAgnosticConfigGKeyFile * self;
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	DesktopAgnosticConfigSchemaOption* _tmp4_ = NULL;
	DesktopAgnosticConfigSchemaOption* _tmp5_;
	DesktopAgnosticConfigSchemaOption* option;
	DesktopAgnosticConfigSchemaOption* _tmp6_;
	GType _tmp7_;
	GType _tmp8_;
	GType list_type;
	gboolean _tmp9_ = FALSE;
	GKeyFile* _tmp10_;
	const gchar* _tmp11_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp18_;
	GValueArray* _tmp48_;
	guint _tmp49_;
	const gchar* _tmp120_;
	const gchar* _tmp121_;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticConfigGKeyFile*) base;
	g_return_if_fail (group != NULL);
	g_return_if_fail (key != NULL);
	g_return_if_fail (value != NULL);
	_tmp0_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = group;
	_tmp3_ = key;
	_tmp4_ = desktop_agnostic_config_schema_get_option (_tmp1_, _tmp2_, _tmp3_);
	_tmp5_ = _g_object_ref0 (_tmp4_);
	option = _tmp5_;
	_tmp6_ = option;
	_tmp7_ = desktop_agnostic_config_schema_option_get_list_type (_tmp6_);
	_tmp8_ = _tmp7_;
	list_type = _tmp8_;
	_tmp10_ = self->priv->_data;
	_tmp11_ = group;
	_tmp12_ = g_key_file_has_group (_tmp10_, _tmp11_);
	if (_tmp12_) {
		GKeyFile* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_;
		_tmp13_ = self->priv->_data;
		_tmp14_ = group;
		_tmp15_ = key;
		_tmp16_ = g_key_file_has_key (_tmp13_, _tmp14_, _tmp15_, &_inner_error_);
		_tmp17_ = _tmp16_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (option);
			return;
		}
		_tmp9_ = _tmp17_;
	} else {
		_tmp9_ = FALSE;
	}
	_tmp18_ = _tmp9_;
	if (_tmp18_) {
		GValueArray* old_value = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		GValueArray* _tmp21_ = NULL;
		GValueArray* _tmp22_;
		GValueArray* _tmp23_;
		guint _tmp24_;
		GValueArray* _tmp25_;
		guint _tmp26_;
		_tmp19_ = group;
		_tmp20_ = key;
		_tmp21_ = desktop_agnostic_config_backend_get_list ((DesktopAgnosticConfigBackend*) self, _tmp19_, _tmp20_, &_inner_error_);
		_tmp22_ = _tmp21_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_value_array_free0 (old_value);
			_g_object_unref0 (option);
			return;
		}
		_g_value_array_free0 (old_value);
		old_value = _tmp22_;
		_tmp23_ = old_value;
		_tmp24_ = _tmp23_->n_values;
		_tmp25_ = value;
		_tmp26_ = _tmp25_->n_values;
		if (_tmp24_ == _tmp26_) {
			gboolean is_equal;
			gboolean _tmp47_;
			is_equal = TRUE;
			{
				guint i;
				i = (guint) 0;
				{
					gboolean _tmp27_;
					_tmp27_ = TRUE;
					while (TRUE) {
						gboolean _tmp28_;
						guint _tmp30_;
						GValueArray* _tmp31_;
						guint _tmp32_;
						GValue old_val = {0};
						GValue new_val = {0};
						GValueArray* _tmp33_;
						guint _tmp34_;
						GValue* _tmp35_ = NULL;
						GValueArray* _tmp36_;
						guint _tmp37_;
						GValue* _tmp38_ = NULL;
						gboolean _tmp39_ = FALSE;
						GType _tmp40_ = 0UL;
						GType _tmp41_ = 0UL;
						gboolean _tmp46_;
						_tmp28_ = _tmp27_;
						if (!_tmp28_) {
							guint _tmp29_;
							_tmp29_ = i;
							i = _tmp29_ + 1;
						}
						_tmp27_ = FALSE;
						_tmp30_ = i;
						_tmp31_ = value;
						_tmp32_ = _tmp31_->n_values;
						if (!(_tmp30_ < _tmp32_)) {
							break;
						}
						_tmp33_ = old_value;
						_tmp34_ = i;
						_tmp35_ = g_value_array_get_nth (_tmp33_, _tmp34_);
						old_val = *_tmp35_;
						_tmp36_ = value;
						_tmp37_ = i;
						_tmp38_ = g_value_array_get_nth (_tmp36_, _tmp37_);
						new_val = *_tmp38_;
						_tmp40_ = G_VALUE_TYPE (&old_val);
						_tmp41_ = G_VALUE_TYPE (&new_val);
						if (_tmp40_ != _tmp41_) {
							_tmp39_ = TRUE;
						} else {
							gchar* _tmp42_ = NULL;
							gchar* _tmp43_;
							gchar* _tmp44_ = NULL;
							gchar* _tmp45_;
							_tmp42_ = g_strdup_value_contents (&old_val);
							_tmp43_ = _tmp42_;
							_tmp44_ = g_strdup_value_contents (&new_val);
							_tmp45_ = _tmp44_;
							_tmp39_ = g_strcmp0 (_tmp43_, _tmp45_) != 0;
							_g_free0 (_tmp45_);
							_g_free0 (_tmp43_);
						}
						_tmp46_ = _tmp39_;
						if (_tmp46_) {
							is_equal = FALSE;
							break;
						}
					}
				}
			}
			_tmp47_ = is_equal;
			if (_tmp47_) {
				_g_value_array_free0 (old_value);
				_g_object_unref0 (option);
				return;
			}
		}
		_g_value_array_free0 (old_value);
	}
	_tmp48_ = value;
	_tmp49_ = _tmp48_->n_values;
	if (_tmp49_ == ((guint) 0)) {
		GKeyFile* _tmp50_;
		const gchar* _tmp51_;
		gboolean _tmp52_ = FALSE;
		GKeyFile* _tmp53_;
		const gchar* _tmp54_;
		const gchar* _tmp55_;
		gboolean _tmp56_ = FALSE;
		gboolean _tmp57_;
		_tmp50_ = self->priv->_data;
		_tmp51_ = group;
		_tmp52_ = g_key_file_has_group (_tmp50_, _tmp51_);
		if (!_tmp52_) {
			_g_object_unref0 (option);
			return;
		}
		_tmp53_ = self->priv->_data;
		_tmp54_ = group;
		_tmp55_ = key;
		_tmp56_ = g_key_file_has_key (_tmp53_, _tmp54_, _tmp55_, &_inner_error_);
		_tmp57_ = _tmp56_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (option);
			return;
		}
		if (_tmp57_) {
			GKeyFile* _tmp58_;
			const gchar* _tmp59_;
			const gchar* _tmp60_;
			_tmp58_ = self->priv->_data;
			_tmp59_ = group;
			_tmp60_ = key;
			g_key_file_remove_key (_tmp58_, _tmp59_, _tmp60_, &_inner_error_);
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (option);
				return;
			}
		}
	} else {
		GType _tmp61_;
		_tmp61_ = list_type;
		if (_tmp61_ == G_TYPE_BOOLEAN) {
			gboolean* _tmp62_ = NULL;
			gboolean* list;
			gint list_length1;
			gint _list_size_;
			GValueArray* _tmp63_;
			GKeyFile* _tmp66_;
			const gchar* _tmp67_;
			const gchar* _tmp68_;
			gboolean* _tmp69_;
			gint _tmp69__length1;
			_tmp62_ = g_new0 (gboolean, 0);
			list = _tmp62_;
			list_length1 = 0;
			_list_size_ = list_length1;
			_tmp63_ = value;
			{
				GValueArray* val_collection = NULL;
				guint val_index = 0U;
				val_collection = _tmp63_;
				for (val_index = 0; val_index < val_collection->n_values; val_index = val_index + 1) {
					GValue val = {0};
					val = *g_value_array_get_nth (val_collection, val_index);
					{
						gboolean* _tmp64_;
						gint _tmp64__length1;
						GValue _tmp65_;
						_tmp64_ = list;
						_tmp64__length1 = list_length1;
						_tmp65_ = val;
						_vala_array_add1 (&list, &list_length1, &_list_size_, g_value_get_boolean (&_tmp65_));
					}
				}
			}
			_tmp66_ = self->priv->_data;
			_tmp67_ = group;
			_tmp68_ = key;
			_tmp69_ = list;
			_tmp69__length1 = list_length1;
			g_key_file_set_boolean_list (_tmp66_, _tmp67_, _tmp68_, _tmp69_, _tmp69__length1);
			list = (g_free (list), NULL);
		} else {
			GType _tmp70_;
			_tmp70_ = list_type;
			if (_tmp70_ == G_TYPE_INT) {
				gint* _tmp71_ = NULL;
				gint* list;
				gint list_length1;
				gint _list_size_;
				GValueArray* _tmp72_;
				GKeyFile* _tmp77_;
				const gchar* _tmp78_;
				const gchar* _tmp79_;
				gint* _tmp80_;
				gint _tmp80__length1;
				_tmp71_ = g_new0 (gint, 0);
				list = _tmp71_;
				list_length1 = 0;
				_list_size_ = list_length1;
				_tmp72_ = value;
				{
					GValueArray* val_collection = NULL;
					guint val_index = 0U;
					val_collection = _tmp72_;
					for (val_index = 0; val_index < val_collection->n_values; val_index = val_index + 1) {
						GValue val = {0};
						val = *g_value_array_get_nth (val_collection, val_index);
						{
							GValue _tmp73_;
							gint _tmp74_ = 0;
							gint _tmp75_;
							gint* _tmp76_;
							gint _tmp76__length1;
							_tmp73_ = val;
							_tmp74_ = desktop_agnostic_config_backend_get_int_from_value (&_tmp73_, &_inner_error_);
							_tmp75_ = _tmp74_;
							if (_inner_error_ != NULL) {
								g_propagate_error (error, _inner_error_);
								list = (g_free (list), NULL);
								_g_object_unref0 (option);
								return;
							}
							_tmp76_ = list;
							_tmp76__length1 = list_length1;
							_vala_array_add2 (&list, &list_length1, &_list_size_, _tmp75_);
						}
					}
				}
				_tmp77_ = self->priv->_data;
				_tmp78_ = group;
				_tmp79_ = key;
				_tmp80_ = list;
				_tmp80__length1 = list_length1;
				g_key_file_set_integer_list (_tmp77_, _tmp78_, _tmp79_, _tmp80_, _tmp80__length1);
				list = (g_free (list), NULL);
			} else {
				GType _tmp81_;
				_tmp81_ = list_type;
				if (_tmp81_ == G_TYPE_FLOAT) {
					gdouble* _tmp82_ = NULL;
					gdouble* list;
					gint list_length1;
					gint _list_size_;
					GValueArray* _tmp83_;
					GKeyFile* _tmp88_;
					const gchar* _tmp89_;
					const gchar* _tmp90_;
					gdouble* _tmp91_;
					gint _tmp91__length1;
					_tmp82_ = g_new0 (gdouble, 0);
					list = _tmp82_;
					list_length1 = 0;
					_list_size_ = list_length1;
					_tmp83_ = value;
					{
						GValueArray* val_collection = NULL;
						guint val_index = 0U;
						val_collection = _tmp83_;
						for (val_index = 0; val_index < val_collection->n_values; val_index = val_index + 1) {
							GValue val = {0};
							val = *g_value_array_get_nth (val_collection, val_index);
							{
								GValue _tmp84_;
								gfloat _tmp85_ = 0.0F;
								gfloat _tmp86_;
								gdouble* _tmp87_;
								gint _tmp87__length1;
								_tmp84_ = val;
								_tmp85_ = desktop_agnostic_config_backend_get_float_from_value (&_tmp84_, &_inner_error_);
								_tmp86_ = _tmp85_;
								if (_inner_error_ != NULL) {
									g_propagate_error (error, _inner_error_);
									list = (g_free (list), NULL);
									_g_object_unref0 (option);
									return;
								}
								_tmp87_ = list;
								_tmp87__length1 = list_length1;
								_vala_array_add3 (&list, &list_length1, &_list_size_, (gdouble) _tmp86_);
							}
						}
					}
					_tmp88_ = self->priv->_data;
					_tmp89_ = group;
					_tmp90_ = key;
					_tmp91_ = list;
					_tmp91__length1 = list_length1;
					g_key_file_set_double_list (_tmp88_, _tmp89_, _tmp90_, _tmp91_, _tmp91__length1);
					list = (g_free (list), NULL);
				} else {
					GType _tmp92_;
					_tmp92_ = list_type;
					if (_tmp92_ == G_TYPE_STRING) {
						gchar** _tmp93_ = NULL;
						gchar** list;
						gint list_length1;
						gint _list_size_;
						GValueArray* _tmp94_;
						GKeyFile* _tmp98_;
						const gchar* _tmp99_;
						const gchar* _tmp100_;
						gchar** _tmp101_;
						gint _tmp101__length1;
						_tmp93_ = g_new0 (gchar*, 0 + 1);
						list = _tmp93_;
						list_length1 = 0;
						_list_size_ = list_length1;
						_tmp94_ = value;
						{
							GValueArray* val_collection = NULL;
							guint val_index = 0U;
							val_collection = _tmp94_;
							for (val_index = 0; val_index < val_collection->n_values; val_index = val_index + 1) {
								GValue val = {0};
								val = *g_value_array_get_nth (val_collection, val_index);
								{
									gchar** _tmp95_;
									gint _tmp95__length1;
									GValue _tmp96_;
									gchar* _tmp97_;
									_tmp95_ = list;
									_tmp95__length1 = list_length1;
									_tmp96_ = val;
									_tmp97_ = g_strdup (g_value_get_string (&_tmp96_));
									_vala_array_add4 (&list, &list_length1, &_list_size_, _tmp97_);
								}
							}
						}
						_tmp98_ = self->priv->_data;
						_tmp99_ = group;
						_tmp100_ = key;
						_tmp101_ = list;
						_tmp101__length1 = list_length1;
						g_key_file_set_string_list (_tmp98_, _tmp99_, _tmp100_, (const gchar* const*) _tmp101_, _tmp101__length1);
						list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
					} else {
						GType _tmp102_;
						DesktopAgnosticConfigSchemaType* _tmp103_ = NULL;
						DesktopAgnosticConfigSchemaType* _tmp104_;
						DesktopAgnosticConfigSchemaType* st;
						DesktopAgnosticConfigSchemaType* _tmp105_;
						gchar** _tmp109_ = NULL;
						gchar** list;
						gint list_length1;
						gint _list_size_;
						GValueArray* _tmp110_;
						GKeyFile* _tmp116_;
						const gchar* _tmp117_;
						const gchar* _tmp118_;
						gchar** _tmp119_;
						gint _tmp119__length1;
						_tmp102_ = list_type;
						_tmp103_ = desktop_agnostic_config_schema_find_type (_tmp102_);
						_tmp104_ = _g_object_ref0 (_tmp103_);
						st = _tmp104_;
						_tmp105_ = st;
						if (_tmp105_ == NULL) {
							GType _tmp106_;
							const gchar* _tmp107_ = NULL;
							GError* _tmp108_;
							_tmp106_ = list_type;
							_tmp107_ = g_type_name (_tmp106_);
							_tmp108_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_INVALID_TYPE, "'%s' is an invalid config type.", _tmp107_);
							_inner_error_ = _tmp108_;
							g_propagate_error (error, _inner_error_);
							_g_object_unref0 (st);
							_g_object_unref0 (option);
							return;
						}
						_tmp109_ = g_new0 (gchar*, 0 + 1);
						list = _tmp109_;
						list_length1 = 0;
						_list_size_ = list_length1;
						_tmp110_ = value;
						{
							GValueArray* val_collection = NULL;
							guint val_index = 0U;
							val_collection = _tmp110_;
							for (val_index = 0; val_index < val_collection->n_values; val_index = val_index + 1) {
								GValue val = {0};
								val = *g_value_array_get_nth (val_collection, val_index);
								{
									DesktopAgnosticConfigSchemaType* _tmp111_;
									GValue _tmp112_;
									gchar* _tmp113_ = NULL;
									gchar* _tmp114_;
									gchar** _tmp115_;
									gint _tmp115__length1;
									_tmp111_ = st;
									_tmp112_ = val;
									_tmp113_ = desktop_agnostic_config_schema_type_serialize (_tmp111_, &_tmp112_, &_inner_error_);
									_tmp114_ = _tmp113_;
									if (_inner_error_ != NULL) {
										g_propagate_error (error, _inner_error_);
										list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
										_g_object_unref0 (st);
										_g_object_unref0 (option);
										return;
									}
									_tmp115_ = list;
									_tmp115__length1 = list_length1;
									_vala_array_add5 (&list, &list_length1, &_list_size_, _tmp114_);
								}
							}
						}
						_tmp116_ = self->priv->_data;
						_tmp117_ = group;
						_tmp118_ = key;
						_tmp119_ = list;
						_tmp119__length1 = list_length1;
						g_key_file_set_string_list (_tmp116_, _tmp117_, _tmp118_, (const gchar* const*) _tmp119_, _tmp119__length1);
						list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
						_g_object_unref0 (st);
					}
				}
			}
		}
	}
	_tmp120_ = group;
	_tmp121_ = key;
	desktop_agnostic_config_gkey_file_update_config (self, _tmp120_, _tmp121_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (option);
		return;
	}
	_g_object_unref0 (option);
}


DesktopAgnosticConfigGKeyFile* desktop_agnostic_config_gkey_file_construct (GType object_type) {
	DesktopAgnosticConfigGKeyFile * self = NULL;
	self = (DesktopAgnosticConfigGKeyFile*) desktop_agnostic_config_backend_construct (object_type);
	return self;
}


DesktopAgnosticConfigGKeyFile* desktop_agnostic_config_gkey_file_new (void) {
	return desktop_agnostic_config_gkey_file_construct (DESKTOP_AGNOSTIC_CONFIG_TYPE_GKEY_FILE);
}


static gchar* desktop_agnostic_config_gkey_file_real_get_name (DesktopAgnosticConfigBackend* base) {
	gchar* result;
	DesktopAgnosticConfigGKeyFile* self;
	gchar* _tmp0_;
	self = (DesktopAgnosticConfigGKeyFile*) base;
	_tmp0_ = g_strdup ("GKeyFile");
	result = _tmp0_;
	return result;
}


static GObject * desktop_agnostic_config_gkey_file_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	DesktopAgnosticConfigGKeyFile * self;
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchema* _tmp1_;
	parent_class = G_OBJECT_CLASS (desktop_agnostic_config_gkey_file_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_CONFIG_TYPE_GKEY_FILE, DesktopAgnosticConfigGKeyFile);
	self->priv->_autosave = TRUE;
	self->priv->_monitor_changed_id = (gulong) 0;
	_tmp0_ = desktop_agnostic_config_backend_get_schema ((DesktopAgnosticConfigBackend*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		GKeyFile* _tmp2_;
		_tmp2_ = g_key_file_new ();
		_g_key_file_free0 (self->priv->_data);
		self->priv->_data = _tmp2_;
		g_datalist_init (&self->priv->_notifiers);
	}
	return obj;
}


static void desktop_agnostic_config_gkey_file_class_init (DesktopAgnosticConfigGKeyFileClass * klass) {
	desktop_agnostic_config_gkey_file_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DesktopAgnosticConfigGKeyFilePrivate));
	G_OBJECT_CLASS (klass)->constructed = desktop_agnostic_config_gkey_file_real_constructed;
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->reset = desktop_agnostic_config_gkey_file_real_reset;
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->notify_add = desktop_agnostic_config_gkey_file_real_notify_add;
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->notify = desktop_agnostic_config_gkey_file_real_notify;
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->notify_remove = desktop_agnostic_config_gkey_file_real_notify_remove;
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->remove = desktop_agnostic_config_gkey_file_real_remove;
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->get_value = desktop_agnostic_config_gkey_file_real_get_value;
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->get_bool = desktop_agnostic_config_gkey_file_real_get_bool;
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->set_bool = desktop_agnostic_config_gkey_file_real_set_bool;
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->get_float = desktop_agnostic_config_gkey_file_real_get_float;
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->set_float = desktop_agnostic_config_gkey_file_real_set_float;
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->get_int = desktop_agnostic_config_gkey_file_real_get_int;
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->set_int = desktop_agnostic_config_gkey_file_real_set_int;
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->get_string = desktop_agnostic_config_gkey_file_real_get_string;
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->set_string = desktop_agnostic_config_gkey_file_real_set_string;
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->get_list = desktop_agnostic_config_gkey_file_real_get_list;
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->set_list = desktop_agnostic_config_gkey_file_real_set_list;
	DESKTOP_AGNOSTIC_CONFIG_BACKEND_CLASS (klass)->get_name = desktop_agnostic_config_gkey_file_real_get_name;
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_config_gkey_file_get_property;
	G_OBJECT_CLASS (klass)->constructor = desktop_agnostic_config_gkey_file_constructor;
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_config_gkey_file_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_CONFIG_GKEY_FILE_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void desktop_agnostic_config_gkey_file_instance_init (DesktopAgnosticConfigGKeyFile * self) {
	self->priv = DESKTOP_AGNOSTIC_CONFIG_GKEY_FILE_GET_PRIVATE (self);
}


static void desktop_agnostic_config_gkey_file_finalize (GObject* obj) {
	DesktopAgnosticConfigGKeyFile * self;
	DesktopAgnosticVFSFileMonitor* _tmp0_;
	DesktopAgnosticVFSFileMonitor* _tmp1_;
	gulong _tmp2_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_CONFIG_TYPE_GKEY_FILE, DesktopAgnosticConfigGKeyFile);
	_tmp0_ = self->priv->_keyfile_monitor;
	desktop_agnostic_vfs_file_monitor_cancel (_tmp0_);
	_tmp1_ = self->priv->_keyfile_monitor;
	_tmp2_ = self->priv->_monitor_changed_id;
	g_signal_handler_disconnect (_tmp1_, _tmp2_);
	_g_key_file_free0 (self->priv->_data);
	_g_object_unref0 (self->priv->_keyfile);
	_g_object_unref0 (self->priv->_keyfile_monitor);
	_g_free0 (self->priv->_checksum);
	G_OBJECT_CLASS (desktop_agnostic_config_gkey_file_parent_class)->finalize (obj);
}


GType desktop_agnostic_config_gkey_file_get_type (void) {
	static volatile gsize desktop_agnostic_config_gkey_file_type_id__volatile = 0;
	if (g_once_init_enter (&desktop_agnostic_config_gkey_file_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticConfigGKeyFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_config_gkey_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticConfigGKeyFile), 0, (GInstanceInitFunc) desktop_agnostic_config_gkey_file_instance_init, NULL };
		GType desktop_agnostic_config_gkey_file_type_id;
		desktop_agnostic_config_gkey_file_type_id = g_type_register_static (DESKTOP_AGNOSTIC_CONFIG_TYPE_BACKEND, "DesktopAgnosticConfigGKeyFile", &g_define_type_info, 0);
		g_once_init_leave (&desktop_agnostic_config_gkey_file_type_id__volatile, desktop_agnostic_config_gkey_file_type_id);
	}
	return desktop_agnostic_config_gkey_file_type_id__volatile;
}


static void _vala_desktop_agnostic_config_gkey_file_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DesktopAgnosticConfigGKeyFile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_CONFIG_TYPE_GKEY_FILE, DesktopAgnosticConfigGKeyFile);
	switch (property_id) {
		case DESKTOP_AGNOSTIC_CONFIG_GKEY_FILE_NAME:
		g_value_take_string (value, desktop_agnostic_config_backend_get_name ((DesktopAgnosticConfigBackend*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


GType register_plugin (void) {
	GType result = 0UL;
	result = DESKTOP_AGNOSTIC_CONFIG_TYPE_GKEY_FILE;
	return result;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



