/* config-schema.c generated by valac 0.20.1, the Vala compiler
 * generated from config-schema.vala, do not modify */

/*
 * Desktop Agnostic Library: Configuration Schema.
 *
 * Copyright (C) 2008, 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <hashtable-gtype-key.c>
#include <float.h>
#include <math.h>
#include <glib/gstdio.h>
#include <libdesktop-agnostic/desktop-agnostic.h>
#include <libdesktop-agnostic/vfs.h>


#define DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA (desktop_agnostic_config_schema_get_type ())
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA, DesktopAgnosticConfigSchema))
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA, DesktopAgnosticConfigSchemaClass))
#define DESKTOP_AGNOSTIC_CONFIG_IS_SCHEMA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA))
#define DESKTOP_AGNOSTIC_CONFIG_IS_SCHEMA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA))
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA, DesktopAgnosticConfigSchemaClass))

typedef struct _DesktopAgnosticConfigSchema DesktopAgnosticConfigSchema;
typedef struct _DesktopAgnosticConfigSchemaClass DesktopAgnosticConfigSchemaClass;
typedef struct _DesktopAgnosticConfigSchemaPrivate DesktopAgnosticConfigSchemaPrivate;

#define DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_OPTION (desktop_agnostic_config_schema_option_get_type ())
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_OPTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_OPTION, DesktopAgnosticConfigSchemaOption))
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_OPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_OPTION, DesktopAgnosticConfigSchemaOptionClass))
#define DESKTOP_AGNOSTIC_CONFIG_IS_SCHEMA_OPTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_OPTION))
#define DESKTOP_AGNOSTIC_CONFIG_IS_SCHEMA_OPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_OPTION))
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_OPTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_OPTION, DesktopAgnosticConfigSchemaOptionClass))

typedef struct _DesktopAgnosticConfigSchemaOption DesktopAgnosticConfigSchemaOption;
typedef struct _DesktopAgnosticConfigSchemaOptionClass DesktopAgnosticConfigSchemaOptionClass;

#define DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_TYPE (desktop_agnostic_config_schema_type_get_type ())
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_TYPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_TYPE, DesktopAgnosticConfigSchemaType))
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_TYPE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_TYPE, DesktopAgnosticConfigSchemaTypeClass))
#define DESKTOP_AGNOSTIC_CONFIG_IS_SCHEMA_TYPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_TYPE))
#define DESKTOP_AGNOSTIC_CONFIG_IS_SCHEMA_TYPE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_TYPE))
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_TYPE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_TYPE, DesktopAgnosticConfigSchemaTypeClass))

typedef struct _DesktopAgnosticConfigSchemaType DesktopAgnosticConfigSchemaType;
typedef struct _DesktopAgnosticConfigSchemaTypeClass DesktopAgnosticConfigSchemaTypeClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define __g_list_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_free0_ (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_key_file_free0(var) ((var == NULL) ? NULL : (var = (g_key_file_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __g_slist_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__g_free0_ (var), NULL)))

/**
   * Configuration schema error types.
   */
typedef enum  {
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_PARSE,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_METADATA_OPTION,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_METADATA_TYPE,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_TYPE,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_LIST_TYPE,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_TYPE_NAME_EXISTS,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_TYPE_GTYPE_EXISTS
} DesktopAgnosticConfigSchemaError;
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR desktop_agnostic_config_schema_error_quark ()
struct _DesktopAgnosticConfigSchema {
	GObject parent_instance;
	DesktopAgnosticConfigSchemaPrivate * priv;
};

struct _DesktopAgnosticConfigSchemaClass {
	GObjectClass parent_class;
};

struct _DesktopAgnosticConfigSchemaPrivate {
	gchar* _filename;
	gchar* _app_name;
	GData* options;
	GHashTable* keys;
	GList* valid_metadata_keys;
	GData* metadata_options;
};


static gpointer desktop_agnostic_config_schema_parent_class = NULL;
static GHashTable* desktop_agnostic_config_schema_type_registry;
static GHashTable* desktop_agnostic_config_schema_type_registry = NULL;
static GHashTable* desktop_agnostic_config_schema_name_registry;
static GHashTable* desktop_agnostic_config_schema_name_registry = NULL;
static GHashTable* desktop_agnostic_config_schema_common_metadata_keys;
static GHashTable* desktop_agnostic_config_schema_common_metadata_keys = NULL;

GQuark desktop_agnostic_config_schema_error_quark (void);
GType desktop_agnostic_config_schema_get_type (void) G_GNUC_CONST;
GType desktop_agnostic_config_schema_option_get_type (void) G_GNUC_CONST;
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA, DesktopAgnosticConfigSchemaPrivate))
enum  {
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_DUMMY_PROPERTY,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_FILENAME,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_APP_NAME
};
GType desktop_agnostic_config_schema_type_get_type (void) G_GNUC_CONST;
static void _g_object_unref0_ (gpointer var);
static void _g_free0_ (gpointer var);
static void _vala_GValue_free (GValue* self);
static void __vala_GValue_free0_ (gpointer var);
static void _g_list_free__g_free0_ (GList* self);
DesktopAgnosticConfigSchema* desktop_agnostic_config_schema_new (const gchar* filename, GError** error);
DesktopAgnosticConfigSchema* desktop_agnostic_config_schema_construct (GType object_type, const gchar* filename, GError** error);
static void __g_list_free__g_free0_0_ (gpointer var);
static GValue* _g_value_dup (GValue* self);
GHashTable* desktop_agnostic_config_backend_get_backend_metadata_keys (void);
static void desktop_agnostic_config_schema_parse (DesktopAgnosticConfigSchema* self, GError** error);
gboolean desktop_agnostic_config_schema_exists (DesktopAgnosticConfigSchema* self, const gchar* group, const gchar* key);
DesktopAgnosticConfigSchemaOption* desktop_agnostic_config_schema_option_new (GKeyFile** schema, const gchar* group, const gchar* key, GError** error);
DesktopAgnosticConfigSchemaOption* desktop_agnostic_config_schema_option_construct (GType object_type, GKeyFile** schema, const gchar* group, const gchar* key, GError** error);
#define DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT "DEFAULT"
GList* desktop_agnostic_config_schema_get_groups (DesktopAgnosticConfigSchema* self);
GList* desktop_agnostic_config_schema_get_keys (DesktopAgnosticConfigSchema* self, const gchar* group);
DesktopAgnosticConfigSchemaOption* desktop_agnostic_config_schema_get_option (DesktopAgnosticConfigSchema* self, const gchar* group, const gchar* key);
GValue* desktop_agnostic_config_schema_get_metadata_option (DesktopAgnosticConfigSchema* self, const gchar* name, GError** error);
void desktop_agnostic_config_schema_register_type (DesktopAgnosticConfigSchemaType* st, GError** error);
GType desktop_agnostic_config_schema_type_get_schema_type (DesktopAgnosticConfigSchemaType* self);
gchar* desktop_agnostic_config_schema_type_get_name (DesktopAgnosticConfigSchemaType* self);
DesktopAgnosticConfigSchemaType* desktop_agnostic_config_schema_find_type (GType type);
DesktopAgnosticConfigSchemaType* desktop_agnostic_config_schema_find_type_by_name (const gchar* name);
static void desktop_agnostic_config_schema_set_filename (DesktopAgnosticConfigSchema* self, const gchar* value);
static void desktop_agnostic_config_schema_set_app_name (DesktopAgnosticConfigSchema* self, const gchar* value);
const gchar* desktop_agnostic_config_schema_get_app_name (DesktopAgnosticConfigSchema* self);
GType desktop_agnostic_config_get_type (GError** error);
static void _g_slist_free__g_free0_ (GSList* self);
static void desktop_agnostic_config_schema_finalize (GObject* obj);
static void _vala_desktop_agnostic_config_schema_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_desktop_agnostic_config_schema_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


GQuark desktop_agnostic_config_schema_error_quark (void) {
	return g_quark_from_static_string ("desktop_agnostic_config_schema_error-quark");
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _vala_GValue_free (GValue* self) {
	g_value_unset (self);
	g_free (self);
}


static void __vala_GValue_free0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
}


static void _g_list_free__g_free0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_free0_, NULL);
	g_list_free (self);
}


/**
     * Creates a new Schema object.
     * @param filename the name of the schema file to parse
     */
static void __g_list_free__g_free0_0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (_g_list_free__g_free0_ (var), NULL));
}


static GValue* _g_value_dup (GValue* self) {
	return g_boxed_copy (G_TYPE_VALUE, self);
}


static gpointer __g_value_dup0 (gpointer self) {
	return self ? _g_value_dup (self) : NULL;
}


DesktopAgnosticConfigSchema* desktop_agnostic_config_schema_construct (GType object_type, const gchar* filename, GError** error) {
	DesktopAgnosticConfigSchema * self = NULL;
	const gchar* _tmp0_;
	GHashTable* backend_metadata_keys = NULL;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
	GHashTable* _tmp4_;
	GList* _tmp5_ = NULL;
	GHashTable* _tmp13_ = NULL;
	GHashTable* _tmp14_;
	GList* _tmp15_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (filename != NULL, NULL);
	_tmp0_ = filename;
	self = (DesktopAgnosticConfigSchema*) g_object_new (object_type, "filename", _tmp0_, NULL);
	g_datalist_init (&self->priv->options);
	_tmp1_ = g_str_hash;
	_tmp2_ = g_str_equal;
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, __g_list_free__g_free0_0_);
	_g_hash_table_unref0 (self->priv->keys);
	self->priv->keys = _tmp3_;
	__g_list_free__g_free0_0 (self->priv->valid_metadata_keys);
	self->priv->valid_metadata_keys = NULL;
	g_datalist_init (&self->priv->metadata_options);
	_tmp4_ = desktop_agnostic_config_schema_common_metadata_keys;
	_tmp5_ = g_hash_table_get_keys (_tmp4_);
	{
		GList* key_collection = NULL;
		GList* key_it = NULL;
		key_collection = _tmp5_;
		for (key_it = key_collection; key_it != NULL; key_it = key_it->next) {
			const gchar* key = NULL;
			key = (const gchar*) key_it->data;
			{
				const gchar* _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_;
				GHashTable* _tmp9_;
				const gchar* _tmp10_;
				gconstpointer _tmp11_ = NULL;
				GValue* _tmp12_;
				_tmp6_ = key;
				_tmp7_ = g_strdup (_tmp6_);
				self->priv->valid_metadata_keys = g_list_append (self->priv->valid_metadata_keys, _tmp7_);
				_tmp8_ = key;
				_tmp9_ = desktop_agnostic_config_schema_common_metadata_keys;
				_tmp10_ = key;
				_tmp11_ = g_hash_table_lookup (_tmp9_, _tmp10_);
				_tmp12_ = __g_value_dup0 ((GValue*) _tmp11_);
				g_datalist_set_data (&self->priv->metadata_options, _tmp8_, _tmp12_);
			}
		}
		_g_list_free0 (key_collection);
	}
	_tmp13_ = desktop_agnostic_config_backend_get_backend_metadata_keys ();
	backend_metadata_keys = _tmp13_;
	_tmp14_ = backend_metadata_keys;
	_tmp15_ = g_hash_table_get_keys (_tmp14_);
	{
		GList* key_collection = NULL;
		GList* key_it = NULL;
		key_collection = _tmp15_;
		for (key_it = key_collection; key_it != NULL; key_it = key_it->next) {
			const gchar* key = NULL;
			key = (const gchar*) key_it->data;
			{
				const gchar* _tmp16_;
				gchar* _tmp17_;
				const gchar* _tmp18_;
				GHashTable* _tmp19_;
				const gchar* _tmp20_;
				gconstpointer _tmp21_ = NULL;
				GValue* _tmp22_;
				_tmp16_ = key;
				_tmp17_ = g_strdup (_tmp16_);
				self->priv->valid_metadata_keys = g_list_append (self->priv->valid_metadata_keys, _tmp17_);
				_tmp18_ = key;
				_tmp19_ = backend_metadata_keys;
				_tmp20_ = key;
				_tmp21_ = g_hash_table_lookup (_tmp19_, _tmp20_);
				_tmp22_ = __g_value_dup0 ((GValue*) _tmp21_);
				g_datalist_set_data (&self->priv->metadata_options, _tmp18_, _tmp22_);
			}
		}
		_g_list_free0 (key_collection);
	}
	desktop_agnostic_config_schema_parse (self, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (self);
		return NULL;
	}
	return self;
}


DesktopAgnosticConfigSchema* desktop_agnostic_config_schema_new (const gchar* filename, GError** error) {
	return desktop_agnostic_config_schema_construct (DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA, filename, error);
}


/**
     * Parses the schema file for configuration options and metadata.
     */
static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


static glong string_pointer_to_offset (const gchar* self, const gchar* pos) {
	glong result = 0L;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, 0L);
	g_return_val_if_fail (pos != NULL, 0L);
	_tmp0_ = pos;
	result = (glong) (((gchar*) _tmp0_) - ((gchar*) self));
	return result;
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* end;
	gchar* _tmp3_;
	_tmp0_ = str;
	_tmp1_ = maxlen;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	end = _tmp2_;
	_tmp3_ = end;
	if (_tmp3_ == NULL) {
		glong _tmp4_;
		_tmp4_ = maxlen;
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = end;
		_tmp6_ = str;
		result = (glong) (_tmp5_ - _tmp6_);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	gboolean _tmp3_;
	glong _tmp9_;
	glong _tmp15_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = offset;
	if (_tmp1_ >= ((glong) 0)) {
		glong _tmp2_;
		_tmp2_ = len;
		_tmp0_ = _tmp2_ >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		glong _tmp4_;
		glong _tmp5_;
		glong _tmp6_ = 0L;
		_tmp4_ = offset;
		_tmp5_ = len;
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
		string_length = _tmp6_;
	} else {
		gint _tmp7_;
		gint _tmp8_;
		_tmp7_ = strlen (self);
		_tmp8_ = _tmp7_;
		string_length = (glong) _tmp8_;
	}
	_tmp9_ = offset;
	if (_tmp9_ < ((glong) 0)) {
		glong _tmp10_;
		glong _tmp11_;
		glong _tmp12_;
		_tmp10_ = string_length;
		_tmp11_ = offset;
		offset = _tmp10_ + _tmp11_;
		_tmp12_ = offset;
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
	} else {
		glong _tmp13_;
		glong _tmp14_;
		_tmp13_ = offset;
		_tmp14_ = string_length;
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
	}
	_tmp15_ = len;
	if (_tmp15_ < ((glong) 0)) {
		glong _tmp16_;
		glong _tmp17_;
		_tmp16_ = string_length;
		_tmp17_ = offset;
		len = _tmp16_ - _tmp17_;
	}
	_tmp18_ = offset;
	_tmp19_ = len;
	_tmp20_ = string_length;
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
	_tmp21_ = offset;
	_tmp22_ = len;
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
	result = _tmp23_;
	return result;
}


static const gchar* string_offset (const gchar* self, glong offset) {
	const gchar* result = NULL;
	glong _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = offset;
	result = (const gchar*) (((gchar*) self) + _tmp0_);
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void desktop_agnostic_config_schema_parse (DesktopAgnosticConfigSchema* self, GError** error) {
	const gchar* _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_filename;
	if (_tmp0_ == NULL) {
		GError* _tmp1_;
		_tmp1_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_PARSE, "A (valid) schema file was not given.");
		_inner_error_ = _tmp1_;
		g_propagate_error (error, _inner_error_);
		return;
	} else {
		GKeyFile* _tmp2_;
		GKeyFile* data;
		GKeyFile* _tmp3_;
		const gchar* _tmp4_;
		GKeyFile* _tmp5_;
		gsize _tmp6_;
		gchar** _tmp7_ = NULL;
		_tmp2_ = g_key_file_new ();
		data = _tmp2_;
		_tmp3_ = data;
		_tmp4_ = self->priv->_filename;
		g_key_file_load_from_file (_tmp3_, _tmp4_, G_KEY_FILE_KEEP_TRANSLATIONS, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_key_file_free0 (data);
			return;
		}
		_tmp5_ = data;
		_tmp7_ = g_key_file_get_groups (_tmp5_, &_tmp6_);
		{
			gchar** group_collection = NULL;
			gint group_collection_length1 = 0;
			gint _group_collection_size_ = 0;
			gint group_it = 0;
			group_collection = _tmp7_;
			group_collection_length1 = _tmp6_;
			for (group_it = 0; group_it < _tmp6_; group_it = group_it + 1) {
				const gchar* group = NULL;
				group = group_collection[group_it];
				{
					const gchar* _tmp8_;
					gboolean _tmp9_ = FALSE;
					_tmp8_ = group;
					_tmp9_ = string_contains (_tmp8_, "/");
					if (_tmp9_) {
						const gchar* _tmp10_;
						const gchar* _tmp11_;
						gint _tmp12_;
						gint _tmp13_;
						const gchar* _tmp14_ = NULL;
						const gchar* last_slash;
						const gchar* _tmp15_;
						const gchar* _tmp16_;
						glong _tmp17_ = 0L;
						glong offset;
						const gchar* _tmp18_;
						glong _tmp19_;
						gchar* _tmp20_ = NULL;
						gchar* option_group;
						const gchar* _tmp21_;
						glong _tmp22_;
						const gchar* _tmp23_ = NULL;
						const gchar* option_key;
						GHashTable* _tmp24_;
						const gchar* _tmp25_;
						gconstpointer _tmp26_ = NULL;
						GList* list;
						GList* _tmp27_;
						const gchar* _tmp42_;
						const gchar* _tmp43_;
						DesktopAgnosticConfigSchemaOption* _tmp44_;
						DesktopAgnosticConfigSchemaOption* option;
						const gchar* _tmp45_;
						DesktopAgnosticConfigSchemaOption* _tmp46_;
						DesktopAgnosticConfigSchemaOption* _tmp47_;
						_tmp10_ = group;
						_tmp11_ = group;
						_tmp12_ = strlen (_tmp11_);
						_tmp13_ = _tmp12_;
						_tmp14_ = g_utf8_strrchr (_tmp10_, (gssize) _tmp13_, (gunichar) '/');
						last_slash = _tmp14_;
						_tmp15_ = group;
						_tmp16_ = last_slash;
						_tmp17_ = string_pointer_to_offset (_tmp15_, _tmp16_);
						offset = _tmp17_;
						_tmp18_ = group;
						_tmp19_ = offset;
						_tmp20_ = string_substring (_tmp18_, (glong) 0, _tmp19_);
						option_group = _tmp20_;
						_tmp21_ = group;
						_tmp22_ = offset;
						_tmp23_ = string_offset (_tmp21_, _tmp22_ + 1);
						option_key = _tmp23_;
						_tmp24_ = self->priv->keys;
						_tmp25_ = option_group;
						_tmp26_ = g_hash_table_lookup (_tmp24_, _tmp25_);
						list = (GList*) _tmp26_;
						_tmp27_ = list;
						if (_tmp27_ == NULL) {
							GList* key_list;
							const gchar* _tmp28_;
							gchar* _tmp29_;
							GHashTable* _tmp30_;
							const gchar* _tmp31_;
							gchar* _tmp32_;
							GList* _tmp33_;
							key_list = NULL;
							_tmp28_ = option_key;
							_tmp29_ = g_strdup (_tmp28_);
							key_list = g_list_append (key_list, _tmp29_);
							_tmp30_ = self->priv->keys;
							_tmp31_ = option_group;
							_tmp32_ = g_strdup (_tmp31_);
							_tmp33_ = key_list;
							key_list = NULL;
							g_hash_table_insert (_tmp30_, _tmp32_, _tmp33_);
							__g_list_free__g_free0_0 (key_list);
						} else {
							const gchar* _tmp34_;
							const gchar* _tmp35_;
							gboolean _tmp36_ = FALSE;
							_tmp34_ = option_group;
							_tmp35_ = option_key;
							_tmp36_ = desktop_agnostic_config_schema_exists (self, _tmp34_, _tmp35_);
							if (!_tmp36_) {
								const gchar* _tmp37_;
								gchar* _tmp38_;
								_tmp37_ = option_key;
								_tmp38_ = g_strdup (_tmp37_);
								list = g_list_append (list, _tmp38_);
							} else {
								const gchar* _tmp39_;
								const gchar* _tmp40_;
								GError* _tmp41_;
								_tmp39_ = option_group;
								_tmp40_ = option_key;
								_tmp41_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_PARSE, "Duplicate key found in '%s': %s", _tmp39_, _tmp40_);
								_inner_error_ = _tmp41_;
								g_propagate_error (error, _inner_error_);
								_g_free0 (option_group);
								group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
								_g_key_file_free0 (data);
								return;
							}
						}
						_tmp42_ = option_group;
						_tmp43_ = option_key;
						_tmp44_ = desktop_agnostic_config_schema_option_new (&data, _tmp42_, _tmp43_, &_inner_error_);
						option = _tmp44_;
						if (_inner_error_ != NULL) {
							g_propagate_error (error, _inner_error_);
							_g_free0 (option_group);
							group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
							_g_key_file_free0 (data);
							return;
						}
						_tmp45_ = group;
						_tmp46_ = option;
						_tmp47_ = _g_object_ref0 (_tmp46_);
						g_datalist_set_data (&self->priv->options, _tmp45_, _tmp47_);
						_g_object_unref0 (option);
						_g_free0 (option_group);
					} else {
						const gchar* _tmp48_;
						_tmp48_ = group;
						if (g_strcmp0 (_tmp48_, DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT) == 0) {
							GKeyFile* _tmp49_;
							const gchar* _tmp50_;
							gsize _tmp51_;
							gchar** _tmp52_ = NULL;
							gchar** _tmp53_;
							gint _tmp53__length1;
							gint __tmp53__size_;
							_tmp49_ = data;
							_tmp50_ = group;
							_tmp52_ = g_key_file_get_keys (_tmp49_, _tmp50_, &_tmp51_, &_inner_error_);
							_tmp53_ = _tmp52_;
							_tmp53__length1 = _tmp51_;
							__tmp53__size_ = _tmp53__length1;
							if (_inner_error_ != NULL) {
								g_propagate_error (error, _inner_error_);
								group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
								_g_key_file_free0 (data);
								return;
							}
							{
								gchar** key_collection = NULL;
								gint key_collection_length1 = 0;
								gint _key_collection_size_ = 0;
								gint key_it = 0;
								key_collection = _tmp53_;
								key_collection_length1 = _tmp53__length1;
								for (key_it = 0; key_it < _tmp53__length1; key_it = key_it + 1) {
									const gchar* key = NULL;
									key = key_collection[key_it];
									{
										GList* _tmp54_;
										const gchar* _tmp55_;
										GCompareFunc _tmp56_;
										GList* _tmp57_ = NULL;
										_tmp54_ = self->priv->valid_metadata_keys;
										_tmp55_ = key;
										_tmp56_ = g_strcmp0;
										_tmp57_ = g_list_find_custom (_tmp54_, _tmp55_, (GCompareFunc) _tmp56_);
										if (_tmp57_ == NULL) {
											const gchar* _tmp58_;
											GError* _tmp59_;
											_tmp58_ = key;
											_tmp59_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_METADATA_OPTION, "The option '%s' is not a registered metadata option.", _tmp58_);
											_inner_error_ = _tmp59_;
											g_propagate_error (error, _inner_error_);
											key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
											group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
											_g_key_file_free0 (data);
											return;
										} else {
											GValue cur_val = {0};
											GValue new_val = {0};
											GType cur_val_type = 0UL;
											const gchar* _tmp60_;
											gconstpointer _tmp61_ = NULL;
											GValue _tmp62_ = {0};
											GType _tmp63_ = 0UL;
											GType _tmp64_;
											GValue _tmp65_ = {0};
											GValue _tmp66_;
											GType _tmp67_;
											const gchar* _tmp93_;
											GValue _tmp94_;
											GValue _tmp95_;
											GValue* _tmp96_;
											_tmp60_ = key;
											_tmp61_ = g_datalist_get_data (&self->priv->metadata_options, _tmp60_);
											if (G_IS_VALUE ((GValue*) _tmp61_)) {
												g_value_init (&_tmp62_, G_VALUE_TYPE ((GValue*) _tmp61_));
												g_value_copy ((GValue*) _tmp61_, &_tmp62_);
											} else {
												_tmp62_ = *((GValue*) _tmp61_);
											}
											G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
											cur_val = _tmp62_;
											_tmp63_ = G_VALUE_TYPE (&cur_val);
											cur_val_type = _tmp63_;
											_tmp64_ = cur_val_type;
											g_value_init (&_tmp65_, _tmp64_);
											G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
											new_val = _tmp65_;
											_tmp66_ = new_val;
											_tmp67_ = cur_val_type;
											if (_tmp67_ == G_TYPE_BOOLEAN) {
												GKeyFile* _tmp68_;
												const gchar* _tmp69_;
												const gchar* _tmp70_;
												gboolean _tmp71_ = FALSE;
												gboolean _tmp72_;
												_tmp68_ = data;
												_tmp69_ = group;
												_tmp70_ = key;
												_tmp71_ = g_key_file_get_boolean (_tmp68_, _tmp69_, _tmp70_, &_inner_error_);
												_tmp72_ = _tmp71_;
												if (_inner_error_ != NULL) {
													g_propagate_error (error, _inner_error_);
													G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
													G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
													key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
													group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
													_g_key_file_free0 (data);
													return;
												}
												g_value_set_boolean (&new_val, _tmp72_);
											} else {
												GType _tmp73_;
												_tmp73_ = cur_val_type;
												if (_tmp73_ == G_TYPE_INT) {
													GKeyFile* _tmp74_;
													const gchar* _tmp75_;
													const gchar* _tmp76_;
													gint _tmp77_ = 0;
													gint _tmp78_;
													_tmp74_ = data;
													_tmp75_ = group;
													_tmp76_ = key;
													_tmp77_ = g_key_file_get_integer (_tmp74_, _tmp75_, _tmp76_, &_inner_error_);
													_tmp78_ = _tmp77_;
													if (_inner_error_ != NULL) {
														g_propagate_error (error, _inner_error_);
														G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
														G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
														key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
														group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
														_g_key_file_free0 (data);
														return;
													}
													g_value_set_int (&new_val, _tmp78_);
												} else {
													GType _tmp79_;
													_tmp79_ = cur_val_type;
													if (_tmp79_ == G_TYPE_FLOAT) {
														GKeyFile* _tmp80_;
														const gchar* _tmp81_;
														const gchar* _tmp82_;
														gdouble _tmp83_ = 0.0;
														gdouble _tmp84_;
														_tmp80_ = data;
														_tmp81_ = group;
														_tmp82_ = key;
														_tmp83_ = g_key_file_get_double (_tmp80_, _tmp81_, _tmp82_, &_inner_error_);
														_tmp84_ = _tmp83_;
														if (_inner_error_ != NULL) {
															g_propagate_error (error, _inner_error_);
															G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
															G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
															key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
															group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
															_g_key_file_free0 (data);
															return;
														}
														g_value_set_float (&new_val, (gfloat) _tmp84_);
													} else {
														GType _tmp85_;
														_tmp85_ = cur_val_type;
														if (_tmp85_ == G_TYPE_STRING) {
															GKeyFile* _tmp86_;
															const gchar* _tmp87_;
															const gchar* _tmp88_;
															gchar* _tmp89_ = NULL;
															gchar* _tmp90_;
															gchar* _tmp91_;
															_tmp86_ = data;
															_tmp87_ = group;
															_tmp88_ = key;
															_tmp89_ = g_key_file_get_string (_tmp86_, _tmp87_, _tmp88_, &_inner_error_);
															_tmp90_ = _tmp89_;
															if (_inner_error_ != NULL) {
																g_propagate_error (error, _inner_error_);
																G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
																G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
																key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
																group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
																_g_key_file_free0 (data);
																return;
															}
															_tmp91_ = _tmp90_;
															g_value_set_string (&new_val, _tmp91_);
															_g_free0 (_tmp91_);
														} else {
															GError* _tmp92_;
															_tmp92_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_METADATA_TYPE, "The metadata option type can only be a simple type.");
															_inner_error_ = _tmp92_;
															g_propagate_error (error, _inner_error_);
															G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
															G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
															key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
															group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
															_g_key_file_free0 (data);
															return;
														}
													}
												}
											}
											_tmp93_ = key;
											_tmp94_ = new_val;
											_tmp95_ = _tmp94_;
											_tmp96_ = __g_value_dup0 (&_tmp95_);
											g_datalist_set_data (&self->priv->metadata_options, _tmp93_, _tmp96_);
											G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
											G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
										}
									}
								}
								key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
							}
						} else {
							const gchar* _tmp97_;
							const gchar* _tmp98_;
							GError* _tmp99_;
							_tmp97_ = self->priv->_filename;
							_tmp98_ = group;
							_tmp99_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_PARSE, "Invalid section in schema ('%s'), there is no group name: %s", _tmp97_, _tmp98_);
							_inner_error_ = _tmp99_;
							g_propagate_error (error, _inner_error_);
							group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
							_g_key_file_free0 (data);
							return;
						}
					}
				}
			}
			group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
		}
		_g_key_file_free0 (data);
	}
}


/**
     * Retrieves the configuration groups in the schema.
     * @return a list of zero or more groups
     */
GList* desktop_agnostic_config_schema_get_groups (DesktopAgnosticConfigSchema* self) {
	GList* result = NULL;
	GHashTable* _tmp0_;
	GList* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->keys;
	_tmp1_ = g_hash_table_get_keys (_tmp0_);
	result = _tmp1_;
	return result;
}


/**
     * Retrieves the configuration keys for a specified group in the schema.
     * @param group the group name to search for keys associated with it
     * @return a list of zero or more keys
     */
GList* desktop_agnostic_config_schema_get_keys (DesktopAgnosticConfigSchema* self, const gchar* group) {
	GList* result = NULL;
	GHashTable* _tmp0_;
	const gchar* _tmp1_;
	gconstpointer _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (group != NULL, NULL);
	_tmp0_ = self->priv->keys;
	_tmp1_ = group;
	_tmp2_ = g_hash_table_lookup (_tmp0_, _tmp1_);
	result = (GList*) _tmp2_;
	return result;
}


/**
     * Determines if a specified group/key exists in the schema.
     * @param group the group that the key is associated with
     * @param key the configuration key to determine if it exists
     * @return whether the group/key exists
     */
gboolean desktop_agnostic_config_schema_exists (DesktopAgnosticConfigSchema* self, const gchar* group, const gchar* key) {
	gboolean result = FALSE;
	GHashTable* _tmp0_;
	const gchar* _tmp1_;
	gconstpointer _tmp2_ = NULL;
	GList* group_keys;
	gboolean _tmp3_ = FALSE;
	GList* _tmp4_;
	gboolean _tmp9_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (group != NULL, FALSE);
	g_return_val_if_fail (key != NULL, FALSE);
	_tmp0_ = self->priv->keys;
	_tmp1_ = group;
	_tmp2_ = g_hash_table_lookup (_tmp0_, _tmp1_);
	group_keys = (GList*) _tmp2_;
	_tmp4_ = group_keys;
	if (_tmp4_ != NULL) {
		GList* _tmp5_;
		const gchar* _tmp6_;
		GCompareFunc _tmp7_;
		GList* _tmp8_ = NULL;
		_tmp5_ = group_keys;
		_tmp6_ = key;
		_tmp7_ = g_strcmp0;
		_tmp8_ = g_list_find_custom (_tmp5_, _tmp6_, (GCompareFunc) _tmp7_);
		_tmp3_ = _tmp8_ != NULL;
	} else {
		_tmp3_ = FALSE;
	}
	_tmp9_ = _tmp3_;
	result = _tmp9_;
	return result;
}


/**
     * Retrieves the metadata associated with a specific group/key.
     * @param group the group that the key is associated with
     * @param key the configuration key to retrieve metadata from
     * @return an object which contains the option metadata
     */
DesktopAgnosticConfigSchemaOption* desktop_agnostic_config_schema_get_option (DesktopAgnosticConfigSchema* self, const gchar* group, const gchar* key) {
	DesktopAgnosticConfigSchemaOption* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* full_key;
	gconstpointer _tmp6_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (group != NULL, NULL);
	g_return_val_if_fail (key != NULL, NULL);
	_tmp0_ = group;
	_tmp1_ = g_strconcat (_tmp0_, "/", NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = key;
	_tmp4_ = g_strconcat (_tmp2_, _tmp3_, NULL);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp2_);
	full_key = _tmp5_;
	_tmp6_ = g_datalist_get_data (&self->priv->options, full_key);
	result = (DesktopAgnosticConfigSchemaOption*) _tmp6_;
	_g_free0 (full_key);
	return result;
}


/**
     * Retrieves the value of the specified metadata option.
     * @throws SchemaError if the option named specified is not registered
     */
GValue* desktop_agnostic_config_schema_get_metadata_option (DesktopAgnosticConfigSchema* self, const gchar* name, GError** error) {
	GValue* result = NULL;
	GList* _tmp0_;
	const gchar* _tmp1_;
	GCompareFunc _tmp2_;
	GList* _tmp3_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = self->priv->valid_metadata_keys;
	_tmp1_ = name;
	_tmp2_ = g_strcmp0;
	_tmp3_ = g_list_find_custom (_tmp0_, _tmp1_, (GCompareFunc) _tmp2_);
	if (_tmp3_ == NULL) {
		const gchar* _tmp4_;
		GError* _tmp5_;
		_tmp4_ = name;
		_tmp5_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_METADATA_OPTION, "The option '%s' is not a registered metadata option.", _tmp4_);
		_inner_error_ = _tmp5_;
		if (_inner_error_->domain == DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	} else {
		const gchar* _tmp6_;
		gconstpointer _tmp7_ = NULL;
		GValue* _tmp8_;
		_tmp6_ = name;
		_tmp7_ = g_datalist_get_data (&self->priv->metadata_options, _tmp6_);
		_tmp8_ = __g_value_dup0 ((GValue*) _tmp7_);
		result = _tmp8_;
		return result;
	}
}


/**
     * Registers a configuration schema type with the class. This is usually
     * not called manually - the class loads all of the configuration schema
     * type modules that it can find when the class is first instantiated.
     */
void desktop_agnostic_config_schema_register_type (DesktopAgnosticConfigSchemaType* st, GError** error) {
	GHashTable* _tmp0_;
	DesktopAgnosticConfigSchemaType* _tmp1_;
	GType _tmp2_;
	GType _tmp3_;
	gconstpointer _tmp4_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (st != NULL);
	_tmp0_ = desktop_agnostic_config_schema_type_registry;
	_tmp1_ = st;
	_tmp2_ = desktop_agnostic_config_schema_type_get_schema_type (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) _tmp3_));
	if (((DesktopAgnosticConfigSchemaType*) _tmp4_) != NULL) {
		GError* _tmp5_;
		_tmp5_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_TYPE_GTYPE_EXISTS, "The GType associated with the SchemaType is already registered.");
		_inner_error_ = _tmp5_;
		if (_inner_error_->domain == DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	} else {
		GHashTable* _tmp6_;
		DesktopAgnosticConfigSchemaType* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gconstpointer _tmp11_ = NULL;
		gboolean _tmp12_;
		_tmp6_ = desktop_agnostic_config_schema_name_registry;
		_tmp7_ = st;
		_tmp8_ = desktop_agnostic_config_schema_type_get_name (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = _tmp9_;
		_tmp11_ = g_hash_table_lookup (_tmp6_, _tmp10_);
		_tmp12_ = ((DesktopAgnosticConfigSchemaType*) _tmp11_) != NULL;
		_g_free0 (_tmp10_);
		if (_tmp12_) {
			GError* _tmp13_;
			_tmp13_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_TYPE_NAME_EXISTS, "The name associated with the SchemaType is already registered.");
			_inner_error_ = _tmp13_;
			if (_inner_error_->domain == DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR) {
				g_propagate_error (error, _inner_error_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		} else {
			GHashTable* _tmp14_;
			DesktopAgnosticConfigSchemaType* _tmp15_;
			GType _tmp16_;
			GType _tmp17_;
			DesktopAgnosticConfigSchemaType* _tmp18_;
			DesktopAgnosticConfigSchemaType* _tmp19_;
			GHashTable* _tmp20_;
			DesktopAgnosticConfigSchemaType* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			DesktopAgnosticConfigSchemaType* _tmp24_;
			DesktopAgnosticConfigSchemaType* _tmp25_;
			_tmp14_ = desktop_agnostic_config_schema_type_registry;
			_tmp15_ = st;
			_tmp16_ = desktop_agnostic_config_schema_type_get_schema_type (_tmp15_);
			_tmp17_ = _tmp16_;
			_tmp18_ = st;
			_tmp19_ = _g_object_ref0 (_tmp18_);
			g_hash_table_insert (_tmp14_, (gpointer) ((gintptr) _tmp17_), _tmp19_);
			_tmp20_ = desktop_agnostic_config_schema_name_registry;
			_tmp21_ = st;
			_tmp22_ = desktop_agnostic_config_schema_type_get_name (_tmp21_);
			_tmp23_ = _tmp22_;
			_tmp24_ = st;
			_tmp25_ = _g_object_ref0 (_tmp24_);
			g_hash_table_insert (_tmp20_, _tmp23_, _tmp25_);
		}
	}
}


/**
     * Looks for a registered SchemaType by its GType.
     */
DesktopAgnosticConfigSchemaType* desktop_agnostic_config_schema_find_type (GType type) {
	DesktopAgnosticConfigSchemaType* result = NULL;
	GHashTable* _tmp0_;
	GType _tmp1_;
	gconstpointer _tmp2_ = NULL;
	_tmp0_ = desktop_agnostic_config_schema_type_registry;
	_tmp1_ = type;
	_tmp2_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) _tmp1_));
	result = (DesktopAgnosticConfigSchemaType*) _tmp2_;
	return result;
}


/**
     * Looks for a registered SchemaType by its declared name.
     */
DesktopAgnosticConfigSchemaType* desktop_agnostic_config_schema_find_type_by_name (const gchar* name) {
	DesktopAgnosticConfigSchemaType* result = NULL;
	GHashTable* _tmp0_;
	const gchar* _tmp1_;
	gconstpointer _tmp2_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = desktop_agnostic_config_schema_name_registry;
	_tmp1_ = name;
	_tmp2_ = g_hash_table_lookup (_tmp0_, _tmp1_);
	result = (DesktopAgnosticConfigSchemaType*) _tmp2_;
	return result;
}


static void desktop_agnostic_config_schema_set_filename (DesktopAgnosticConfigSchema* self, const gchar* value) {
	gchar* basename;
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_ = NULL;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_;
	g_return_if_fail (self != NULL);
	basename = NULL;
	_tmp0_ = value;
	_tmp1_ = g_str_has_suffix (_tmp0_, ".schema-ini");
	if (!_tmp1_) {
		g_critical ("config-schema.vala:166: Schema files MUST have the extension '.schema-" \
"ini'.");
		_g_free0 (basename);
		return;
	}
	_tmp2_ = value;
	_tmp3_ = g_file_test (_tmp2_, G_FILE_TEST_EXISTS);
	if (!_tmp3_) {
		const gchar* _tmp4_;
		_tmp4_ = value;
		g_critical ("config-schema.vala:171: The file '%s' could not be found.", _tmp4_);
		_g_free0 (basename);
		return;
	}
	_tmp5_ = value;
	_tmp6_ = g_strdup (_tmp5_);
	_g_free0 (self->priv->_filename);
	self->priv->_filename = _tmp6_;
	_tmp7_ = value;
	_tmp8_ = g_path_get_basename (_tmp7_);
	_g_free0 (basename);
	basename = _tmp8_;
	_tmp9_ = basename;
	_tmp10_ = basename;
	_tmp11_ = strlen (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = string_substring (_tmp9_, (glong) 0, (glong) (_tmp12_ - 11));
	_tmp14_ = _tmp13_;
	desktop_agnostic_config_schema_set_app_name (self, _tmp14_);
	_g_free0 (_tmp14_);
	_g_free0 (basename);
	g_object_notify ((GObject *) self, "filename");
}


const gchar* desktop_agnostic_config_schema_get_app_name (DesktopAgnosticConfigSchema* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_app_name;
	result = _tmp0_;
	return result;
}


static void desktop_agnostic_config_schema_set_app_name (DesktopAgnosticConfigSchema* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_app_name);
	self->priv->_app_name = _tmp1_;
	g_object_notify ((GObject *) self, "app-name");
}


static void _g_slist_free__g_free0_ (GSList* self) {
	g_slist_foreach (self, (GFunc) _g_free0_, NULL);
	g_slist_free (self);
}


static void desktop_agnostic_config_schema_class_init (DesktopAgnosticConfigSchemaClass * klass) {
	GHashTable* _tmp0_;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
	GHashFunc _tmp4_;
	GEqualFunc _tmp5_;
	GHashTable* _tmp6_;
	GList* type_modules = NULL;
	gchar** paths = NULL;
	gint paths_length1 = 0;
	gint _paths_size_ = 0;
	GSList* search_paths = NULL;
	gint _tmp7_ = 0;
	gchar** _tmp8_ = NULL;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar* _tmp13_ = NULL;
	GSList* _tmp14_;
	GValue _tmp50_ = {0};
	GValue val;
	GHashTable* _tmp51_;
	gchar* _tmp52_;
	GValue _tmp53_;
	GValue _tmp54_;
	GValue* _tmp55_;
	GError * _inner_error_ = NULL;
	desktop_agnostic_config_schema_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DesktopAgnosticConfigSchemaPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_config_schema_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_desktop_agnostic_config_schema_set_property;
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_config_schema_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_CONFIG_SCHEMA_FILENAME, g_param_spec_string ("filename", "filename", "filename", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_CONFIG_SCHEMA_APP_NAME, g_param_spec_string ("app-name", "Application name", "The name of the application associated with the schema", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	_tmp0_ = g_hash_table_new_full ((GHashFunc) desktop_agnostic_config_gtype_hash, (GEqualFunc) desktop_agnostic_config_gtype_equal, NULL, _g_object_unref0_);
	desktop_agnostic_config_schema_type_registry = _tmp0_;
	_tmp1_ = g_str_hash;
	_tmp2_ = g_str_equal;
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_object_unref0_);
	desktop_agnostic_config_schema_name_registry = _tmp3_;
	_tmp4_ = g_str_hash;
	_tmp5_ = g_str_equal;
	_tmp6_ = g_hash_table_new_full (_tmp4_, _tmp5_, _g_free0_, __vala_GValue_free0_);
	desktop_agnostic_config_schema_common_metadata_keys = _tmp6_;
	__g_list_free__g_free0_0 (type_modules);
	type_modules = NULL;
	desktop_agnostic_module_loader_get_default ();
	{
		desktop_agnostic_config_get_type (&_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch3_g_error;
		}
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* err = NULL;
		err = _inner_error_;
		_inner_error_ = NULL;
		_g_error_free0 (err);
	}
	__finally3:
	if (_inner_error_ != NULL) {
		__g_slist_free__g_free0_0 (search_paths);
		paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
		__g_list_free__g_free0_0 (type_modules);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	_tmp8_ = desktop_agnostic_module_loader_get_search_paths (&_tmp7_);
	paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
	paths = _tmp8_;
	paths_length1 = _tmp7_;
	_paths_size_ = paths_length1;
	__g_slist_free__g_free0_0 (search_paths);
	search_paths = NULL;
	_tmp9_ = paths;
	_tmp9__length1 = paths_length1;
	{
		gchar** path_collection = NULL;
		gint path_collection_length1 = 0;
		gint _path_collection_size_ = 0;
		gint path_it = 0;
		path_collection = _tmp9_;
		path_collection_length1 = _tmp9__length1;
		for (path_it = 0; path_it < _tmp9__length1; path_it = path_it + 1) {
			const gchar* path = NULL;
			path = path_collection[path_it];
			{
				const gchar* _tmp10_;
				_tmp10_ = path;
				if (_tmp10_ != NULL) {
					const gchar* _tmp11_;
					gchar* _tmp12_;
					_tmp11_ = path;
					_tmp12_ = g_strdup (_tmp11_);
					search_paths = g_slist_append (search_paths, _tmp12_);
				}
			}
		}
	}
	_tmp13_ = g_get_current_dir ();
	search_paths = g_slist_append (search_paths, _tmp13_);
	_tmp14_ = search_paths;
	{
		GSList* path_collection = NULL;
		GSList* path_it = NULL;
		path_collection = _tmp14_;
		for (path_it = path_collection; path_it != NULL; path_it = path_it->next) {
			const gchar* path = NULL;
			path = (const gchar*) path_it->data;
			{
				const gchar* _tmp15_;
				gboolean _tmp16_ = FALSE;
				const gchar* _tmp17_;
				gchar* _tmp18_ = NULL;
				gchar* module_glob;
				_tmp15_ = path;
				_tmp16_ = g_file_test (_tmp15_, G_FILE_TEST_IS_DIR);
				if (!_tmp16_) {
					continue;
				}
				_tmp17_ = path;
				_tmp18_ = g_build_filename (_tmp17_, "libda-cfg-type-*", NULL);
				module_glob = _tmp18_;
				{
					DesktopAgnosticVFSGlob* found_modules = NULL;
					gchar** modules_paths = NULL;
					gint modules_paths_length1 = 0;
					gint _modules_paths_size_ = 0;
					const gchar* _tmp19_;
					DesktopAgnosticVFSGlob* _tmp20_ = NULL;
					DesktopAgnosticVFSGlob* _tmp21_;
					DesktopAgnosticVFSGlob* _tmp22_;
					gint _tmp23_ = 0;
					gchar** _tmp24_ = NULL;
					gchar** _tmp25_;
					gint _tmp25__length1;
					_tmp19_ = module_glob;
					_tmp20_ = desktop_agnostic_vfs_glob_execute (_tmp19_, &_inner_error_);
					_tmp21_ = _tmp20_;
					if (_inner_error_ != NULL) {
						_g_object_unref0 (found_modules);
						if (_inner_error_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
							goto __catch4_desktop_agnostic_vfs_glob_error;
						}
						_g_object_unref0 (found_modules);
						_g_free0 (module_glob);
						__g_slist_free__g_free0_0 (search_paths);
						paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
						__g_list_free__g_free0_0 (type_modules);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
					}
					_g_object_unref0 (found_modules);
					found_modules = _tmp21_;
					_tmp22_ = found_modules;
					_tmp24_ = desktop_agnostic_vfs_glob_get_paths (_tmp22_, &_tmp23_);
					modules_paths = _tmp24_;
					modules_paths_length1 = _tmp23_;
					_modules_paths_size_ = modules_paths_length1;
					_tmp25_ = modules_paths;
					_tmp25__length1 = modules_paths_length1;
					{
						gchar** module_collection = NULL;
						gint module_collection_length1 = 0;
						gint _module_collection_size_ = 0;
						gint module_it = 0;
						module_collection = _tmp25_;
						module_collection_length1 = _tmp25__length1;
						for (module_it = 0; module_it < _tmp25__length1; module_it = module_it + 1) {
							const gchar* module = NULL;
							module = module_collection[module_it];
							{
								GList* _tmp26_;
								const gchar* _tmp27_;
								GList* _tmp28_ = NULL;
								_tmp26_ = type_modules;
								_tmp27_ = module;
								_tmp28_ = g_list_find (_tmp26_, _tmp27_);
								if (_tmp28_ == NULL) {
									GType type = 0UL;
									DesktopAgnosticModuleLoader* _tmp29_ = NULL;
									DesktopAgnosticModuleLoader* loader;
									DesktopAgnosticModuleLoader* _tmp30_;
									const gchar* _tmp31_;
									gchar* _tmp32_ = NULL;
									gchar* _tmp33_;
									const gchar* _tmp34_;
									GType _tmp35_ = 0UL;
									GType _tmp36_;
									_tmp29_ = desktop_agnostic_module_loader_get_default ();
									loader = _tmp29_;
									_tmp30_ = loader;
									_tmp31_ = module;
									_tmp32_ = g_path_get_basename (_tmp31_);
									_tmp33_ = _tmp32_;
									_tmp34_ = module;
									_tmp35_ = desktop_agnostic_module_loader_load_from_path (_tmp30_, _tmp33_, _tmp34_);
									type = _tmp35_;
									_g_free0 (_tmp33_);
									_tmp36_ = type;
									if (_tmp36_ != G_TYPE_INVALID) {
										{
											GType _tmp37_;
											GObject* _tmp38_ = NULL;
											GObject* _tmp39_;
											GObject* obj;
											GObject* _tmp40_;
											DesktopAgnosticConfigSchemaType* _tmp41_;
											const gchar* _tmp42_;
											gchar* _tmp43_;
											_tmp37_ = type;
											_tmp38_ = g_object_new (_tmp37_, NULL);
											_tmp39_ = G_IS_INITIALLY_UNOWNED (_tmp38_) ? g_object_ref_sink (_tmp38_) : _tmp38_;
											obj = _tmp39_;
											_tmp40_ = obj;
											obj = NULL;
											_tmp41_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_TYPE, DesktopAgnosticConfigSchemaType);
											desktop_agnostic_config_schema_register_type (_tmp41_, &_inner_error_);
											_g_object_unref0 (_tmp41_);
											if (_inner_error_ != NULL) {
												_g_object_unref0 (obj);
												if (_inner_error_->domain == DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR) {
													goto __catch5_desktop_agnostic_config_schema_error;
												}
												_g_object_unref0 (obj);
												_g_object_unref0 (found_modules);
												_g_free0 (module_glob);
												__g_slist_free__g_free0_0 (search_paths);
												paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
												__g_list_free__g_free0_0 (type_modules);
												g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
												g_clear_error (&_inner_error_);
											}
											_tmp42_ = module;
											_tmp43_ = g_strdup (_tmp42_);
											type_modules = g_list_append (type_modules, _tmp43_);
											_g_object_unref0 (obj);
										}
										goto __finally5;
										__catch5_desktop_agnostic_config_schema_error:
										{
											GError* err = NULL;
											GError* _tmp44_;
											const gchar* _tmp45_;
											err = _inner_error_;
											_inner_error_ = NULL;
											_tmp44_ = err;
											_tmp45_ = _tmp44_->message;
											g_warning ("config-schema.vala:120: Schema error: %s", _tmp45_);
											_g_error_free0 (err);
										}
										__finally5:
										if (_inner_error_ != NULL) {
											_g_object_unref0 (found_modules);
											if (_inner_error_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
												goto __catch4_desktop_agnostic_vfs_glob_error;
											}
											_g_object_unref0 (found_modules);
											_g_free0 (module_glob);
											__g_slist_free__g_free0_0 (search_paths);
											paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
											__g_list_free__g_free0_0 (type_modules);
											g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
											g_clear_error (&_inner_error_);
										}
									} else {
										const gchar* _tmp46_;
										_tmp46_ = module;
										g_warning ("config-schema.vala:125: Could not load the config type module: %s", _tmp46_);
									}
								}
							}
						}
					}
					_g_object_unref0 (found_modules);
				}
				goto __finally4;
				__catch4_desktop_agnostic_vfs_glob_error:
				{
					GError* err = NULL;
					GError* _tmp47_;
					err = _inner_error_;
					_inner_error_ = NULL;
					_tmp47_ = err;
					if (!g_error_matches (_tmp47_, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_NOMATCH)) {
						GError* _tmp48_;
						const gchar* _tmp49_;
						_tmp48_ = err;
						_tmp49_ = _tmp48_->message;
						g_warning ("config-schema.vala:134: Glob-related error: %s", _tmp49_);
					}
					_g_error_free0 (err);
				}
				__finally4:
				if (_inner_error_ != NULL) {
					_g_free0 (module_glob);
					__g_slist_free__g_free0_0 (search_paths);
					paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
					__g_list_free__g_free0_0 (type_modules);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
				}
				_g_free0 (module_glob);
			}
		}
	}
	g_value_init (&_tmp50_, G_TYPE_BOOLEAN);
	val = _tmp50_;
	g_value_set_boolean (&val, TRUE);
	_tmp51_ = desktop_agnostic_config_schema_common_metadata_keys;
	_tmp52_ = g_strdup ("single_instance");
	_tmp53_ = val;
	_tmp54_ = _tmp53_;
	_tmp55_ = __g_value_dup0 (&_tmp54_);
	g_hash_table_insert (_tmp51_, _tmp52_, _tmp55_);
	{
		desktop_agnostic_config_get_type (&_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch6_g_error;
		}
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* err = NULL;
		GError* _tmp56_;
		const gchar* _tmp57_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp56_ = err;
		_tmp57_ = _tmp56_->message;
		g_critical ("config-schema.vala:149: Config error: %s", _tmp57_);
		_g_error_free0 (err);
	}
	__finally6:
	if (_inner_error_ != NULL) {
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
		__g_slist_free__g_free0_0 (search_paths);
		paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
		__g_list_free__g_free0_0 (type_modules);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	__g_slist_free__g_free0_0 (search_paths);
	paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
	__g_list_free__g_free0_0 (type_modules);
}


static void desktop_agnostic_config_schema_instance_init (DesktopAgnosticConfigSchema * self) {
	self->priv = DESKTOP_AGNOSTIC_CONFIG_SCHEMA_GET_PRIVATE (self);
}


static void desktop_agnostic_config_schema_finalize (GObject* obj) {
	DesktopAgnosticConfigSchema * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA, DesktopAgnosticConfigSchema);
	_g_free0 (self->priv->_filename);
	_g_free0 (self->priv->_app_name);
	_g_hash_table_unref0 (self->priv->keys);
	__g_list_free__g_free0_0 (self->priv->valid_metadata_keys);
	G_OBJECT_CLASS (desktop_agnostic_config_schema_parent_class)->finalize (obj);
}


/**
   * A representation of a configuration schema, comprised of one or more
   * configuration options.
   */
GType desktop_agnostic_config_schema_get_type (void) {
	static volatile gsize desktop_agnostic_config_schema_type_id__volatile = 0;
	if (g_once_init_enter (&desktop_agnostic_config_schema_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticConfigSchemaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_config_schema_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticConfigSchema), 0, (GInstanceInitFunc) desktop_agnostic_config_schema_instance_init, NULL };
		GType desktop_agnostic_config_schema_type_id;
		desktop_agnostic_config_schema_type_id = g_type_register_static (G_TYPE_OBJECT, "DesktopAgnosticConfigSchema", &g_define_type_info, 0);
		g_once_init_leave (&desktop_agnostic_config_schema_type_id__volatile, desktop_agnostic_config_schema_type_id);
	}
	return desktop_agnostic_config_schema_type_id__volatile;
}


static void _vala_desktop_agnostic_config_schema_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DesktopAgnosticConfigSchema * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA, DesktopAgnosticConfigSchema);
	switch (property_id) {
		case DESKTOP_AGNOSTIC_CONFIG_SCHEMA_APP_NAME:
		g_value_set_string (value, desktop_agnostic_config_schema_get_app_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_desktop_agnostic_config_schema_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DesktopAgnosticConfigSchema * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA, DesktopAgnosticConfigSchema);
	switch (property_id) {
		case DESKTOP_AGNOSTIC_CONFIG_SCHEMA_FILENAME:
		desktop_agnostic_config_schema_set_filename (self, g_value_get_string (value));
		break;
		case DESKTOP_AGNOSTIC_CONFIG_SCHEMA_APP_NAME:
		desktop_agnostic_config_schema_set_app_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



