/* module-guesser.c generated by valac 0.20.1, the Vala compiler
 * generated from module-guesser.vala, do not modify */

/*
 * Desktop Agnostic Module guesser function.
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <libdesktop-agnostic/desktop-agnostic.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <libdesktop-agnostic/vfs.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



GType guess_module (DesktopAgnosticModuleLoader* loader, const gchar* library_prefix);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


/**
 * Given a valid library prefix, this function takes the first valid module
 * that is locates via the search paths and glob and loads it.
 */
GType guess_module (DesktopAgnosticModuleLoader* loader, const gchar* library_prefix) {
	GType result = 0UL;
	DesktopAgnosticModuleLoader* _tmp0_;
	gint _tmp1_ = 0;
	gchar** _tmp2_ = NULL;
	gchar** paths;
	gint paths_length1;
	gint _paths_size_;
	const gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* module_glob_suffix;
	GType _result_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (loader != NULL, 0UL);
	g_return_val_if_fail (library_prefix != NULL, 0UL);
	_tmp0_ = loader;
	_tmp2_ = desktop_agnostic_module_loader_get_search_paths (&_tmp1_);
	paths = _tmp2_;
	paths_length1 = _tmp1_;
	_paths_size_ = paths_length1;
	_tmp3_ = library_prefix;
	_tmp4_ = g_strdup_printf ("%s*", _tmp3_);
	module_glob_suffix = _tmp4_;
	_result_ = G_TYPE_INVALID;
	_tmp5_ = paths;
	_tmp5__length1 = paths_length1;
	{
		gchar** path_prefix_collection = NULL;
		gint path_prefix_collection_length1 = 0;
		gint _path_prefix_collection_size_ = 0;
		gint path_prefix_it = 0;
		path_prefix_collection = _tmp5_;
		path_prefix_collection_length1 = _tmp5__length1;
		for (path_prefix_it = 0; path_prefix_it < _tmp5__length1; path_prefix_it = path_prefix_it + 1) {
			const gchar* path_prefix = NULL;
			path_prefix = path_prefix_collection[path_prefix_it];
			{
				gboolean _tmp6_ = FALSE;
				const gchar* _tmp7_;
				gboolean _tmp10_;
				const gchar* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_ = NULL;
				gchar* module_glob;
				GType _tmp29_;
				_tmp7_ = path_prefix;
				if (_tmp7_ == NULL) {
					_tmp6_ = TRUE;
				} else {
					const gchar* _tmp8_;
					gboolean _tmp9_ = FALSE;
					_tmp8_ = path_prefix;
					_tmp9_ = g_file_test (_tmp8_, G_FILE_TEST_IS_DIR);
					_tmp6_ = !_tmp9_;
				}
				_tmp10_ = _tmp6_;
				if (_tmp10_) {
					continue;
				}
				_tmp11_ = path_prefix;
				_tmp12_ = module_glob_suffix;
				_tmp13_ = g_build_filename (_tmp11_, _tmp12_, NULL);
				module_glob = _tmp13_;
				{
					DesktopAgnosticVFSGlob* found_modules = NULL;
					gchar** modules_paths = NULL;
					gint modules_paths_length1 = 0;
					gint _modules_paths_size_ = 0;
					const gchar* _tmp14_;
					DesktopAgnosticVFSGlob* _tmp15_ = NULL;
					DesktopAgnosticVFSGlob* _tmp16_;
					DesktopAgnosticVFSGlob* _tmp17_;
					gint _tmp18_ = 0;
					gchar** _tmp19_ = NULL;
					gchar** _tmp20_;
					gint _tmp20__length1;
					_tmp14_ = module_glob;
					_tmp15_ = desktop_agnostic_vfs_glob_execute (_tmp14_, &_inner_error_);
					_tmp16_ = _tmp15_;
					if (_inner_error_ != NULL) {
						_g_object_unref0 (found_modules);
						if (_inner_error_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
							goto __catch0_desktop_agnostic_vfs_glob_error;
						}
						_g_object_unref0 (found_modules);
						_g_free0 (module_glob);
						_g_free0 (module_glob_suffix);
						paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return 0UL;
					}
					_g_object_unref0 (found_modules);
					found_modules = _tmp16_;
					_tmp17_ = found_modules;
					_tmp19_ = desktop_agnostic_vfs_glob_get_paths (_tmp17_, &_tmp18_);
					modules_paths = _tmp19_;
					modules_paths_length1 = _tmp18_;
					_modules_paths_size_ = modules_paths_length1;
					_tmp20_ = modules_paths;
					_tmp20__length1 = modules_paths_length1;
					{
						gchar** module_collection = NULL;
						gint module_collection_length1 = 0;
						gint _module_collection_size_ = 0;
						gint module_it = 0;
						module_collection = _tmp20_;
						module_collection_length1 = _tmp20__length1;
						for (module_it = 0; module_it < _tmp20__length1; module_it = module_it + 1) {
							const gchar* module = NULL;
							module = module_collection[module_it];
							{
								DesktopAgnosticModuleLoader* _tmp21_;
								const gchar* _tmp22_;
								const gchar* _tmp23_;
								GType _tmp24_ = 0UL;
								GType _tmp25_;
								_tmp21_ = loader;
								_tmp22_ = path_prefix;
								_tmp23_ = module;
								_tmp24_ = desktop_agnostic_module_loader_load_from_path (_tmp21_, _tmp22_, _tmp23_);
								_result_ = _tmp24_;
								_tmp25_ = _result_;
								if (_tmp25_ != G_TYPE_INVALID) {
									break;
								}
							}
						}
					}
					_g_object_unref0 (found_modules);
				}
				goto __finally0;
				__catch0_desktop_agnostic_vfs_glob_error:
				{
					GError* err = NULL;
					GError* _tmp26_;
					err = _inner_error_;
					_inner_error_ = NULL;
					_tmp26_ = err;
					if (!g_error_matches (_tmp26_, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_NOMATCH)) {
						GError* _tmp27_;
						const gchar* _tmp28_;
						_tmp27_ = err;
						_tmp28_ = _tmp27_->message;
						g_warning ("module-guesser.vala:65: Glob-related eror: %s", _tmp28_);
					}
					_g_error_free0 (err);
				}
				__finally0:
				if (_inner_error_ != NULL) {
					_g_free0 (module_glob);
					_g_free0 (module_glob_suffix);
					paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return 0UL;
				}
				_tmp29_ = _result_;
				if (_tmp29_ != G_TYPE_INVALID) {
					_g_free0 (module_glob);
					break;
				}
				_g_free0 (module_glob);
			}
		}
	}
	result = _result_;
	_g_free0 (module_glob_suffix);
	paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



