/* vfs-file-impl-gio.c generated by valac 0.20.1, the Vala compiler
 * generated from vfs-file-impl-gio.vala, do not modify */

/*
 * Desktop Agnostic Library: File implementation (with GIO).
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <libdesktop-agnostic/vfs.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define DESKTOP_AGNOSTIC_VFS_TYPE_FILE_GIO (desktop_agnostic_vfs_file_gio_get_type ())
#define DESKTOP_AGNOSTIC_VFS_FILE_GIO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_FILE_GIO, DesktopAgnosticVFSFileGIO))
#define DESKTOP_AGNOSTIC_VFS_FILE_GIO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_AGNOSTIC_VFS_TYPE_FILE_GIO, DesktopAgnosticVFSFileGIOClass))
#define DESKTOP_AGNOSTIC_VFS_IS_FILE_GIO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_FILE_GIO))
#define DESKTOP_AGNOSTIC_VFS_IS_FILE_GIO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_AGNOSTIC_VFS_TYPE_FILE_GIO))
#define DESKTOP_AGNOSTIC_VFS_FILE_GIO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_FILE_GIO, DesktopAgnosticVFSFileGIOClass))

typedef struct _DesktopAgnosticVFSFileGIO DesktopAgnosticVFSFileGIO;
typedef struct _DesktopAgnosticVFSFileGIOClass DesktopAgnosticVFSFileGIOClass;
typedef struct _DesktopAgnosticVFSFileGIOPrivate DesktopAgnosticVFSFileGIOPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define DESKTOP_AGNOSTIC_VFS_TYPE_FILE_MONITOR_GIO (desktop_agnostic_vfs_file_monitor_gio_get_type ())
#define DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_GIO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_FILE_MONITOR_GIO, DesktopAgnosticVFSFileMonitorGIO))
#define DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_GIO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_AGNOSTIC_VFS_TYPE_FILE_MONITOR_GIO, DesktopAgnosticVFSFileMonitorGIOClass))
#define DESKTOP_AGNOSTIC_VFS_IS_FILE_MONITOR_GIO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_FILE_MONITOR_GIO))
#define DESKTOP_AGNOSTIC_VFS_IS_FILE_MONITOR_GIO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_AGNOSTIC_VFS_TYPE_FILE_MONITOR_GIO))
#define DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_GIO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_FILE_MONITOR_GIO, DesktopAgnosticVFSFileMonitorGIOClass))

typedef struct _DesktopAgnosticVFSFileMonitorGIO DesktopAgnosticVFSFileMonitorGIO;
typedef struct _DesktopAgnosticVFSFileMonitorGIOClass DesktopAgnosticVFSFileMonitorGIOClass;
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
#define __g_slist_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__g_object_unref0_ (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _DesktopAgnosticVFSFileGIO {
	DesktopAgnosticVFSFile parent_instance;
	DesktopAgnosticVFSFileGIOPrivate * priv;
};

struct _DesktopAgnosticVFSFileGIOClass {
	DesktopAgnosticVFSFileClass parent_class;
};

struct _DesktopAgnosticVFSFileGIOPrivate {
	GFile* _file;
	gchar* _uri;
};


static gpointer desktop_agnostic_vfs_file_gio_parent_class = NULL;

GType desktop_agnostic_vfs_file_gio_get_type (void) G_GNUC_CONST;
#define DESKTOP_AGNOSTIC_VFS_FILE_GIO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DESKTOP_AGNOSTIC_VFS_TYPE_FILE_GIO, DesktopAgnosticVFSFileGIOPrivate))
enum  {
	DESKTOP_AGNOSTIC_VFS_FILE_GIO_DUMMY_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPLEMENTATION,
	DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPL_PATH,
	DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPL_URI,
	DESKTOP_AGNOSTIC_VFS_FILE_GIO_FILE_TYPE,
	DESKTOP_AGNOSTIC_VFS_FILE_GIO_ACCESS_FLAGS,
	DESKTOP_AGNOSTIC_VFS_FILE_GIO_PARENT
};
static void desktop_agnostic_vfs_file_gio_real_init (DesktopAgnosticVFSFile* base, const gchar* uri);
static gboolean desktop_agnostic_vfs_file_gio_real_exists (DesktopAgnosticVFSFile* base);
static DesktopAgnosticVFSFileMonitor* desktop_agnostic_vfs_file_gio_real_monitor (DesktopAgnosticVFSFile* base);
DesktopAgnosticVFSFileMonitorGIO* desktop_agnostic_vfs_file_monitor_gio_new (DesktopAgnosticVFSFileGIO* file);
DesktopAgnosticVFSFileMonitorGIO* desktop_agnostic_vfs_file_monitor_gio_construct (GType object_type, DesktopAgnosticVFSFileGIO* file);
GType desktop_agnostic_vfs_file_monitor_gio_get_type (void) G_GNUC_CONST;
static gboolean desktop_agnostic_vfs_file_gio_real_load_contents (DesktopAgnosticVFSFile* base, gchar** contents, gsize* length, GError** error);
static gboolean desktop_agnostic_vfs_file_gio_real_replace_contents (DesktopAgnosticVFSFile* base, const gchar* contents, GError** error);
static gboolean desktop_agnostic_vfs_file_gio_real_launch (DesktopAgnosticVFSFile* base, GError** error);
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
static GSList* desktop_agnostic_vfs_file_gio_real_enumerate_children (DesktopAgnosticVFSFile* base, GError** error);
static void _g_slist_free__g_object_unref0_ (GSList* self);
static gboolean desktop_agnostic_vfs_file_gio_real_copy (DesktopAgnosticVFSFile* base, DesktopAgnosticVFSFile* destination, gboolean overwrite, GError** error);
static gboolean desktop_agnostic_vfs_file_gio_real_remove (DesktopAgnosticVFSFile* base, GError** error);
static gboolean desktop_agnostic_vfs_file_gio_real_is_native (DesktopAgnosticVFSFile* base);
static gchar* desktop_agnostic_vfs_file_gio_real_get_mime_type (DesktopAgnosticVFSFile* base, GError** error);
static gchar** desktop_agnostic_vfs_file_gio_real_get_icon_names (DesktopAgnosticVFSFile* base, int* result_length1, GError** error);
static gchar** _vala_array_dup1 (gchar** self, int length);
static gchar* desktop_agnostic_vfs_file_gio_real_get_thumbnail_path (DesktopAgnosticVFSFile* base);
DesktopAgnosticVFSFileGIO* desktop_agnostic_vfs_file_gio_new (void);
DesktopAgnosticVFSFileGIO* desktop_agnostic_vfs_file_gio_construct (GType object_type);
static void desktop_agnostic_vfs_file_gio_finalize (GObject* obj);
static void _vala_desktop_agnostic_vfs_file_gio_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static void desktop_agnostic_vfs_file_gio_real_init (DesktopAgnosticVFSFile* base, const gchar* uri) {
	DesktopAgnosticVFSFileGIO * self;
	const gchar* _tmp0_;
	GFile* _tmp1_ = NULL;
	self = (DesktopAgnosticVFSFileGIO*) base;
	g_return_if_fail (uri != NULL);
	_tmp0_ = uri;
	_tmp1_ = g_file_new_for_uri (_tmp0_);
	_g_object_unref0 (self->priv->_file);
	self->priv->_file = _tmp1_;
}


static gboolean desktop_agnostic_vfs_file_gio_real_exists (DesktopAgnosticVFSFile* base) {
	DesktopAgnosticVFSFileGIO * self;
	gboolean result = FALSE;
	GFile* _tmp0_;
	gboolean _tmp1_ = FALSE;
	self = (DesktopAgnosticVFSFileGIO*) base;
	_tmp0_ = self->priv->_file;
	_tmp1_ = g_file_query_exists (_tmp0_, NULL);
	result = _tmp1_;
	return result;
}


static DesktopAgnosticVFSFileMonitor* desktop_agnostic_vfs_file_gio_real_monitor (DesktopAgnosticVFSFile* base) {
	DesktopAgnosticVFSFileGIO * self;
	DesktopAgnosticVFSFileMonitor* result = NULL;
	DesktopAgnosticVFSFileMonitorGIO* _tmp0_;
	self = (DesktopAgnosticVFSFileGIO*) base;
	_tmp0_ = desktop_agnostic_vfs_file_monitor_gio_new (self);
	result = (DesktopAgnosticVFSFileMonitor*) _tmp0_;
	return result;
}


static gboolean desktop_agnostic_vfs_file_gio_real_load_contents (DesktopAgnosticVFSFile* base, gchar** contents, gsize* length, GError** error) {
	DesktopAgnosticVFSFileGIO * self;
	gchar* _vala_contents = NULL;
	gsize _vala_length = 0UL;
	gboolean result = FALSE;
	guint8* glib_contents = NULL;
	gint glib_contents_length1 = 0;
	gint _glib_contents_size_ = 0;
	GFile* _tmp0_;
	guint8* _tmp1_ = NULL;
	gsize _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticVFSFileGIO*) base;
	_tmp0_ = self->priv->_file;
	_tmp3_ = g_file_load_contents (_tmp0_, NULL, &_tmp1_, &_tmp2_, NULL, &_inner_error_);
	glib_contents = (g_free (glib_contents), NULL);
	glib_contents = _tmp1_;
	glib_contents_length1 = _tmp2_;
	_glib_contents_size_ = glib_contents_length1;
	_tmp4_ = _tmp3_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		glib_contents = (g_free (glib_contents), NULL);
		return FALSE;
	}
	if (_tmp4_) {
		guint8* _tmp5_;
		gint _tmp5__length1;
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		_tmp5_ = glib_contents;
		_tmp5__length1 = glib_contents_length1;
		glib_contents = NULL;
		_g_free0 (_vala_contents);
		_vala_contents = (gchar*) _tmp5_;
		_tmp6_ = _vala_contents;
		_tmp7_ = strlen (_tmp6_);
		_tmp8_ = _tmp7_;
		_vala_length = (gsize) _tmp8_;
		result = TRUE;
		glib_contents = (g_free (glib_contents), NULL);
		if (contents) {
			*contents = _vala_contents;
		} else {
			_g_free0 (_vala_contents);
		}
		if (length) {
			*length = _vala_length;
		}
		return result;
	} else {
		result = FALSE;
		glib_contents = (g_free (glib_contents), NULL);
		if (contents) {
			*contents = _vala_contents;
		} else {
			_g_free0 (_vala_contents);
		}
		if (length) {
			*length = _vala_length;
		}
		return result;
	}
	glib_contents = (g_free (glib_contents), NULL);
	if (contents) {
		*contents = _vala_contents;
	} else {
		_g_free0 (_vala_contents);
	}
	if (length) {
		*length = _vala_length;
	}
}


static guint8* string_get_data (const gchar* self, int* result_length1) {
	guint8* result;
	guint8* res;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res_length1;
	_tmp3_ = res;
	_tmp3__length1 = res_length1;
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp3__length1;
	if (result_length1) {
		*result_length1 = _tmp4__length1;
	}
	result = _tmp4_;
	return result;
}


static gboolean desktop_agnostic_vfs_file_gio_real_replace_contents (DesktopAgnosticVFSFile* base, const gchar* contents, GError** error) {
	DesktopAgnosticVFSFileGIO * self;
	gboolean result = FALSE;
	GFile* _tmp0_;
	const gchar* _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticVFSFileGIO*) base;
	g_return_val_if_fail (contents != NULL, FALSE);
	_tmp0_ = self->priv->_file;
	_tmp1_ = contents;
	_tmp2_ = string_get_data (_tmp1_, &_tmp2__length1);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp2__length1;
	_tmp4_ = g_file_replace_contents (_tmp0_, _tmp3_, (gsize) _tmp3__length1, NULL, FALSE, 0, NULL, NULL, &_inner_error_);
	_tmp5_ = _tmp4_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return FALSE;
	}
	result = _tmp5_;
	return result;
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static void _g_list_free__g_object_unref0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
	g_list_free (self);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean desktop_agnostic_vfs_file_gio_real_launch (DesktopAgnosticVFSFile* base, GError** error) {
	DesktopAgnosticVFSFileGIO * self;
	gboolean result = FALSE;
	GAppInfo* app_info = NULL;
	GList* files;
	GFile* _tmp0_;
	GAppInfo* _tmp1_ = NULL;
	GAppInfo* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GAppInfo* _tmp5_;
	GList* _tmp6_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticVFSFileGIO*) base;
	files = NULL;
	_tmp0_ = self->priv->_file;
	_tmp1_ = g_file_query_default_handler (_tmp0_, NULL, &_inner_error_);
	_tmp2_ = _tmp1_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		__g_list_free__g_object_unref0_0 (files);
		_g_object_unref0 (app_info);
		return FALSE;
	}
	_g_object_unref0 (app_info);
	app_info = _tmp2_;
	_tmp3_ = self->priv->_file;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	files = g_list_append (files, _tmp4_);
	_tmp5_ = app_info;
	_tmp6_ = files;
	_tmp7_ = g_app_info_launch (_tmp5_, _tmp6_, NULL, &_inner_error_);
	_tmp8_ = _tmp7_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		__g_list_free__g_object_unref0_0 (files);
		_g_object_unref0 (app_info);
		return FALSE;
	}
	result = _tmp8_;
	__g_list_free__g_object_unref0_0 (files);
	_g_object_unref0 (app_info);
	return result;
}


static void _g_slist_free__g_object_unref0_ (GSList* self) {
	g_slist_foreach (self, (GFunc) _g_object_unref0_, NULL);
	g_slist_free (self);
}


static GSList* desktop_agnostic_vfs_file_gio_real_enumerate_children (DesktopAgnosticVFSFile* base, GError** error) {
	DesktopAgnosticVFSFileGIO * self;
	GSList* result = NULL;
	GSList* children = NULL;
	GFileEnumerator* enumerator = NULL;
	GFileInfo* info = NULL;
	GFile* _tmp0_;
	GFileEnumerator* _tmp1_ = NULL;
	GFileEnumerator* _tmp2_;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticVFSFileGIO*) base;
	__g_slist_free__g_object_unref0_0 (children);
	children = NULL;
	_tmp0_ = self->priv->_file;
	_tmp1_ = g_file_enumerate_children (_tmp0_, G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
	_tmp2_ = _tmp1_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (info);
		_g_object_unref0 (enumerator);
		__g_slist_free__g_object_unref0_0 (children);
		return NULL;
	}
	_g_object_unref0 (enumerator);
	enumerator = _tmp2_;
	while (TRUE) {
		GFileEnumerator* _tmp3_;
		GFileInfo* _tmp4_ = NULL;
		GFileInfo* _tmp5_;
		GFileInfo* _tmp6_;
		GFile* gchild = NULL;
		DesktopAgnosticVFSFile* child = NULL;
		GFile* _tmp7_;
		GFileInfo* _tmp8_;
		const gchar* _tmp9_ = NULL;
		GFile* _tmp10_ = NULL;
		GFile* _tmp11_;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_;
		DesktopAgnosticVFSFile* _tmp14_ = NULL;
		DesktopAgnosticVFSFile* _tmp15_;
		DesktopAgnosticVFSFile* _tmp16_;
		DesktopAgnosticVFSFile* _tmp17_;
		_tmp3_ = enumerator;
		_tmp4_ = g_file_enumerator_next_file (_tmp3_, NULL, &_inner_error_);
		_tmp5_ = _tmp4_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (info);
			_g_object_unref0 (enumerator);
			__g_slist_free__g_object_unref0_0 (children);
			return NULL;
		}
		_g_object_unref0 (info);
		info = _tmp5_;
		_tmp6_ = info;
		if (!(_tmp6_ != NULL)) {
			break;
		}
		_tmp7_ = self->priv->_file;
		_tmp8_ = info;
		_tmp9_ = g_file_info_get_name (_tmp8_);
		_tmp10_ = g_file_get_child (_tmp7_, _tmp9_);
		_g_object_unref0 (gchild);
		gchild = _tmp10_;
		_tmp11_ = gchild;
		_tmp12_ = g_file_get_uri (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = desktop_agnostic_vfs_file_new_for_uri (_tmp13_, &_inner_error_);
		_tmp15_ = _tmp14_;
		_g_free0 (_tmp13_);
		_tmp16_ = _tmp15_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (child);
			_g_object_unref0 (gchild);
			_g_object_unref0 (info);
			_g_object_unref0 (enumerator);
			__g_slist_free__g_object_unref0_0 (children);
			return NULL;
		}
		_g_object_unref0 (child);
		child = _tmp16_;
		_tmp17_ = child;
		child = NULL;
		children = g_slist_append (children, _tmp17_);
		_g_object_unref0 (child);
		_g_object_unref0 (gchild);
	}
	result = children;
	_g_object_unref0 (info);
	_g_object_unref0 (enumerator);
	return result;
}


static gboolean desktop_agnostic_vfs_file_gio_real_copy (DesktopAgnosticVFSFile* base, DesktopAgnosticVFSFile* destination, gboolean overwrite, GError** error) {
	DesktopAgnosticVFSFileGIO * self;
	gboolean result = FALSE;
	GFileCopyFlags flags;
	gboolean _tmp0_;
	GFile* _tmp1_;
	DesktopAgnosticVFSFile* _tmp2_;
	void* _tmp3_;
	void* _tmp4_;
	GFileCopyFlags _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticVFSFileGIO*) base;
	g_return_val_if_fail (destination != NULL, FALSE);
	flags = 0;
	_tmp0_ = overwrite;
	if (_tmp0_) {
		flags = G_FILE_COPY_OVERWRITE;
	}
	_tmp1_ = self->priv->_file;
	_tmp2_ = destination;
	_tmp3_ = desktop_agnostic_vfs_file_get_implementation (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = flags;
	_tmp6_ = g_file_copy (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, G_TYPE_FILE, GFile), _tmp5_, NULL, NULL, NULL, &_inner_error_);
	_tmp7_ = _tmp6_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return FALSE;
	}
	result = _tmp7_;
	return result;
}


static gboolean desktop_agnostic_vfs_file_gio_real_remove (DesktopAgnosticVFSFile* base, GError** error) {
	DesktopAgnosticVFSFileGIO * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GFile* _tmp6_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticVFSFileGIO*) base;
	_tmp0_ = desktop_agnostic_vfs_file_exists ((DesktopAgnosticVFSFile*) self);
	if (!_tmp0_) {
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		GError* _tmp5_;
		_tmp1_ = desktop_agnostic_vfs_file_get_uri ((DesktopAgnosticVFSFile*) self);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = g_error_new (DESKTOP_AGNOSTIC_VFS_FILE_ERROR, DESKTOP_AGNOSTIC_VFS_FILE_ERROR_FILE_NOT_FOUND, "The file '%s' does not exist.", _tmp3_);
		_tmp5_ = _tmp4_;
		_g_free0 (_tmp3_);
		_inner_error_ = _tmp5_;
		g_propagate_error (error, _inner_error_);
		return FALSE;
	}
	_tmp6_ = self->priv->_file;
	_tmp7_ = g_file_delete (_tmp6_, NULL, &_inner_error_);
	_tmp8_ = _tmp7_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return FALSE;
	}
	result = _tmp8_;
	return result;
}


static gboolean desktop_agnostic_vfs_file_gio_real_is_native (DesktopAgnosticVFSFile* base) {
	DesktopAgnosticVFSFileGIO * self;
	gboolean result = FALSE;
	GFile* _tmp0_;
	gboolean _tmp1_ = FALSE;
	self = (DesktopAgnosticVFSFileGIO*) base;
	_tmp0_ = self->priv->_file;
	_tmp1_ = g_file_is_native (_tmp0_);
	result = _tmp1_;
	return result;
}


static gchar* desktop_agnostic_vfs_file_gio_real_get_mime_type (DesktopAgnosticVFSFile* base, GError** error) {
	DesktopAgnosticVFSFileGIO * self;
	gchar* result = NULL;
	GFile* _tmp0_;
	GFileInfo* _tmp1_ = NULL;
	GFileInfo* fi;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticVFSFileGIO*) base;
	_tmp0_ = self->priv->_file;
	_tmp1_ = g_file_query_info (_tmp0_, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, 0, NULL, &_inner_error_);
	fi = _tmp1_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp2_ = g_file_info_get_content_type (fi);
	_tmp3_ = g_strdup (_tmp2_);
	result = _tmp3_;
	_g_object_unref0 (fi);
	return result;
}


static gchar** _vala_array_dup1 (gchar** self, int length) {
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


static gchar** desktop_agnostic_vfs_file_gio_real_get_icon_names (DesktopAgnosticVFSFile* base, int* result_length1, GError** error) {
	DesktopAgnosticVFSFileGIO * self;
	gchar** result = NULL;
	GFile* _tmp0_;
	GFileInfo* _tmp1_ = NULL;
	GFileInfo* fi;
	GIcon* _tmp2_ = NULL;
	GIcon* _tmp3_;
	GIcon* icon;
	GIcon* _tmp4_;
	gchar** _tmp19_ = NULL;
	gchar** unknown;
	gint unknown_length1;
	gint _unknown_size_;
	gchar** _tmp20_;
	gint _tmp20__length1;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticVFSFileGIO*) base;
	_tmp0_ = self->priv->_file;
	_tmp1_ = g_file_query_info (_tmp0_, G_FILE_ATTRIBUTE_STANDARD_ICON, 0, NULL, &_inner_error_);
	fi = _tmp1_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp2_ = g_file_info_get_icon (fi);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	icon = _tmp3_;
	_tmp4_ = icon;
	if (_tmp4_ != NULL) {
		GIcon* _tmp5_;
		GIcon* _tmp11_;
		_tmp5_ = icon;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, g_themed_icon_get_type ())) {
			GValue _tmp6_ = {0};
			GValue v;
			GIcon* _tmp7_;
			GValue _tmp8_;
			gchar** _tmp9_;
			gint _tmp9__length1;
			gchar** names;
			gint names_length1;
			gint _names_size_;
			gchar** _tmp10_;
			gint _tmp10__length1;
			g_value_init (&_tmp6_, G_TYPE_STRV);
			v = _tmp6_;
			_tmp7_ = icon;
			g_object_get_property ((GObject*) _tmp7_, "names", &v);
			_tmp8_ = v;
			_tmp9_ = (g_value_get_boxed (&_tmp8_) != NULL) ? _vala_array_dup1 (g_value_get_boxed (&_tmp8_), g_strv_length (g_value_get_boxed (&_tmp8_))) : ((gpointer) g_value_get_boxed (&_tmp8_));
			_tmp9__length1 = g_strv_length (g_value_get_boxed (&_tmp8_));
			names = _tmp9_;
			names_length1 = _tmp9__length1;
			_names_size_ = names_length1;
			_tmp10_ = names;
			_tmp10__length1 = names_length1;
			if (result_length1) {
				*result_length1 = _tmp10__length1;
			}
			result = _tmp10_;
			G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
			_g_object_unref0 (icon);
			_g_object_unref0 (fi);
			return result;
		}
		_tmp11_ = icon;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, g_file_icon_get_type ())) {
			GIcon* _tmp12_;
			GFile* _tmp13_ = NULL;
			gchar* _tmp14_ = NULL;
			gchar* path;
			const gchar* _tmp15_;
			gchar* _tmp16_;
			gchar** _tmp17_ = NULL;
			gchar** _result_;
			gint _result__length1;
			gint __result__size_;
			gchar** _tmp18_;
			gint _tmp18__length1;
			_tmp12_ = icon;
			_tmp13_ = g_file_icon_get_file (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, g_file_icon_get_type ()) ? ((GFileIcon*) _tmp12_) : NULL);
			_tmp14_ = g_file_get_path (_tmp13_);
			path = _tmp14_;
			_tmp15_ = path;
			_tmp16_ = g_strdup (_tmp15_);
			_tmp17_ = g_new0 (gchar*, 1 + 1);
			_tmp17_[0] = _tmp16_;
			_result_ = _tmp17_;
			_result__length1 = 1;
			__result__size_ = _result__length1;
			_tmp18_ = _result_;
			_tmp18__length1 = _result__length1;
			if (result_length1) {
				*result_length1 = _tmp18__length1;
			}
			result = _tmp18_;
			_g_free0 (path);
			_g_object_unref0 (icon);
			_g_object_unref0 (fi);
			return result;
		}
	}
	_tmp19_ = g_new0 (gchar*, 0 + 1);
	unknown = _tmp19_;
	unknown_length1 = 0;
	_unknown_size_ = unknown_length1;
	_tmp20_ = unknown;
	_tmp20__length1 = unknown_length1;
	if (result_length1) {
		*result_length1 = _tmp20__length1;
	}
	result = _tmp20_;
	_g_object_unref0 (icon);
	_g_object_unref0 (fi);
	return result;
}


static gchar* desktop_agnostic_vfs_file_gio_real_get_thumbnail_path (DesktopAgnosticVFSFile* base) {
	DesktopAgnosticVFSFileGIO * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticVFSFileGIO*) base;
	{
		GFile* _tmp0_;
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* fi;
		GFileInfo* _tmp2_;
		gboolean _tmp3_ = FALSE;
		_tmp0_ = self->priv->_file;
		_tmp1_ = g_file_query_info (_tmp0_, G_FILE_ATTRIBUTE_THUMBNAIL_PATH, 0, NULL, &_inner_error_);
		fi = _tmp1_;
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
		_tmp2_ = fi;
		_tmp3_ = g_file_info_has_attribute (_tmp2_, G_FILE_ATTRIBUTE_THUMBNAIL_PATH);
		if (_tmp3_) {
			GFileInfo* _tmp4_;
			const gchar* _tmp5_ = NULL;
			gchar* _tmp6_;
			_tmp4_ = fi;
			_tmp5_ = g_file_info_get_attribute_byte_string (_tmp4_, G_FILE_ATTRIBUTE_THUMBNAIL_PATH);
			_tmp6_ = g_strdup (_tmp5_);
			result = _tmp6_;
			_g_object_unref0 (fi);
			return result;
		}
		_g_object_unref0 (fi);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp7_ = err;
		_tmp8_ = _tmp7_->message;
		g_warning ("vfs-file-impl-gio.vala:313: %s", _tmp8_);
		_g_error_free0 (err);
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = NULL;
	return result;
}


DesktopAgnosticVFSFileGIO* desktop_agnostic_vfs_file_gio_construct (GType object_type) {
	DesktopAgnosticVFSFileGIO * self = NULL;
	self = (DesktopAgnosticVFSFileGIO*) desktop_agnostic_vfs_file_construct (object_type);
	return self;
}


DesktopAgnosticVFSFileGIO* desktop_agnostic_vfs_file_gio_new (void) {
	return desktop_agnostic_vfs_file_gio_construct (DESKTOP_AGNOSTIC_VFS_TYPE_FILE_GIO);
}


static void* desktop_agnostic_vfs_file_gio_real_get_implementation (DesktopAgnosticVFSFile* base) {
	void* result;
	DesktopAgnosticVFSFileGIO* self;
	GFile* _tmp0_;
	self = (DesktopAgnosticVFSFileGIO*) base;
	_tmp0_ = self->priv->_file;
	result = (void*) _tmp0_;
	return result;
}


static gchar* desktop_agnostic_vfs_file_gio_real_get_impl_path (DesktopAgnosticVFSFile* base) {
	gchar* result;
	DesktopAgnosticVFSFileGIO* self;
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	self = (DesktopAgnosticVFSFileGIO*) base;
	_tmp0_ = self->priv->_file;
	_tmp1_ = g_file_get_path (_tmp0_);
	result = _tmp1_;
	return result;
}


static gchar* desktop_agnostic_vfs_file_gio_real_get_impl_uri (DesktopAgnosticVFSFile* base) {
	gchar* result;
	DesktopAgnosticVFSFileGIO* self;
	const gchar* _tmp0_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	self = (DesktopAgnosticVFSFileGIO*) base;
	_tmp0_ = self->priv->_uri;
	if (_tmp0_ == NULL) {
		GFile* _tmp1_;
		gchar* _tmp2_ = NULL;
		_tmp1_ = self->priv->_file;
		_tmp2_ = g_file_get_uri (_tmp1_);
		_g_free0 (self->priv->_uri);
		self->priv->_uri = _tmp2_;
	}
	_tmp3_ = self->priv->_uri;
	_tmp4_ = g_strdup (_tmp3_);
	result = _tmp4_;
	return result;
}


static DesktopAgnosticVFSFileType desktop_agnostic_vfs_file_gio_real_get_file_type (DesktopAgnosticVFSFile* base) {
	DesktopAgnosticVFSFileType result;
	DesktopAgnosticVFSFileGIO* self;
	DesktopAgnosticVFSFileType ft;
	gboolean _tmp0_ = FALSE;
	DesktopAgnosticVFSFileType _tmp9_;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticVFSFileGIO*) base;
	ft = DESKTOP_AGNOSTIC_VFS_FILE_TYPE_UNKNOWN;
	_tmp0_ = desktop_agnostic_vfs_file_exists ((DesktopAgnosticVFSFile*) self);
	if (_tmp0_) {
		GFileInfo* info = NULL;
		GFileType gft = 0;
		{
			GFile* _tmp1_;
			GFileInfo* _tmp2_ = NULL;
			GFileInfo* _tmp3_;
			GFileInfo* _tmp4_;
			guint32 _tmp5_ = 0U;
			GFileType _tmp6_;
			_tmp1_ = self->priv->_file;
			_tmp2_ = g_file_query_info (_tmp1_, G_FILE_ATTRIBUTE_STANDARD_TYPE, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
			_tmp3_ = _tmp2_;
			if (_inner_error_ != NULL) {
				goto __catch1_g_error;
			}
			_g_object_unref0 (info);
			info = _tmp3_;
			_tmp4_ = info;
			_tmp5_ = g_file_info_get_attribute_uint32 (_tmp4_, G_FILE_ATTRIBUTE_STANDARD_TYPE);
			gft = (GFileType) _tmp5_;
			_tmp6_ = gft;
			switch (_tmp6_) {
				case G_FILE_TYPE_REGULAR:
				{
					ft = DESKTOP_AGNOSTIC_VFS_FILE_TYPE_REGULAR;
					break;
				}
				case G_FILE_TYPE_DIRECTORY:
				case G_FILE_TYPE_MOUNTABLE:
				{
					ft = DESKTOP_AGNOSTIC_VFS_FILE_TYPE_DIRECTORY;
					break;
				}
				case G_FILE_TYPE_SYMBOLIC_LINK:
				case G_FILE_TYPE_SHORTCUT:
				{
					ft = DESKTOP_AGNOSTIC_VFS_FILE_TYPE_SYMBOLIC_LINK;
					break;
				}
				case G_FILE_TYPE_SPECIAL:
				{
					ft = DESKTOP_AGNOSTIC_VFS_FILE_TYPE_SPECIAL;
					break;
				}
				case G_FILE_TYPE_UNKNOWN:
				{
					ft = DESKTOP_AGNOSTIC_VFS_FILE_TYPE_UNKNOWN;
					break;
				}
				default:
				break;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* err = NULL;
			GError* _tmp7_;
			const gchar* _tmp8_;
			err = _inner_error_;
			_inner_error_ = NULL;
			_tmp7_ = err;
			_tmp8_ = _tmp7_->message;
			g_warning ("vfs-file-impl-gio.vala:94: An error occurred while querying the file t" \
"ype: %s", _tmp8_);
			ft = DESKTOP_AGNOSTIC_VFS_FILE_TYPE_UNKNOWN;
			_g_error_free0 (err);
		}
		__finally1:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (info);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0;
		}
		_g_object_unref0 (info);
	}
	_tmp9_ = ft;
	result = _tmp9_;
	return result;
}


static DesktopAgnosticVFSAccessFlags desktop_agnostic_vfs_file_gio_real_get_access_flags (DesktopAgnosticVFSFile* base) {
	DesktopAgnosticVFSAccessFlags result;
	DesktopAgnosticVFSFileGIO* self;
	DesktopAgnosticVFSAccessFlags flags;
	gboolean _tmp0_ = FALSE;
	DesktopAgnosticVFSAccessFlags _tmp17_;
	GError * _inner_error_ = NULL;
	self = (DesktopAgnosticVFSFileGIO*) base;
	flags = DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_NONE;
	_tmp0_ = desktop_agnostic_vfs_file_exists ((DesktopAgnosticVFSFile*) self);
	if (_tmp0_) {
		GFileInfo* info = NULL;
		{
			gchar* attrs = NULL;
			gchar* _tmp1_ = NULL;
			GFile* _tmp2_;
			const gchar* _tmp3_;
			GFileInfo* _tmp4_ = NULL;
			GFileInfo* _tmp5_;
			GFileInfo* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GFileInfo* _tmp9_;
			gboolean _tmp10_ = FALSE;
			GFileInfo* _tmp12_;
			gboolean _tmp13_ = FALSE;
			_tmp1_ = g_strdup_printf ("%s,%s,%s", G_FILE_ATTRIBUTE_ACCESS_CAN_READ, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE, G_FILE_ATTRIBUTE_ACCESS_CAN_EXECUTE);
			_g_free0 (attrs);
			attrs = _tmp1_;
			_tmp2_ = self->priv->_file;
			_tmp3_ = attrs;
			_tmp4_ = g_file_query_info (_tmp2_, _tmp3_, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
			_tmp5_ = _tmp4_;
			if (_inner_error_ != NULL) {
				_g_free0 (attrs);
				goto __catch2_g_error;
			}
			_g_object_unref0 (info);
			info = _tmp5_;
			_tmp6_ = info;
			_tmp7_ = g_file_info_get_attribute_boolean (_tmp6_, G_FILE_ATTRIBUTE_ACCESS_CAN_READ);
			if (_tmp7_) {
				DesktopAgnosticVFSAccessFlags _tmp8_;
				_tmp8_ = flags;
				flags = _tmp8_ | DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_READ;
			}
			_tmp9_ = info;
			_tmp10_ = g_file_info_get_attribute_boolean (_tmp9_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE);
			if (_tmp10_) {
				DesktopAgnosticVFSAccessFlags _tmp11_;
				_tmp11_ = flags;
				flags = _tmp11_ | DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_WRITE;
			}
			_tmp12_ = info;
			_tmp13_ = g_file_info_get_attribute_boolean (_tmp12_, G_FILE_ATTRIBUTE_ACCESS_CAN_EXECUTE);
			if (_tmp13_) {
				DesktopAgnosticVFSAccessFlags _tmp14_;
				_tmp14_ = flags;
				flags = _tmp14_ | DESKTOP_AGNOSTIC_VFS_ACCESS_FLAGS_EXECUTE;
			}
			_g_free0 (attrs);
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* err = NULL;
			GError* _tmp15_;
			const gchar* _tmp16_;
			err = _inner_error_;
			_inner_error_ = NULL;
			_tmp15_ = err;
			_tmp16_ = _tmp15_->message;
			g_warning ("vfs-file-impl-gio.vala:135: An error occurred while querying the acces" \
"s flags: %s", _tmp16_);
			_g_error_free0 (err);
		}
		__finally2:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (info);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0;
		}
		_g_object_unref0 (info);
	}
	_tmp17_ = flags;
	result = _tmp17_;
	return result;
}


static DesktopAgnosticVFSFile* desktop_agnostic_vfs_file_gio_real_get_parent (DesktopAgnosticVFSFile* base) {
	DesktopAgnosticVFSFile* result;
	DesktopAgnosticVFSFileGIO* self;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_;
	self = (DesktopAgnosticVFSFileGIO*) base;
	_tmp0_ = self->priv->_file;
	_tmp1_ = g_file_get_parent (_tmp0_);
	_g_object_unref0 (file);
	file = _tmp1_;
	_tmp2_ = file;
	if (_tmp2_ == NULL) {
		result = NULL;
		_g_object_unref0 (file);
		return result;
	} else {
		DesktopAgnosticVFSFile* _result_ = NULL;
		DesktopAgnosticVFSFileGIO* _tmp3_;
		DesktopAgnosticVFSFile* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		_tmp3_ = desktop_agnostic_vfs_file_gio_new ();
		_g_object_unref0 (_result_);
		_result_ = (DesktopAgnosticVFSFile*) _tmp3_;
		_tmp4_ = _result_;
		_tmp5_ = file;
		_tmp6_ = g_file_get_uri (_tmp5_);
		_tmp7_ = _tmp6_;
		desktop_agnostic_vfs_file_init (_tmp4_, _tmp7_);
		_g_free0 (_tmp7_);
		result = _result_;
		_g_object_unref0 (file);
		return result;
	}
	_g_object_unref0 (file);
}


static void desktop_agnostic_vfs_file_gio_class_init (DesktopAgnosticVFSFileGIOClass * klass) {
	desktop_agnostic_vfs_file_gio_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DesktopAgnosticVFSFileGIOPrivate));
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->init = desktop_agnostic_vfs_file_gio_real_init;
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->exists = desktop_agnostic_vfs_file_gio_real_exists;
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->monitor = desktop_agnostic_vfs_file_gio_real_monitor;
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->load_contents = desktop_agnostic_vfs_file_gio_real_load_contents;
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->replace_contents = desktop_agnostic_vfs_file_gio_real_replace_contents;
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->launch = desktop_agnostic_vfs_file_gio_real_launch;
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->enumerate_children = desktop_agnostic_vfs_file_gio_real_enumerate_children;
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->copy = desktop_agnostic_vfs_file_gio_real_copy;
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->remove = desktop_agnostic_vfs_file_gio_real_remove;
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->is_native = desktop_agnostic_vfs_file_gio_real_is_native;
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->get_mime_type = desktop_agnostic_vfs_file_gio_real_get_mime_type;
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->get_icon_names = desktop_agnostic_vfs_file_gio_real_get_icon_names;
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->get_thumbnail_path = desktop_agnostic_vfs_file_gio_real_get_thumbnail_path;
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->get_implementation = desktop_agnostic_vfs_file_gio_real_get_implementation;
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->get_impl_path = desktop_agnostic_vfs_file_gio_real_get_impl_path;
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->get_impl_uri = desktop_agnostic_vfs_file_gio_real_get_impl_uri;
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->get_file_type = desktop_agnostic_vfs_file_gio_real_get_file_type;
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->get_access_flags = desktop_agnostic_vfs_file_gio_real_get_access_flags;
	DESKTOP_AGNOSTIC_VFS_FILE_CLASS (klass)->get_parent = desktop_agnostic_vfs_file_gio_real_get_parent;
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_vfs_file_gio_get_property;
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_vfs_file_gio_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPLEMENTATION, g_param_spec_pointer ("implementation", "implementation", "implementation", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPL_PATH, g_param_spec_string ("impl-path", "impl-path", "impl-path", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPL_URI, g_param_spec_string ("impl-uri", "impl-uri", "impl-uri", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_GIO_FILE_TYPE, g_param_spec_enum ("file-type", "file-type", "file-type", DESKTOP_AGNOSTIC_VFS_TYPE_FILE_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_GIO_ACCESS_FLAGS, g_param_spec_enum ("access-flags", "access-flags", "access-flags", DESKTOP_AGNOSTIC_VFS_TYPE_ACCESS_FLAGS, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_FILE_GIO_PARENT, g_param_spec_object ("parent", "parent", "parent", DESKTOP_AGNOSTIC_VFS_TYPE_FILE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void desktop_agnostic_vfs_file_gio_instance_init (DesktopAgnosticVFSFileGIO * self) {
	self->priv = DESKTOP_AGNOSTIC_VFS_FILE_GIO_GET_PRIVATE (self);
}


static void desktop_agnostic_vfs_file_gio_finalize (GObject* obj) {
	DesktopAgnosticVFSFileGIO * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_VFS_TYPE_FILE_GIO, DesktopAgnosticVFSFileGIO);
	_g_object_unref0 (self->priv->_file);
	_g_free0 (self->priv->_uri);
	G_OBJECT_CLASS (desktop_agnostic_vfs_file_gio_parent_class)->finalize (obj);
}


GType desktop_agnostic_vfs_file_gio_get_type (void) {
	static volatile gsize desktop_agnostic_vfs_file_gio_type_id__volatile = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_file_gio_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticVFSFileGIOClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_vfs_file_gio_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticVFSFileGIO), 0, (GInstanceInitFunc) desktop_agnostic_vfs_file_gio_instance_init, NULL };
		GType desktop_agnostic_vfs_file_gio_type_id;
		desktop_agnostic_vfs_file_gio_type_id = g_type_register_static (DESKTOP_AGNOSTIC_VFS_TYPE_FILE, "DesktopAgnosticVFSFileGIO", &g_define_type_info, 0);
		g_once_init_leave (&desktop_agnostic_vfs_file_gio_type_id__volatile, desktop_agnostic_vfs_file_gio_type_id);
	}
	return desktop_agnostic_vfs_file_gio_type_id__volatile;
}


static void _vala_desktop_agnostic_vfs_file_gio_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DesktopAgnosticVFSFileGIO * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_VFS_TYPE_FILE_GIO, DesktopAgnosticVFSFileGIO);
	switch (property_id) {
		case DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPLEMENTATION:
		g_value_set_pointer (value, desktop_agnostic_vfs_file_get_implementation ((DesktopAgnosticVFSFile*) self));
		break;
		case DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPL_PATH:
		g_value_take_string (value, desktop_agnostic_vfs_file_get_impl_path ((DesktopAgnosticVFSFile*) self));
		break;
		case DESKTOP_AGNOSTIC_VFS_FILE_GIO_IMPL_URI:
		g_value_take_string (value, desktop_agnostic_vfs_file_get_impl_uri ((DesktopAgnosticVFSFile*) self));
		break;
		case DESKTOP_AGNOSTIC_VFS_FILE_GIO_FILE_TYPE:
		g_value_set_enum (value, desktop_agnostic_vfs_file_get_file_type ((DesktopAgnosticVFSFile*) self));
		break;
		case DESKTOP_AGNOSTIC_VFS_FILE_GIO_ACCESS_FLAGS:
		g_value_set_enum (value, desktop_agnostic_vfs_file_get_access_flags ((DesktopAgnosticVFSFile*) self));
		break;
		case DESKTOP_AGNOSTIC_VFS_FILE_GIO_PARENT:
		g_value_take_object (value, desktop_agnostic_vfs_file_get_parent ((DesktopAgnosticVFSFile*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



