/* vfs-glob.c generated by valac 0.20.1, the Vala compiler
 * generated from vfs-glob.vala, do not modify */

/*
 * Desktop Agnostic Library: glob() wrapper.
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <glob.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>


#define DESKTOP_AGNOSTIC_VFS_TYPE_GLOB (desktop_agnostic_vfs_glob_get_type ())
#define DESKTOP_AGNOSTIC_VFS_GLOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_GLOB, DesktopAgnosticVFSGlob))
#define DESKTOP_AGNOSTIC_VFS_GLOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_AGNOSTIC_VFS_TYPE_GLOB, DesktopAgnosticVFSGlobClass))
#define DESKTOP_AGNOSTIC_VFS_IS_GLOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_GLOB))
#define DESKTOP_AGNOSTIC_VFS_IS_GLOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_AGNOSTIC_VFS_TYPE_GLOB))
#define DESKTOP_AGNOSTIC_VFS_GLOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_AGNOSTIC_VFS_TYPE_GLOB, DesktopAgnosticVFSGlobClass))

typedef struct _DesktopAgnosticVFSGlob DesktopAgnosticVFSGlob;
typedef struct _DesktopAgnosticVFSGlobClass DesktopAgnosticVFSGlobClass;
typedef struct _DesktopAgnosticVFSGlobPrivate DesktopAgnosticVFSGlobPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

typedef enum  {
	DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_NOSPACE,
	DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_ABORTED,
	DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_NOMATCH,
	DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_BAD_PATTERN,
	DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_BAD_FLAGS,
	DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_ERRNO
} DesktopAgnosticVFSGlobError;
#define DESKTOP_AGNOSTIC_VFS_GLOB_ERROR desktop_agnostic_vfs_glob_error_quark ()
struct _DesktopAgnosticVFSGlob {
	GObject parent_instance;
	DesktopAgnosticVFSGlobPrivate * priv;
};

struct _DesktopAgnosticVFSGlobClass {
	GObjectClass parent_class;
};

struct _DesktopAgnosticVFSGlobPrivate {
	glob_t glob;
	gchar* _pattern;
	gint _flags;
};


static gpointer desktop_agnostic_vfs_glob_parent_class = NULL;

GQuark desktop_agnostic_vfs_glob_error_quark (void);
GType desktop_agnostic_vfs_glob_get_type (void) G_GNUC_CONST;
#define DESKTOP_AGNOSTIC_VFS_GLOB_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DESKTOP_AGNOSTIC_VFS_TYPE_GLOB, DesktopAgnosticVFSGlobPrivate))
enum  {
	DESKTOP_AGNOSTIC_VFS_GLOB_DUMMY_PROPERTY,
	DESKTOP_AGNOSTIC_VFS_GLOB_OFFSET,
	DESKTOP_AGNOSTIC_VFS_GLOB_PATTERN,
	DESKTOP_AGNOSTIC_VFS_GLOB_FLAGS
};
DesktopAgnosticVFSGlob* desktop_agnostic_vfs_glob_execute (const gchar* pattern, GError** error);
static void desktop_agnostic_vfs_glob_run_glob (DesktopAgnosticVFSGlob* self, const gchar* pattern, gint flags, GError** error);
DesktopAgnosticVFSGlob* desktop_agnostic_vfs_glob_execute_with_flags (const gchar* pattern, gint flags, GError** error);
void desktop_agnostic_vfs_glob_append (DesktopAgnosticVFSGlob* self, const gchar* pattern, GError** error);
gchar** desktop_agnostic_vfs_glob_get_paths (DesktopAgnosticVFSGlob* self, int* result_length1);
static gint desktop_agnostic_vfs_glob_on_glob_error (const gchar* path, gint eerrno);
DesktopAgnosticVFSGlob* desktop_agnostic_vfs_glob_new (void);
DesktopAgnosticVFSGlob* desktop_agnostic_vfs_glob_construct (GType object_type);
gsize desktop_agnostic_vfs_glob_get_offset (DesktopAgnosticVFSGlob* self);
const gchar* desktop_agnostic_vfs_glob_get_pattern (DesktopAgnosticVFSGlob* self);
void desktop_agnostic_vfs_glob_set_pattern (DesktopAgnosticVFSGlob* self, const gchar* value);
gint desktop_agnostic_vfs_glob_get_flags (DesktopAgnosticVFSGlob* self);
void desktop_agnostic_vfs_glob_set_flags (DesktopAgnosticVFSGlob* self, gint value);
static void desktop_agnostic_vfs_glob_finalize (GObject* obj);
static void _vala_desktop_agnostic_vfs_glob_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_desktop_agnostic_vfs_glob_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GQuark desktop_agnostic_vfs_glob_error_quark (void) {
	return g_quark_from_static_string ("desktop_agnostic_vfs_glob_error-quark");
}


DesktopAgnosticVFSGlob* desktop_agnostic_vfs_glob_execute (const gchar* pattern, GError** error) {
	DesktopAgnosticVFSGlob* result = NULL;
	const gchar* _tmp0_;
	GObject* _tmp1_ = NULL;
	GObject* _tmp2_;
	DesktopAgnosticVFSGlob* g;
	const gchar* _tmp3_;
	gint _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (pattern != NULL, NULL);
	_tmp0_ = pattern;
	_tmp1_ = g_object_new (DESKTOP_AGNOSTIC_VFS_TYPE_GLOB, "pattern", _tmp0_, NULL);
	_tmp2_ = G_IS_INITIALLY_UNOWNED (_tmp1_) ? g_object_ref_sink (_tmp1_) : _tmp1_;
	g = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, DESKTOP_AGNOSTIC_VFS_TYPE_GLOB, DesktopAgnosticVFSGlob);
	_tmp3_ = g->priv->_pattern;
	_tmp4_ = g->priv->_flags;
	desktop_agnostic_vfs_glob_run_glob (g, _tmp3_, _tmp4_, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (g);
			return NULL;
		} else {
			_g_object_unref0 (g);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = g;
	return result;
}


DesktopAgnosticVFSGlob* desktop_agnostic_vfs_glob_execute_with_flags (const gchar* pattern, gint flags, GError** error) {
	DesktopAgnosticVFSGlob* result = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	GObject* _tmp2_ = NULL;
	GObject* _tmp3_;
	DesktopAgnosticVFSGlob* g;
	const gchar* _tmp4_;
	gint _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (pattern != NULL, NULL);
	_tmp0_ = pattern;
	_tmp1_ = flags;
	_tmp2_ = g_object_new (DESKTOP_AGNOSTIC_VFS_TYPE_GLOB, "pattern", _tmp0_, "flags", _tmp1_, NULL);
	_tmp3_ = G_IS_INITIALLY_UNOWNED (_tmp2_) ? g_object_ref_sink (_tmp2_) : _tmp2_;
	g = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, DESKTOP_AGNOSTIC_VFS_TYPE_GLOB, DesktopAgnosticVFSGlob);
	_tmp4_ = g->priv->_pattern;
	_tmp5_ = g->priv->_flags;
	desktop_agnostic_vfs_glob_run_glob (g, _tmp4_, _tmp5_, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (g);
			return NULL;
		} else {
			_g_object_unref0 (g);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = g;
	return result;
}


void desktop_agnostic_vfs_glob_append (DesktopAgnosticVFSGlob* self, const gchar* pattern, GError** error) {
	const gchar* _tmp0_;
	gint _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (pattern != NULL);
	_tmp0_ = pattern;
	_tmp1_ = self->priv->_flags;
	desktop_agnostic_vfs_glob_run_glob (self, _tmp0_, _tmp1_ | GLOB_APPEND, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


gchar** desktop_agnostic_vfs_glob_get_paths (DesktopAgnosticVFSGlob* self, int* result_length1) {
	gchar** result = NULL;
	glob_t _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** _tmp2_;
	gint _tmp2__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->glob;
	_tmp1_ = _tmp0_.gl_pathv;
	_tmp1__length1 = _tmp0_.gl_pathc;
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _tmp1__length1;
	if (result_length1) {
		*result_length1 = _tmp2__length1;
	}
	result = _tmp2_;
	return result;
}


static void desktop_agnostic_vfs_glob_run_glob (DesktopAgnosticVFSGlob* self, const gchar* pattern, gint flags, GError** error) {
	const gchar* _tmp0_;
	gint _tmp1_;
	glob_t _tmp2_ = {0};
	gint _tmp3_ = 0;
	gint res;
	gint _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (pattern != NULL);
	_tmp0_ = pattern;
	_tmp1_ = flags;
	_tmp3_ = glob (_tmp0_, _tmp1_, (void*) desktop_agnostic_vfs_glob_on_glob_error, &_tmp2_);
	globfree (&self->priv->glob);
	self->priv->glob = _tmp2_;
	res = _tmp3_;
	_tmp4_ = res;
	if (_tmp4_ != 0) {
		gint _tmp5_;
		_tmp5_ = res;
		switch (_tmp5_) {
			case GLOB_NOSPACE:
			{
				GError* _tmp6_;
				_tmp6_ = g_error_new_literal (DESKTOP_AGNOSTIC_VFS_GLOB_ERROR, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_NOSPACE, "Ran out of memory.");
				_inner_error_ = _tmp6_;
				if (_inner_error_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
					g_propagate_error (error, _inner_error_);
					return;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
			}
			case GLOB_ABORTED:
			{
				GError* _tmp7_;
				_tmp7_ = g_error_new_literal (DESKTOP_AGNOSTIC_VFS_GLOB_ERROR, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_ABORTED, "Read error.");
				_inner_error_ = _tmp7_;
				if (_inner_error_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
					g_propagate_error (error, _inner_error_);
					return;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
			}
			case GLOB_NOMATCH:
			{
				GError* _tmp8_;
				_tmp8_ = g_error_new_literal (DESKTOP_AGNOSTIC_VFS_GLOB_ERROR, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_NOMATCH, "No matches found.");
				_inner_error_ = _tmp8_;
				if (_inner_error_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
					g_propagate_error (error, _inner_error_);
					return;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
			}
			default:
			{
				gint _tmp9_;
				_tmp9_ = res;
				g_critical ("vfs-glob.vala:126: Unknown error code: %d", _tmp9_);
				break;
			}
		}
	}
}


static gint desktop_agnostic_vfs_glob_on_glob_error (const gchar* path, gint eerrno) {
	gint result = 0;
	gint _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (path != NULL, 0);
	_tmp0_ = eerrno;
	switch (_tmp0_) {
		case EACCES:
		case EBADF:
		case EMFILE:
		case ENFILE:
		case ENOENT:
		case ENOMEM:
		case ENOTDIR:
		case EFAULT:
		case EINVAL:
		case ELOOP:
		case ENAMETOOLONG:
		{
			const gchar* _tmp1_;
			gint _tmp2_;
			gint _tmp3_;
			const gchar* _tmp4_ = NULL;
			GError* _tmp5_;
			_tmp1_ = path;
			_tmp2_ = eerrno;
			_tmp3_ = eerrno;
			_tmp4_ = strerror (_tmp3_);
			_tmp5_ = g_error_new (DESKTOP_AGNOSTIC_VFS_GLOB_ERROR, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_ERRNO, "Miscellaneous error for '%s' (%d): %s", _tmp1_, _tmp2_, _tmp4_);
			_inner_error_ = _tmp5_;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0;
		}
		default:
		{
			gint _tmp6_;
			_tmp6_ = eerrno;
			g_critical ("vfs-glob.vala:151: Unknown error code: %d", _tmp6_);
			break;
		}
	}
	result = 1;
	return result;
}


DesktopAgnosticVFSGlob* desktop_agnostic_vfs_glob_construct (GType object_type) {
	DesktopAgnosticVFSGlob * self = NULL;
	self = (DesktopAgnosticVFSGlob*) g_object_new (object_type, NULL);
	return self;
}


DesktopAgnosticVFSGlob* desktop_agnostic_vfs_glob_new (void) {
	return desktop_agnostic_vfs_glob_construct (DESKTOP_AGNOSTIC_VFS_TYPE_GLOB);
}


gsize desktop_agnostic_vfs_glob_get_offset (DesktopAgnosticVFSGlob* self) {
	gsize result;
	glob_t _tmp0_;
	gsize _tmp1_;
	g_return_val_if_fail (self != NULL, 0UL);
	_tmp0_ = self->priv->glob;
	_tmp1_ = _tmp0_.gl_offs;
	result = _tmp1_;
	return result;
}


const gchar* desktop_agnostic_vfs_glob_get_pattern (DesktopAgnosticVFSGlob* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_pattern;
	result = _tmp0_;
	return result;
}


void desktop_agnostic_vfs_glob_set_pattern (DesktopAgnosticVFSGlob* self, const gchar* value) {
	const gchar* _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	if (g_strcmp0 (_tmp0_, "") != 0) {
		const gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = value;
		_tmp2_ = g_strdup (_tmp1_);
		_g_free0 (self->priv->_pattern);
		self->priv->_pattern = _tmp2_;
	} else {
		GError* _tmp3_;
		_tmp3_ = g_error_new_literal (DESKTOP_AGNOSTIC_VFS_GLOB_ERROR, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_BAD_PATTERN, "Invalid pattern.");
		_inner_error_ = _tmp3_;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	g_object_notify ((GObject *) self, "pattern");
}


gint desktop_agnostic_vfs_glob_get_flags (DesktopAgnosticVFSGlob* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_flags;
	result = _tmp0_;
	return result;
}


void desktop_agnostic_vfs_glob_set_flags (DesktopAgnosticVFSGlob* self, gint value) {
	gint _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	if (_tmp0_ >= 0) {
		gint _tmp1_;
		_tmp1_ = value;
		self->priv->_flags = _tmp1_;
	} else {
		GError* _tmp2_;
		_tmp2_ = g_error_new_literal (DESKTOP_AGNOSTIC_VFS_GLOB_ERROR, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_BAD_FLAGS, "Invalid flags.");
		_inner_error_ = _tmp2_;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	g_object_notify ((GObject *) self, "flags");
}


static void desktop_agnostic_vfs_glob_class_init (DesktopAgnosticVFSGlobClass * klass) {
	desktop_agnostic_vfs_glob_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DesktopAgnosticVFSGlobPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_vfs_glob_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_desktop_agnostic_vfs_glob_set_property;
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_vfs_glob_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_GLOB_OFFSET, g_param_spec_ulong ("offset", "offset", "offset", 0, G_MAXULONG, 0UL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_GLOB_PATTERN, g_param_spec_string ("pattern", "pattern", "pattern", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_VFS_GLOB_FLAGS, g_param_spec_int ("flags", "flags", "flags", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void desktop_agnostic_vfs_glob_instance_init (DesktopAgnosticVFSGlob * self) {
	self->priv = DESKTOP_AGNOSTIC_VFS_GLOB_GET_PRIVATE (self);
	self->priv->_flags = (GLOB_MARK | GLOB_BRACE) | GLOB_TILDE_CHECK;
}


static void desktop_agnostic_vfs_glob_finalize (GObject* obj) {
	DesktopAgnosticVFSGlob * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DESKTOP_AGNOSTIC_VFS_TYPE_GLOB, DesktopAgnosticVFSGlob);
	globfree (&self->priv->glob);
	_g_free0 (self->priv->_pattern);
	G_OBJECT_CLASS (desktop_agnostic_vfs_glob_parent_class)->finalize (obj);
}


GType desktop_agnostic_vfs_glob_get_type (void) {
	static volatile gsize desktop_agnostic_vfs_glob_type_id__volatile = 0;
	if (g_once_init_enter (&desktop_agnostic_vfs_glob_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticVFSGlobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_vfs_glob_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticVFSGlob), 0, (GInstanceInitFunc) desktop_agnostic_vfs_glob_instance_init, NULL };
		GType desktop_agnostic_vfs_glob_type_id;
		desktop_agnostic_vfs_glob_type_id = g_type_register_static (G_TYPE_OBJECT, "DesktopAgnosticVFSGlob", &g_define_type_info, 0);
		g_once_init_leave (&desktop_agnostic_vfs_glob_type_id__volatile, desktop_agnostic_vfs_glob_type_id);
	}
	return desktop_agnostic_vfs_glob_type_id__volatile;
}


static void _vala_desktop_agnostic_vfs_glob_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DesktopAgnosticVFSGlob * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_VFS_TYPE_GLOB, DesktopAgnosticVFSGlob);
	switch (property_id) {
		case DESKTOP_AGNOSTIC_VFS_GLOB_OFFSET:
		g_value_set_ulong (value, desktop_agnostic_vfs_glob_get_offset (self));
		break;
		case DESKTOP_AGNOSTIC_VFS_GLOB_PATTERN:
		g_value_set_string (value, desktop_agnostic_vfs_glob_get_pattern (self));
		break;
		case DESKTOP_AGNOSTIC_VFS_GLOB_FLAGS:
		g_value_set_int (value, desktop_agnostic_vfs_glob_get_flags (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_desktop_agnostic_vfs_glob_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DesktopAgnosticVFSGlob * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DESKTOP_AGNOSTIC_VFS_TYPE_GLOB, DesktopAgnosticVFSGlob);
	switch (property_id) {
		case DESKTOP_AGNOSTIC_VFS_GLOB_PATTERN:
		desktop_agnostic_vfs_glob_set_pattern (self, g_value_get_string (value));
		break;
		case DESKTOP_AGNOSTIC_VFS_GLOB_FLAGS:
		desktop_agnostic_vfs_glob_set_flags (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



