/* test-color.c generated by valac 0.20.1, the Vala compiler
 * generated from test-color.vala, do not modify */

/*
 * Tests the Color class, plus its interaction with the Config interface.
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <libdesktop-agnostic/desktop-agnostic.h>
#include <stdlib.h>
#include <string.h>
#include <libdesktop-agnostic/config.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



void print_color (DesktopAgnosticColor* clr, const gchar* name);
void print_cfg_color (DesktopAgnosticConfigBackend* cfg, const gchar* name);
gint _vala_main (gchar** args, int args_length1);


void print_color (DesktopAgnosticColor* clr, const gchar* name) {
	DesktopAgnosticColor* _tmp0_;
	g_return_if_fail (name != NULL);
	_tmp0_ = clr;
	if (_tmp0_ == NULL) {
		const gchar* _tmp1_;
		_tmp1_ = name;
		g_message ("test-color.vala:29: color '%s' is NULL", _tmp1_);
	} else {
		const gchar* _tmp2_;
		DesktopAgnosticColor* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		_tmp2_ = name;
		_tmp3_ = clr;
		_tmp4_ = desktop_agnostic_color_to_string (_tmp3_);
		_tmp5_ = _tmp4_;
		g_message ("test-color.vala:33: color '%s' = %s", _tmp2_, _tmp5_);
		_g_free0 (_tmp5_);
	}
}


void print_cfg_color (DesktopAgnosticConfigBackend* cfg, const gchar* name) {
	GValue val = {0};
	DesktopAgnosticConfigBackend* _tmp0_;
	const gchar* _tmp1_;
	GValue _tmp2_ = {0};
	GValue _tmp3_;
	GValue _tmp4_;
	const gchar* _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (cfg != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = cfg;
	_tmp1_ = name;
	desktop_agnostic_config_backend_get_value (_tmp0_, DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT, _tmp1_, &_tmp2_, &_inner_error_);
	_tmp3_ = _tmp2_;
	if (_inner_error_ != NULL) {
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp3_;
	_tmp4_ = val;
	_tmp5_ = name;
	print_color (g_value_get_object (&_tmp4_), _tmp5_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
}


gint _vala_main (gchar** args, int args_length1) {
	gint result = 0;
	GError * _inner_error_ = NULL;
	{
		DesktopAgnosticConfigSchema* _tmp14_;
		DesktopAgnosticConfigSchema* schema;
		DesktopAgnosticConfigSchema* _tmp15_;
		DesktopAgnosticConfigBackend* _tmp16_ = NULL;
		DesktopAgnosticConfigBackend* cfg;
		DesktopAgnosticConfigBackend* _tmp17_;
		DesktopAgnosticConfigBackend* _tmp18_;
		DesktopAgnosticConfigBackend* _tmp19_;
		GValue _tmp20_ = {0};
		GValue val;
		GValue _tmp21_;
		GValueArray* array;
		{
			DesktopAgnosticColor* _tmp0_;
			DesktopAgnosticColor* green;
			DesktopAgnosticColor* _tmp1_;
			guint _tmp2_;
			guint _tmp3_;
			gushort _tmp4_;
			DesktopAgnosticColor* _tmp5_;
			gchar* _tmp6_ = NULL;
			gchar* _tmp7_;
			DesktopAgnosticColor* _tmp8_;
			DesktopAgnosticColor* one_char_hex;
			DesktopAgnosticColor* _tmp9_;
			gchar* _tmp10_ = NULL;
			gchar* _tmp11_;
			_tmp0_ = desktop_agnostic_color_new_from_string ("green", &_inner_error_);
			green = _tmp0_;
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR) {
					goto __catch1_desktop_agnostic_color_parse_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return 0;
			}
			_tmp1_ = green;
			_tmp2_ = desktop_agnostic_color_get_alpha (_tmp1_);
			_tmp3_ = _tmp2_;
			_tmp4_ = G_MAXUSHORT;
			_vala_assert (_tmp3_ == ((guint) _tmp4_), "green.alpha == ushort.MAX");
			_tmp5_ = green;
			_tmp6_ = desktop_agnostic_color_to_string (_tmp5_);
			_tmp7_ = _tmp6_;
			g_message ("test-color.vala:53: green = %s", _tmp7_);
			_g_free0 (_tmp7_);
			_tmp8_ = desktop_agnostic_color_new_from_string ("#f00f", &_inner_error_);
			one_char_hex = _tmp8_;
			if (_inner_error_ != NULL) {
				_g_object_unref0 (green);
				if (_inner_error_->domain == DESKTOP_AGNOSTIC_COLOR_PARSE_ERROR) {
					goto __catch1_desktop_agnostic_color_parse_error;
				}
				_g_object_unref0 (green);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return 0;
			}
			_tmp9_ = one_char_hex;
			_tmp10_ = desktop_agnostic_color_to_string (_tmp9_);
			_tmp11_ = _tmp10_;
			g_message ("test-color.vala:55: red = %s", _tmp11_);
			_g_free0 (_tmp11_);
			_g_object_unref0 (one_char_hex);
			_g_object_unref0 (green);
		}
		goto __finally1;
		__catch1_desktop_agnostic_color_parse_error:
		{
			GError* err = NULL;
			GError* _tmp12_;
			const gchar* _tmp13_;
			err = _inner_error_;
			_inner_error_ = NULL;
			_tmp12_ = err;
			_tmp13_ = _tmp12_->message;
			g_critical ("test-color.vala:59: Color parse error: %s", _tmp13_);
			_g_error_free0 (err);
		}
		__finally1:
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
		_tmp14_ = desktop_agnostic_config_schema_new ("test-color.schema-ini", &_inner_error_);
		schema = _tmp14_;
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
		_tmp15_ = schema;
		_tmp16_ = desktop_agnostic_config_new (_tmp15_, &_inner_error_);
		cfg = _tmp16_;
		if (_inner_error_ != NULL) {
			_g_object_unref0 (schema);
			goto __catch0_g_error;
		}
		_tmp17_ = cfg;
		print_cfg_color (_tmp17_, "color");
		_tmp18_ = cfg;
		print_cfg_color (_tmp18_, "none");
		_tmp19_ = cfg;
		desktop_agnostic_config_backend_get_value (_tmp19_, DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT, "color_list", &_tmp20_, &_inner_error_);
		val = _tmp20_;
		if (_inner_error_ != NULL) {
			_g_object_unref0 (cfg);
			_g_object_unref0 (schema);
			goto __catch0_g_error;
		}
		_tmp21_ = val;
		array = g_value_get_boxed (&_tmp21_);
		{
			guint i;
			i = (guint) 0;
			{
				gboolean _tmp22_;
				_tmp22_ = TRUE;
				while (TRUE) {
					gboolean _tmp23_;
					guint _tmp25_;
					GValueArray* _tmp26_;
					guint _tmp27_;
					GValueArray* _tmp28_;
					guint _tmp29_;
					GValue* _tmp30_ = NULL;
					GValue v;
					GValue _tmp31_;
					guint _tmp32_;
					gchar* _tmp33_ = NULL;
					gchar* _tmp34_;
					_tmp23_ = _tmp22_;
					if (!_tmp23_) {
						guint _tmp24_;
						_tmp24_ = i;
						i = _tmp24_ + 1;
					}
					_tmp22_ = FALSE;
					_tmp25_ = i;
					_tmp26_ = array;
					_tmp27_ = _tmp26_->n_values;
					if (!(_tmp25_ < _tmp27_)) {
						break;
					}
					_tmp28_ = array;
					_tmp29_ = i;
					_tmp30_ = g_value_array_get_nth (_tmp28_, _tmp29_);
					v = *_tmp30_;
					_tmp31_ = v;
					_tmp32_ = i;
					_tmp33_ = g_strdup_printf ("color_list[%u]", _tmp32_);
					_tmp34_ = _tmp33_;
					print_color (g_value_get_object (&_tmp31_), _tmp34_);
					_g_free0 (_tmp34_);
				}
			}
		}
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
		_g_object_unref0 (cfg);
		_g_object_unref0 (schema);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp35_;
		const gchar* _tmp36_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp35_ = err;
		_tmp36_ = _tmp35_->message;
		g_critical ("test-color.vala:75: Error: %s", _tmp36_);
		result = 1;
		_g_error_free0 (err);
		return result;
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
	result = 0;
	return result;
}


int main (int argc, char ** argv) {
	g_type_init ();
	return _vala_main (argv, argc);
}



