/* test-config.c generated by valac 0.20.1, the Vala compiler
 * generated from test-config.vala, do not modify */

/*
 * Desktop Agnostic Library: Test for the config backend implementations.
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <libdesktop-agnostic/config.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define TYPE_TEST_CASE (test_case_get_type ())
#define TEST_CASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TEST_CASE, TestCase))
#define TEST_CASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TEST_CASE, TestCaseClass))
#define IS_TEST_CASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TEST_CASE))
#define IS_TEST_CASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TEST_CASE))
#define TEST_CASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TEST_CASE, TestCaseClass))

typedef struct _TestCase TestCase;
typedef struct _TestCaseClass TestCaseClass;
typedef struct _TestCasePrivate TestCasePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _test_case_unref0(var) ((var == NULL) ? NULL : (var = (test_case_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_value_array_free0(var) ((var == NULL) ? NULL : (var = (g_value_array_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecTestCase ParamSpecTestCase;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	ASSERTION_ERROR_NOT_EQUAL,
	ASSERTION_ERROR_INVALID_TYPE,
	ASSERTION_ERROR_NOT_REACHED
} AssertionError;
#define ASSERTION_ERROR assertion_error_quark ()
struct _TestCase {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TestCasePrivate * priv;
};

struct _TestCaseClass {
	GTypeClass parent_class;
	void (*finalize) (TestCase *self);
};

struct _TestCasePrivate {
	DesktopAgnosticConfigBackend* cfg;
	guint notify_counter;
	GMainLoop* ml;
	gint retval;
};

typedef void (*TestCaseGetCfgFunc) (DesktopAgnosticConfigBackend* cfg, const gchar* group, const gchar* key, GError** error);
struct _ParamSpecTestCase {
	GParamSpec parent_instance;
};


static gpointer test_case_parent_class = NULL;

GQuark assertion_error_quark (void);
#define EXIT_SUCCESS 0
#define EXIT_ASSERTION 1
#define EXIT_EXCEPTION 2
gpointer test_case_ref (gpointer instance);
void test_case_unref (gpointer instance);
GParamSpec* param_spec_test_case (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_test_case (GValue* value, gpointer v_object);
void value_take_test_case (GValue* value, gpointer v_object);
gpointer value_get_test_case (const GValue* value);
GType test_case_get_type (void) G_GNUC_CONST;
#define TEST_CASE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TEST_CASE, TestCasePrivate))
enum  {
	TEST_CASE_DUMMY_PROPERTY
};
TestCase* test_case_new (GError** error);
TestCase* test_case_construct (GType object_type, GError** error);
static void test_case_on_string_changed (TestCase* self, const gchar* group, const gchar* key, GValue* value);
static void test_case_on_string_changed2 (TestCase* self, const gchar* group, const gchar* key, GValue* value);
static gboolean test_case_array_equals (TestCase* self, GValueArray* expected, GValueArray* actual, GError** error);
static void test_case_assert_equals (TestCase* self, GValue* expected, GValue* actual, GError** error);
static void test_case_test_default_empty_list (TestCase* self, const gchar* suffix, GError** error);
static void test_case_test_defaults (TestCase* self, GError** error);
static void test_case_test_set_empty_list (TestCase* self, const gchar* key, GError** error);
static void test_case_test_set (TestCase* self, GError** error);
static void test_case_update_notify_value (TestCase* self, GMainContext* ctx, const gchar* value, guint counter_expected, GError** error);
static void test_case_test_notify (TestCase* self, GError** error);
static void _test_case_on_string_changed_desktop_agnostic_config_notify_func (const gchar* group, const gchar* key, GValue* value, gpointer self);
static void _test_case_on_string_changed2_desktop_agnostic_config_notify_func (const gchar* group, const gchar* key, GValue* value, gpointer self);
static void test_case_test_invalid_func (TestCase* self, TestCaseGetCfgFunc func, GError** error);
static void test_case_test_invalid (TestCase* self, GError** error);
gint test_case_main (gchar** args, int args_length1);
static void test_case_finalize (TestCase* obj);


GQuark assertion_error_quark (void) {
	return g_quark_from_static_string ("assertion_error-quark");
}


TestCase* test_case_construct (GType object_type, GError** error) {
	TestCase* self = NULL;
	DesktopAgnosticConfigSchema* _tmp0_;
	DesktopAgnosticConfigSchema* schema;
	DesktopAgnosticConfigSchema* _tmp1_;
	DesktopAgnosticConfigSchema* _tmp2_;
	DesktopAgnosticConfigBackend* _tmp3_ = NULL;
	DesktopAgnosticConfigBackend* _tmp4_;
	DesktopAgnosticConfigBackend* _tmp5_;
	GMainLoop* _tmp6_;
	GError * _inner_error_ = NULL;
	self = (TestCase*) g_type_create_instance (object_type);
	_tmp0_ = desktop_agnostic_config_schema_new ("test-config.schema-ini", &_inner_error_);
	schema = _tmp0_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_test_case_unref0 (self);
		return NULL;
	}
	_tmp1_ = schema;
	schema = NULL;
	_tmp2_ = _tmp1_;
	_tmp3_ = desktop_agnostic_config_new (_tmp2_, &_inner_error_);
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp2_);
	_tmp5_ = _tmp4_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (schema);
		_test_case_unref0 (self);
		return NULL;
	}
	_g_object_unref0 (self->priv->cfg);
	self->priv->cfg = _tmp5_;
	self->priv->notify_counter = (guint) 0;
	_tmp6_ = g_main_loop_new (NULL, FALSE);
	_g_main_loop_unref0 (self->priv->ml);
	self->priv->ml = _tmp6_;
	self->priv->retval = 0;
	_g_object_unref0 (schema);
	return self;
}


TestCase* test_case_new (GError** error) {
	return test_case_construct (TYPE_TEST_CASE, error);
}


static void test_case_on_string_changed (TestCase* self, const gchar* group, const gchar* key, GValue* value) {
	guint _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (group != NULL);
	g_return_if_fail (key != NULL);
	g_return_if_fail (value != NULL);
	_tmp0_ = self->priv->notify_counter;
	self->priv->notify_counter = _tmp0_ + 1;
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


static void test_case_on_string_changed2 (TestCase* self, const gchar* group, const gchar* key, GValue* value) {
	GValue _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (group != NULL);
	g_return_if_fail (key != NULL);
	g_return_if_fail (value != NULL);
	_tmp0_ = *value;
	_tmp1_ = string_contains (g_value_get_string (&_tmp0_), "quux");
	if (_tmp1_) {
		guint _tmp2_;
		_tmp2_ = self->priv->notify_counter;
		self->priv->notify_counter = _tmp2_ + 3;
	}
}


static gboolean test_case_array_equals (TestCase* self, GValueArray* expected, GValueArray* actual, GError** error) {
	gboolean result = FALSE;
	gboolean equal;
	GValueArray* _tmp0_;
	guint _tmp1_;
	GValueArray* _tmp2_;
	guint _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (expected != NULL, FALSE);
	g_return_val_if_fail (actual != NULL, FALSE);
	equal = TRUE;
	_tmp0_ = expected;
	_tmp1_ = _tmp0_->n_values;
	_tmp2_ = actual;
	_tmp3_ = _tmp2_->n_values;
	if (_tmp1_ == _tmp3_) {
		{
			guint i;
			i = (guint) 0;
			{
				gboolean _tmp4_;
				_tmp4_ = TRUE;
				while (TRUE) {
					gboolean _tmp5_;
					guint _tmp7_;
					GValueArray* _tmp8_;
					guint _tmp9_;
					GValueArray* _tmp10_;
					guint _tmp11_;
					GValue* _tmp12_ = NULL;
					GValueArray* _tmp13_;
					guint _tmp14_;
					GValue* _tmp15_ = NULL;
					GValue _tmp16_;
					GValue _tmp17_;
					_tmp5_ = _tmp4_;
					if (!_tmp5_) {
						guint _tmp6_;
						_tmp6_ = i;
						i = _tmp6_ + 1;
					}
					_tmp4_ = FALSE;
					_tmp7_ = i;
					_tmp8_ = actual;
					_tmp9_ = _tmp8_->n_values;
					if (!(_tmp7_ < _tmp9_)) {
						break;
					}
					_tmp10_ = expected;
					_tmp11_ = i;
					_tmp12_ = g_value_array_get_nth (_tmp10_, _tmp11_);
					_tmp13_ = actual;
					_tmp14_ = i;
					_tmp15_ = g_value_array_get_nth (_tmp13_, _tmp14_);
					_tmp16_ = *_tmp12_;
					_tmp17_ = *_tmp15_;
					test_case_assert_equals (self, &_tmp16_, &_tmp17_, &_inner_error_);
					if (_inner_error_ != NULL) {
						if (_inner_error_->domain == ASSERTION_ERROR) {
							g_propagate_error (error, _inner_error_);
							return FALSE;
						} else {
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return FALSE;
						}
					}
				}
			}
		}
	} else {
		equal = FALSE;
	}
	result = equal;
	return result;
}


static void test_case_assert_equals (TestCase* self, GValue* expected, GValue* actual, GError** error) {
	gboolean equal;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp20_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (expected != NULL);
	g_return_if_fail (actual != NULL);
	equal = TRUE;
	_tmp0_ = G_VALUE_HOLDS (actual, G_TYPE_BOOLEAN);
	if (_tmp0_) {
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		_tmp1_ = g_value_get_boolean (expected);
		_tmp2_ = g_value_get_boolean (actual);
		equal = _tmp1_ == _tmp2_;
	} else {
		gboolean _tmp3_ = FALSE;
		_tmp3_ = G_VALUE_HOLDS (actual, G_TYPE_INT);
		if (_tmp3_) {
			gint _tmp4_ = 0;
			gint _tmp5_ = 0;
			_tmp4_ = g_value_get_int (expected);
			_tmp5_ = g_value_get_int (actual);
			equal = _tmp4_ == _tmp5_;
		} else {
			gboolean _tmp6_ = FALSE;
			_tmp6_ = G_VALUE_HOLDS (actual, G_TYPE_FLOAT);
			if (_tmp6_) {
				gfloat _tmp7_ = 0.0F;
				gfloat _tmp8_ = 0.0F;
				_tmp7_ = g_value_get_float (expected);
				_tmp8_ = g_value_get_float (actual);
				equal = _tmp7_ == _tmp8_;
			} else {
				gboolean _tmp9_ = FALSE;
				_tmp9_ = G_VALUE_HOLDS (actual, G_TYPE_STRING);
				if (_tmp9_) {
					const gchar* _tmp10_ = NULL;
					const gchar* _tmp11_ = NULL;
					_tmp10_ = g_value_get_string (expected);
					_tmp11_ = g_value_get_string (actual);
					equal = g_strcmp0 (_tmp10_, _tmp11_) == 0;
				} else {
					gboolean _tmp12_ = FALSE;
					_tmp12_ = G_VALUE_HOLDS (actual, G_TYPE_VALUE_ARRAY);
					if (_tmp12_) {
						GValue _tmp13_;
						GValue _tmp14_;
						gboolean _tmp15_ = FALSE;
						gboolean _tmp16_;
						_tmp13_ = *expected;
						_tmp14_ = *actual;
						_tmp15_ = test_case_array_equals (self, g_value_get_boxed (&_tmp13_), g_value_get_boxed (&_tmp14_), &_inner_error_);
						_tmp16_ = _tmp15_;
						if (_inner_error_ != NULL) {
							if (_inner_error_->domain == ASSERTION_ERROR) {
								g_propagate_error (error, _inner_error_);
								return;
							} else {
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
								g_clear_error (&_inner_error_);
								return;
							}
						}
						equal = _tmp16_;
					} else {
						GType _tmp17_ = 0UL;
						const gchar* _tmp18_ = NULL;
						GError* _tmp19_;
						_tmp17_ = G_VALUE_TYPE (actual);
						_tmp18_ = g_type_name (_tmp17_);
						_tmp19_ = g_error_new (ASSERTION_ERROR, ASSERTION_ERROR_INVALID_TYPE, "Invalid value type (%s).", _tmp18_);
						_inner_error_ = _tmp19_;
						if (_inner_error_->domain == ASSERTION_ERROR) {
							g_propagate_error (error, _inner_error_);
							return;
						} else {
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return;
						}
					}
				}
			}
		}
	}
	_tmp20_ = equal;
	if (!_tmp20_) {
		gchar* _tmp21_ = NULL;
		gchar* _tmp22_;
		gchar* _tmp23_ = NULL;
		gchar* _tmp24_;
		GError* _tmp25_;
		GError* _tmp26_;
		_tmp21_ = g_strdup_value_contents (expected);
		_tmp22_ = _tmp21_;
		_tmp23_ = g_strdup_value_contents (actual);
		_tmp24_ = _tmp23_;
		_tmp25_ = g_error_new (ASSERTION_ERROR, ASSERTION_ERROR_NOT_EQUAL, "%s != %s", _tmp22_, _tmp24_);
		_tmp26_ = _tmp25_;
		_g_free0 (_tmp24_);
		_g_free0 (_tmp22_);
		_inner_error_ = _tmp26_;
		if (_inner_error_->domain == ASSERTION_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void test_case_test_default_empty_list (TestCase* self, const gchar* suffix, GError** error) {
	GValueArray* expected_array = NULL;
	GValue expected = {0};
	gchar* key = NULL;
	GValueArray* _tmp0_;
	GValueArray* _tmp1_;
	GValue _tmp2_ = {0};
	const gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	DesktopAgnosticConfigBackend* _tmp5_;
	const gchar* _tmp6_;
	GValue _tmp7_ = {0};
	GValue _tmp8_;
	GValue _tmp9_;
	GValue _tmp10_;
	DesktopAgnosticConfigBackend* _tmp11_;
	const gchar* _tmp12_;
	GValueArray* _tmp13_ = NULL;
	GValueArray* _tmp14_;
	GValueArray* _tmp15_;
	GValueArray* _tmp16_;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_;
	gboolean _tmp19_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (suffix != NULL);
	_tmp0_ = g_value_array_new ((guint) 0);
	_g_value_array_free0 (expected_array);
	expected_array = _tmp0_;
	_tmp1_ = expected_array;
	g_value_init (&_tmp2_, G_TYPE_VALUE_ARRAY);
	g_value_set_boxed (&_tmp2_, _tmp1_);
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp2_;
	_tmp3_ = suffix;
	_tmp4_ = g_strdup_printf ("list-%s", _tmp3_);
	_g_free0 (key);
	key = _tmp4_;
	_tmp5_ = self->priv->cfg;
	_tmp6_ = key;
	desktop_agnostic_config_backend_get_value (_tmp5_, "empty", _tmp6_, &_tmp7_, &_inner_error_);
	_tmp8_ = _tmp7_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (key);
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		_g_value_array_free0 (expected_array);
		return;
	}
	_tmp9_ = expected;
	_tmp10_ = _tmp8_;
	test_case_assert_equals (self, &_tmp9_, &_tmp10_, &_inner_error_);
	G_IS_VALUE (&_tmp10_) ? (g_value_unset (&_tmp10_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (key);
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		_g_value_array_free0 (expected_array);
		return;
	}
	_tmp11_ = self->priv->cfg;
	_tmp12_ = key;
	_tmp13_ = desktop_agnostic_config_backend_get_list (_tmp11_, "empty", _tmp12_, &_inner_error_);
	_tmp14_ = _tmp13_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (key);
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		_g_value_array_free0 (expected_array);
		return;
	}
	_tmp15_ = expected_array;
	_tmp16_ = _tmp14_;
	_tmp17_ = test_case_array_equals (self, _tmp15_, _tmp16_, &_inner_error_);
	_tmp18_ = _tmp17_;
	_g_value_array_free0 (_tmp16_);
	_tmp19_ = _tmp18_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (key);
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		_g_value_array_free0 (expected_array);
		return;
	}
	_vala_assert (_tmp19_, "array_equals (expected_array,                           cfg.get_list (\"empty\", key))");
	_g_free0 (key);
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	_g_value_array_free0 (expected_array);
}


static void test_case_test_defaults (TestCase* self, GError** error) {
	GValue expected = {0};
	GValue item_1 = {0};
	GValue item_2 = {0};
	GValue item_3 = {0};
	GValueArray* expected_array = NULL;
	DesktopAgnosticConfigBackend* _tmp0_;
	GValue _tmp1_ = {0};
	DesktopAgnosticConfigBackend* _tmp2_;
	GValue _tmp3_ = {0};
	GValue _tmp4_;
	GValue _tmp5_;
	GValue _tmp6_;
	DesktopAgnosticConfigBackend* _tmp7_;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_;
	GValue _tmp10_;
	GValue _tmp11_ = {0};
	DesktopAgnosticConfigBackend* _tmp12_;
	GValue _tmp13_ = {0};
	GValue _tmp14_;
	GValue _tmp15_;
	GValue _tmp16_;
	DesktopAgnosticConfigBackend* _tmp17_;
	gint _tmp18_ = 0;
	gint _tmp19_;
	GValue _tmp20_;
	GValue _tmp21_ = {0};
	DesktopAgnosticConfigBackend* _tmp22_;
	GValue _tmp23_ = {0};
	GValue _tmp24_;
	GValue _tmp25_;
	GValue _tmp26_;
	DesktopAgnosticConfigBackend* _tmp27_;
	gfloat _tmp28_ = 0.0F;
	gfloat _tmp29_;
	GValue _tmp30_;
	GValue _tmp31_ = {0};
	DesktopAgnosticConfigBackend* _tmp32_;
	GValue _tmp33_ = {0};
	GValue _tmp34_;
	GValue _tmp35_;
	GValue _tmp36_;
	DesktopAgnosticConfigBackend* _tmp37_;
	gchar* _tmp38_ = NULL;
	gchar* _tmp39_;
	GValue _tmp40_;
	gchar* _tmp41_;
	GValue _tmp42_ = {0};
	DesktopAgnosticConfigBackend* _tmp43_;
	GValue _tmp44_ = {0};
	GValue _tmp45_;
	GValue _tmp46_;
	GValue _tmp47_;
	DesktopAgnosticConfigBackend* _tmp48_;
	gchar* _tmp49_ = NULL;
	gchar* _tmp50_;
	GValue _tmp51_;
	gchar* _tmp52_;
	GValueArray* _tmp53_;
	GValue _tmp54_ = {0};
	GValue _tmp55_ = {0};
	GValueArray* _tmp56_;
	GValue _tmp57_;
	GValueArray* _tmp58_;
	GValue _tmp59_;
	GValueArray* _tmp60_;
	GValue _tmp61_ = {0};
	DesktopAgnosticConfigBackend* _tmp62_;
	GValue _tmp63_ = {0};
	GValue _tmp64_;
	GValue _tmp65_;
	GValue _tmp66_;
	DesktopAgnosticConfigBackend* _tmp67_;
	GValueArray* _tmp68_ = NULL;
	GValueArray* _tmp69_;
	GValue _tmp70_;
	GValueArray* _tmp71_;
	gboolean _tmp72_ = FALSE;
	gboolean _tmp73_;
	gboolean _tmp74_;
	GValueArray* _tmp75_;
	GValue _tmp76_ = {0};
	GValue _tmp77_ = {0};
	GValue _tmp78_ = {0};
	GValueArray* _tmp79_;
	GValue _tmp80_;
	GValueArray* _tmp81_;
	GValue _tmp82_;
	GValueArray* _tmp83_;
	GValue _tmp84_;
	GValueArray* _tmp85_;
	GValue _tmp86_ = {0};
	DesktopAgnosticConfigBackend* _tmp87_;
	GValue _tmp88_ = {0};
	GValue _tmp89_;
	GValue _tmp90_;
	GValue _tmp91_;
	DesktopAgnosticConfigBackend* _tmp92_;
	GValueArray* _tmp93_ = NULL;
	GValueArray* _tmp94_;
	GValue _tmp95_;
	GValueArray* _tmp96_;
	gboolean _tmp97_ = FALSE;
	gboolean _tmp98_;
	gboolean _tmp99_;
	GValueArray* _tmp100_;
	GValue _tmp101_ = {0};
	GValue _tmp102_ = {0};
	GValue _tmp103_ = {0};
	GValueArray* _tmp104_;
	GValue _tmp105_;
	GValueArray* _tmp106_;
	GValue _tmp107_;
	GValueArray* _tmp108_;
	GValue _tmp109_;
	GValueArray* _tmp110_;
	GValue _tmp111_ = {0};
	DesktopAgnosticConfigBackend* _tmp112_;
	GValue _tmp113_ = {0};
	GValue _tmp114_;
	GValue _tmp115_;
	GValue _tmp116_;
	DesktopAgnosticConfigBackend* _tmp117_;
	GValueArray* _tmp118_ = NULL;
	GValueArray* _tmp119_;
	GValue _tmp120_;
	GValueArray* _tmp121_;
	gboolean _tmp122_ = FALSE;
	gboolean _tmp123_;
	gboolean _tmp124_;
	GValueArray* _tmp125_;
	GValue _tmp126_ = {0};
	GValue _tmp127_ = {0};
	GValueArray* _tmp128_;
	GValue _tmp129_;
	GValueArray* _tmp130_;
	GValue _tmp131_;
	GValueArray* _tmp132_;
	GValue _tmp133_ = {0};
	DesktopAgnosticConfigBackend* _tmp134_;
	GValue _tmp135_ = {0};
	GValue _tmp136_;
	GValue _tmp137_;
	GValue _tmp138_;
	DesktopAgnosticConfigBackend* _tmp139_;
	GValueArray* _tmp140_ = NULL;
	GValueArray* _tmp141_;
	GValue _tmp142_;
	GValueArray* _tmp143_;
	gboolean _tmp144_ = FALSE;
	gboolean _tmp145_;
	gboolean _tmp146_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->cfg;
	desktop_agnostic_config_backend_reset (_tmp0_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	g_value_init (&_tmp1_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp1_, TRUE);
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp1_;
	_tmp2_ = self->priv->cfg;
	desktop_agnostic_config_backend_get_value (_tmp2_, "numeric", "boolean", &_tmp3_, &_inner_error_);
	_tmp4_ = _tmp3_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp5_ = expected;
	_tmp6_ = _tmp4_;
	test_case_assert_equals (self, &_tmp5_, &_tmp6_, &_inner_error_);
	G_IS_VALUE (&_tmp6_) ? (g_value_unset (&_tmp6_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp7_ = self->priv->cfg;
	_tmp8_ = desktop_agnostic_config_backend_get_bool (_tmp7_, "numeric", "boolean", &_inner_error_);
	_tmp9_ = _tmp8_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp10_ = expected;
	_vala_assert (g_value_get_boolean (&_tmp10_) == _tmp9_, "(bool)expected == cfg.get_bool (\"numeric\", \"boolean\")");
	g_value_init (&_tmp11_, G_TYPE_INT);
	g_value_set_int (&_tmp11_, 3);
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp11_;
	_tmp12_ = self->priv->cfg;
	desktop_agnostic_config_backend_get_value (_tmp12_, "numeric", "integer", &_tmp13_, &_inner_error_);
	_tmp14_ = _tmp13_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp15_ = expected;
	_tmp16_ = _tmp14_;
	test_case_assert_equals (self, &_tmp15_, &_tmp16_, &_inner_error_);
	G_IS_VALUE (&_tmp16_) ? (g_value_unset (&_tmp16_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp17_ = self->priv->cfg;
	_tmp18_ = desktop_agnostic_config_backend_get_int (_tmp17_, "numeric", "integer", &_inner_error_);
	_tmp19_ = _tmp18_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp20_ = expected;
	_vala_assert (g_value_get_int (&_tmp20_) == _tmp19_, "(int)expected == cfg.get_int (\"numeric\", \"integer\")");
	g_value_init (&_tmp21_, G_TYPE_FLOAT);
	g_value_set_float (&_tmp21_, 3.14f);
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp21_;
	_tmp22_ = self->priv->cfg;
	desktop_agnostic_config_backend_get_value (_tmp22_, "numeric", "float", &_tmp23_, &_inner_error_);
	_tmp24_ = _tmp23_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp25_ = expected;
	_tmp26_ = _tmp24_;
	test_case_assert_equals (self, &_tmp25_, &_tmp26_, &_inner_error_);
	G_IS_VALUE (&_tmp26_) ? (g_value_unset (&_tmp26_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp27_ = self->priv->cfg;
	_tmp28_ = desktop_agnostic_config_backend_get_float (_tmp27_, "numeric", "float", &_inner_error_);
	_tmp29_ = _tmp28_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp30_ = expected;
	_vala_assert (g_value_get_float (&_tmp30_) == _tmp29_, "(float)expected == cfg.get_float (\"numeric\", \"float\")");
	g_value_init (&_tmp31_, G_TYPE_STRING);
	g_value_set_string (&_tmp31_, "Foo bar");
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp31_;
	_tmp32_ = self->priv->cfg;
	desktop_agnostic_config_backend_get_value (_tmp32_, "misc", "string", &_tmp33_, &_inner_error_);
	_tmp34_ = _tmp33_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp35_ = expected;
	_tmp36_ = _tmp34_;
	test_case_assert_equals (self, &_tmp35_, &_tmp36_, &_inner_error_);
	G_IS_VALUE (&_tmp36_) ? (g_value_unset (&_tmp36_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp37_ = self->priv->cfg;
	_tmp38_ = desktop_agnostic_config_backend_get_string (_tmp37_, "misc", "string", &_inner_error_);
	_tmp39_ = _tmp38_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp40_ = expected;
	_tmp41_ = _tmp39_;
	_vala_assert (g_strcmp0 (g_value_get_string (&_tmp40_), _tmp41_) == 0, "(string)expected == cfg.get_string (\"misc\", \"string\")");
	_g_free0 (_tmp41_);
	g_value_init (&_tmp42_, G_TYPE_STRING);
	g_value_set_string (&_tmp42_, "");
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp42_;
	_tmp43_ = self->priv->cfg;
	desktop_agnostic_config_backend_get_value (_tmp43_, "empty", "string", &_tmp44_, &_inner_error_);
	_tmp45_ = _tmp44_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp46_ = expected;
	_tmp47_ = _tmp45_;
	test_case_assert_equals (self, &_tmp46_, &_tmp47_, &_inner_error_);
	G_IS_VALUE (&_tmp47_) ? (g_value_unset (&_tmp47_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp48_ = self->priv->cfg;
	_tmp49_ = desktop_agnostic_config_backend_get_string (_tmp48_, "empty", "string", &_inner_error_);
	_tmp50_ = _tmp49_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp51_ = expected;
	_tmp52_ = _tmp50_;
	_vala_assert (g_strcmp0 (g_value_get_string (&_tmp51_), _tmp52_) == 0, "(string)expected == cfg.get_string (\"empty\", \"string\")");
	_g_free0 (_tmp52_);
	_tmp53_ = g_value_array_new ((guint) 2);
	_g_value_array_free0 (expected_array);
	expected_array = _tmp53_;
	g_value_init (&_tmp54_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp54_, TRUE);
	G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
	item_1 = _tmp54_;
	g_value_init (&_tmp55_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp55_, FALSE);
	G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
	item_2 = _tmp55_;
	_tmp56_ = expected_array;
	_tmp57_ = item_1;
	g_value_array_append (_tmp56_, &_tmp57_);
	_tmp58_ = expected_array;
	_tmp59_ = item_2;
	g_value_array_append (_tmp58_, &_tmp59_);
	_tmp60_ = expected_array;
	g_value_init (&_tmp61_, G_TYPE_VALUE_ARRAY);
	g_value_set_boxed (&_tmp61_, _tmp60_);
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp61_;
	_tmp62_ = self->priv->cfg;
	desktop_agnostic_config_backend_get_value (_tmp62_, "list", "boolean", &_tmp63_, &_inner_error_);
	_tmp64_ = _tmp63_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp65_ = expected;
	_tmp66_ = _tmp64_;
	test_case_assert_equals (self, &_tmp65_, &_tmp66_, &_inner_error_);
	G_IS_VALUE (&_tmp66_) ? (g_value_unset (&_tmp66_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp67_ = self->priv->cfg;
	_tmp68_ = desktop_agnostic_config_backend_get_list (_tmp67_, "list", "boolean", &_inner_error_);
	_tmp69_ = _tmp68_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp70_ = expected;
	_tmp71_ = _tmp69_;
	_tmp72_ = test_case_array_equals (self, g_value_get_boxed (&_tmp70_), _tmp71_, &_inner_error_);
	_tmp73_ = _tmp72_;
	_g_value_array_free0 (_tmp71_);
	_tmp74_ = _tmp73_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_vala_assert (_tmp74_, "array_equals ((ValueArray)expected,                           cfg.get_list (\"list\", \"boolean\"))");
	_tmp75_ = g_value_array_new ((guint) 3);
	_g_value_array_free0 (expected_array);
	expected_array = _tmp75_;
	g_value_init (&_tmp76_, G_TYPE_INT);
	g_value_set_int (&_tmp76_, 1);
	G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
	item_1 = _tmp76_;
	g_value_init (&_tmp77_, G_TYPE_INT);
	g_value_set_int (&_tmp77_, 2);
	G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
	item_2 = _tmp77_;
	g_value_init (&_tmp78_, G_TYPE_INT);
	g_value_set_int (&_tmp78_, 3);
	G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
	item_3 = _tmp78_;
	_tmp79_ = expected_array;
	_tmp80_ = item_1;
	g_value_array_append (_tmp79_, &_tmp80_);
	_tmp81_ = expected_array;
	_tmp82_ = item_2;
	g_value_array_append (_tmp81_, &_tmp82_);
	_tmp83_ = expected_array;
	_tmp84_ = item_3;
	g_value_array_append (_tmp83_, &_tmp84_);
	_tmp85_ = expected_array;
	g_value_init (&_tmp86_, G_TYPE_VALUE_ARRAY);
	g_value_set_boxed (&_tmp86_, _tmp85_);
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp86_;
	_tmp87_ = self->priv->cfg;
	desktop_agnostic_config_backend_get_value (_tmp87_, "list", "integer", &_tmp88_, &_inner_error_);
	_tmp89_ = _tmp88_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp90_ = expected;
	_tmp91_ = _tmp89_;
	test_case_assert_equals (self, &_tmp90_, &_tmp91_, &_inner_error_);
	G_IS_VALUE (&_tmp91_) ? (g_value_unset (&_tmp91_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp92_ = self->priv->cfg;
	_tmp93_ = desktop_agnostic_config_backend_get_list (_tmp92_, "list", "integer", &_inner_error_);
	_tmp94_ = _tmp93_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp95_ = expected;
	_tmp96_ = _tmp94_;
	_tmp97_ = test_case_array_equals (self, g_value_get_boxed (&_tmp95_), _tmp96_, &_inner_error_);
	_tmp98_ = _tmp97_;
	_g_value_array_free0 (_tmp96_);
	_tmp99_ = _tmp98_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_vala_assert (_tmp99_, "array_equals ((ValueArray)expected,                           cfg.get_list (\"list\", \"integer\"))");
	_tmp100_ = g_value_array_new ((guint) 3);
	_g_value_array_free0 (expected_array);
	expected_array = _tmp100_;
	g_value_init (&_tmp101_, G_TYPE_FLOAT);
	g_value_set_float (&_tmp101_, 1.618f);
	G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
	item_1 = _tmp101_;
	g_value_init (&_tmp102_, G_TYPE_FLOAT);
	g_value_set_float (&_tmp102_, 2.718f);
	G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
	item_2 = _tmp102_;
	g_value_init (&_tmp103_, G_TYPE_FLOAT);
	g_value_set_float (&_tmp103_, 3.141f);
	G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
	item_3 = _tmp103_;
	_tmp104_ = expected_array;
	_tmp105_ = item_1;
	g_value_array_append (_tmp104_, &_tmp105_);
	_tmp106_ = expected_array;
	_tmp107_ = item_2;
	g_value_array_append (_tmp106_, &_tmp107_);
	_tmp108_ = expected_array;
	_tmp109_ = item_3;
	g_value_array_append (_tmp108_, &_tmp109_);
	_tmp110_ = expected_array;
	g_value_init (&_tmp111_, G_TYPE_VALUE_ARRAY);
	g_value_set_boxed (&_tmp111_, _tmp110_);
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp111_;
	_tmp112_ = self->priv->cfg;
	desktop_agnostic_config_backend_get_value (_tmp112_, "list", "float", &_tmp113_, &_inner_error_);
	_tmp114_ = _tmp113_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp115_ = expected;
	_tmp116_ = _tmp114_;
	test_case_assert_equals (self, &_tmp115_, &_tmp116_, &_inner_error_);
	G_IS_VALUE (&_tmp116_) ? (g_value_unset (&_tmp116_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp117_ = self->priv->cfg;
	_tmp118_ = desktop_agnostic_config_backend_get_list (_tmp117_, "list", "float", &_inner_error_);
	_tmp119_ = _tmp118_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp120_ = expected;
	_tmp121_ = _tmp119_;
	_tmp122_ = test_case_array_equals (self, g_value_get_boxed (&_tmp120_), _tmp121_, &_inner_error_);
	_tmp123_ = _tmp122_;
	_g_value_array_free0 (_tmp121_);
	_tmp124_ = _tmp123_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_vala_assert (_tmp124_, "array_equals ((ValueArray)expected,                           cfg.get_list (\"list\", \"float\"))");
	_tmp125_ = g_value_array_new ((guint) 2);
	_g_value_array_free0 (expected_array);
	expected_array = _tmp125_;
	g_value_init (&_tmp126_, G_TYPE_STRING);
	g_value_set_string (&_tmp126_, "foo");
	G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
	item_1 = _tmp126_;
	g_value_init (&_tmp127_, G_TYPE_STRING);
	g_value_set_string (&_tmp127_, "bar");
	G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
	item_2 = _tmp127_;
	_tmp128_ = expected_array;
	_tmp129_ = item_1;
	g_value_array_append (_tmp128_, &_tmp129_);
	_tmp130_ = expected_array;
	_tmp131_ = item_2;
	g_value_array_append (_tmp130_, &_tmp131_);
	_tmp132_ = expected_array;
	g_value_init (&_tmp133_, G_TYPE_VALUE_ARRAY);
	g_value_set_boxed (&_tmp133_, _tmp132_);
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp133_;
	_tmp134_ = self->priv->cfg;
	desktop_agnostic_config_backend_get_value (_tmp134_, "list", "string", &_tmp135_, &_inner_error_);
	_tmp136_ = _tmp135_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp137_ = expected;
	_tmp138_ = _tmp136_;
	test_case_assert_equals (self, &_tmp137_, &_tmp138_, &_inner_error_);
	G_IS_VALUE (&_tmp138_) ? (g_value_unset (&_tmp138_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp139_ = self->priv->cfg;
	_tmp140_ = desktop_agnostic_config_backend_get_list (_tmp139_, "list", "string", &_inner_error_);
	_tmp141_ = _tmp140_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp142_ = expected;
	_tmp143_ = _tmp141_;
	_tmp144_ = test_case_array_equals (self, g_value_get_boxed (&_tmp142_), _tmp143_, &_inner_error_);
	_tmp145_ = _tmp144_;
	_g_value_array_free0 (_tmp143_);
	_tmp146_ = _tmp145_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_vala_assert (_tmp146_, "array_equals ((ValueArray)expected,                           cfg.get_list (\"list\", \"string\"))");
	test_case_test_default_empty_list (self, "boolean", &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	test_case_test_default_empty_list (self, "integer", &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	test_case_test_default_empty_list (self, "float", &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	test_case_test_default_empty_list (self, "string", &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_g_value_array_free0 (expected_array);
	G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
	G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
	G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
}


static void test_case_test_set_empty_list (TestCase* self, const gchar* key, GError** error) {
	GValueArray* old_value = NULL;
	GValueArray* expected_array = NULL;
	GValue expected = {0};
	DesktopAgnosticConfigBackend* _tmp0_;
	const gchar* _tmp1_;
	GValueArray* _tmp2_ = NULL;
	GValueArray* _tmp3_;
	GValueArray* _tmp4_;
	GValueArray* _tmp5_;
	GValue _tmp6_ = {0};
	DesktopAgnosticConfigBackend* _tmp7_;
	const gchar* _tmp8_;
	GValueArray* _tmp9_;
	DesktopAgnosticConfigBackend* _tmp10_;
	const gchar* _tmp11_;
	GValue _tmp12_ = {0};
	GValue _tmp13_;
	GValue _tmp14_;
	GValue _tmp15_;
	DesktopAgnosticConfigBackend* _tmp16_;
	const gchar* _tmp17_;
	GValueArray* _tmp18_ = NULL;
	GValueArray* _tmp19_;
	GValueArray* _tmp20_;
	GValueArray* _tmp21_;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_;
	gboolean _tmp24_;
	DesktopAgnosticConfigBackend* _tmp25_;
	const gchar* _tmp26_;
	GValueArray* _tmp27_;
	DesktopAgnosticConfigBackend* _tmp28_;
	const gchar* _tmp29_;
	GValueArray* _tmp30_ = NULL;
	GValueArray* _tmp31_;
	GValueArray* _tmp32_;
	GValueArray* _tmp33_;
	gboolean _tmp34_ = FALSE;
	gboolean _tmp35_;
	gboolean _tmp36_;
	DesktopAgnosticConfigBackend* _tmp37_;
	const gchar* _tmp38_;
	GValue _tmp39_;
	DesktopAgnosticConfigBackend* _tmp40_;
	const gchar* _tmp41_;
	GValue _tmp42_ = {0};
	GValue _tmp43_;
	GValue _tmp44_;
	GValue _tmp45_;
	DesktopAgnosticConfigBackend* _tmp46_;
	const gchar* _tmp47_;
	GValueArray* _tmp48_ = NULL;
	GValueArray* _tmp49_;
	GValueArray* _tmp50_;
	GValueArray* _tmp51_;
	gboolean _tmp52_ = FALSE;
	gboolean _tmp53_;
	gboolean _tmp54_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = self->priv->cfg;
	_tmp1_ = key;
	_tmp2_ = desktop_agnostic_config_backend_get_list (_tmp0_, "list", _tmp1_, &_inner_error_);
	_tmp3_ = _tmp2_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		_g_value_array_free0 (expected_array);
		_g_value_array_free0 (old_value);
		return;
	}
	_g_value_array_free0 (old_value);
	old_value = _tmp3_;
	_tmp4_ = g_value_array_new ((guint) 0);
	_g_value_array_free0 (expected_array);
	expected_array = _tmp4_;
	_tmp5_ = expected_array;
	g_value_init (&_tmp6_, G_TYPE_VALUE_ARRAY);
	g_value_set_boxed (&_tmp6_, _tmp5_);
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp6_;
	_tmp7_ = self->priv->cfg;
	_tmp8_ = key;
	_tmp9_ = expected_array;
	desktop_agnostic_config_backend_set_list (_tmp7_, "list", _tmp8_, _tmp9_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		_g_value_array_free0 (expected_array);
		_g_value_array_free0 (old_value);
		return;
	}
	_tmp10_ = self->priv->cfg;
	_tmp11_ = key;
	desktop_agnostic_config_backend_get_value (_tmp10_, "list", _tmp11_, &_tmp12_, &_inner_error_);
	_tmp13_ = _tmp12_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		_g_value_array_free0 (expected_array);
		_g_value_array_free0 (old_value);
		return;
	}
	_tmp14_ = expected;
	_tmp15_ = _tmp13_;
	test_case_assert_equals (self, &_tmp14_, &_tmp15_, &_inner_error_);
	G_IS_VALUE (&_tmp15_) ? (g_value_unset (&_tmp15_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		_g_value_array_free0 (expected_array);
		_g_value_array_free0 (old_value);
		return;
	}
	_tmp16_ = self->priv->cfg;
	_tmp17_ = key;
	_tmp18_ = desktop_agnostic_config_backend_get_list (_tmp16_, "list", _tmp17_, &_inner_error_);
	_tmp19_ = _tmp18_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		_g_value_array_free0 (expected_array);
		_g_value_array_free0 (old_value);
		return;
	}
	_tmp20_ = expected_array;
	_tmp21_ = _tmp19_;
	_tmp22_ = test_case_array_equals (self, _tmp20_, _tmp21_, &_inner_error_);
	_tmp23_ = _tmp22_;
	_g_value_array_free0 (_tmp21_);
	_tmp24_ = _tmp23_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		_g_value_array_free0 (expected_array);
		_g_value_array_free0 (old_value);
		return;
	}
	_vala_assert (_tmp24_, "array_equals (expected_array,                           cfg.get_list (\"list\", key))");
	_tmp25_ = self->priv->cfg;
	_tmp26_ = key;
	_tmp27_ = old_value;
	desktop_agnostic_config_backend_set_list (_tmp25_, "list", _tmp26_, _tmp27_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		_g_value_array_free0 (expected_array);
		_g_value_array_free0 (old_value);
		return;
	}
	_tmp28_ = self->priv->cfg;
	_tmp29_ = key;
	_tmp30_ = desktop_agnostic_config_backend_get_list (_tmp28_, "list", _tmp29_, &_inner_error_);
	_tmp31_ = _tmp30_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		_g_value_array_free0 (expected_array);
		_g_value_array_free0 (old_value);
		return;
	}
	_tmp32_ = old_value;
	_tmp33_ = _tmp31_;
	_tmp34_ = test_case_array_equals (self, _tmp32_, _tmp33_, &_inner_error_);
	_tmp35_ = _tmp34_;
	_g_value_array_free0 (_tmp33_);
	_tmp36_ = _tmp35_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		_g_value_array_free0 (expected_array);
		_g_value_array_free0 (old_value);
		return;
	}
	_vala_assert (_tmp36_, "array_equals (old_value,                           cfg.get_list (\"list\", key))");
	_tmp37_ = self->priv->cfg;
	_tmp38_ = key;
	_tmp39_ = expected;
	desktop_agnostic_config_backend_set_value (_tmp37_, "list", _tmp38_, &_tmp39_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		_g_value_array_free0 (expected_array);
		_g_value_array_free0 (old_value);
		return;
	}
	_tmp40_ = self->priv->cfg;
	_tmp41_ = key;
	desktop_agnostic_config_backend_get_value (_tmp40_, "list", _tmp41_, &_tmp42_, &_inner_error_);
	_tmp43_ = _tmp42_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		_g_value_array_free0 (expected_array);
		_g_value_array_free0 (old_value);
		return;
	}
	_tmp44_ = expected;
	_tmp45_ = _tmp43_;
	test_case_assert_equals (self, &_tmp44_, &_tmp45_, &_inner_error_);
	G_IS_VALUE (&_tmp45_) ? (g_value_unset (&_tmp45_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		_g_value_array_free0 (expected_array);
		_g_value_array_free0 (old_value);
		return;
	}
	_tmp46_ = self->priv->cfg;
	_tmp47_ = key;
	_tmp48_ = desktop_agnostic_config_backend_get_list (_tmp46_, "list", _tmp47_, &_inner_error_);
	_tmp49_ = _tmp48_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		_g_value_array_free0 (expected_array);
		_g_value_array_free0 (old_value);
		return;
	}
	_tmp50_ = expected_array;
	_tmp51_ = _tmp49_;
	_tmp52_ = test_case_array_equals (self, _tmp50_, _tmp51_, &_inner_error_);
	_tmp53_ = _tmp52_;
	_g_value_array_free0 (_tmp51_);
	_tmp54_ = _tmp53_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		_g_value_array_free0 (expected_array);
		_g_value_array_free0 (old_value);
		return;
	}
	_vala_assert (_tmp54_, "array_equals (expected_array,                           cfg.get_list (\"list\", key))");
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	_g_value_array_free0 (expected_array);
	_g_value_array_free0 (old_value);
}


static void test_case_test_set (TestCase* self, GError** error) {
	GValue expected = {0};
	GValue item_1 = {0};
	GValue item_2 = {0};
	GValue item_3 = {0};
	GValueArray* expected_array = NULL;
	GValue _tmp0_ = {0};
	DesktopAgnosticConfigBackend* _tmp1_;
	GValue _tmp2_;
	DesktopAgnosticConfigBackend* _tmp3_;
	GValue _tmp4_ = {0};
	GValue _tmp5_;
	GValue _tmp6_;
	GValue _tmp7_;
	DesktopAgnosticConfigBackend* _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_;
	GValue _tmp11_;
	GValue _tmp12_ = {0};
	DesktopAgnosticConfigBackend* _tmp13_;
	GValue _tmp14_;
	DesktopAgnosticConfigBackend* _tmp15_;
	GValue _tmp16_ = {0};
	GValue _tmp17_;
	GValue _tmp18_;
	GValue _tmp19_;
	DesktopAgnosticConfigBackend* _tmp20_;
	gint _tmp21_ = 0;
	gint _tmp22_;
	GValue _tmp23_;
	GValue _tmp24_ = {0};
	DesktopAgnosticConfigBackend* _tmp25_;
	GValue _tmp26_;
	DesktopAgnosticConfigBackend* _tmp27_;
	GValue _tmp28_ = {0};
	GValue _tmp29_;
	GValue _tmp30_;
	GValue _tmp31_;
	DesktopAgnosticConfigBackend* _tmp32_;
	gfloat _tmp33_ = 0.0F;
	gfloat _tmp34_;
	GValue _tmp35_;
	GValue _tmp36_ = {0};
	DesktopAgnosticConfigBackend* _tmp37_;
	GValue _tmp38_;
	DesktopAgnosticConfigBackend* _tmp39_;
	GValue _tmp40_ = {0};
	GValue _tmp41_;
	GValue _tmp42_;
	GValue _tmp43_;
	DesktopAgnosticConfigBackend* _tmp44_;
	gchar* _tmp45_ = NULL;
	gchar* _tmp46_;
	GValue _tmp47_;
	gchar* _tmp48_;
	GValueArray* _tmp49_;
	GValue _tmp50_ = {0};
	GValue _tmp51_ = {0};
	GValue _tmp52_ = {0};
	GValueArray* _tmp53_;
	GValue _tmp54_;
	GValueArray* _tmp55_;
	GValue _tmp56_;
	GValueArray* _tmp57_;
	GValue _tmp58_;
	GValueArray* _tmp59_;
	GValue _tmp60_ = {0};
	DesktopAgnosticConfigBackend* _tmp61_;
	GValue _tmp62_;
	DesktopAgnosticConfigBackend* _tmp63_;
	GValue _tmp64_ = {0};
	GValue _tmp65_;
	GValue _tmp66_;
	GValue _tmp67_;
	DesktopAgnosticConfigBackend* _tmp68_;
	GValueArray* _tmp69_ = NULL;
	GValueArray* _tmp70_;
	GValue _tmp71_;
	GValueArray* _tmp72_;
	gboolean _tmp73_ = FALSE;
	gboolean _tmp74_;
	gboolean _tmp75_;
	GValueArray* _tmp76_;
	GValue _tmp77_ = {0};
	GValue _tmp78_ = {0};
	GValue _tmp79_ = {0};
	GValueArray* _tmp80_;
	GValue _tmp81_;
	GValueArray* _tmp82_;
	GValue _tmp83_;
	GValueArray* _tmp84_;
	GValue _tmp85_;
	GValueArray* _tmp86_;
	GValue _tmp87_ = {0};
	DesktopAgnosticConfigBackend* _tmp88_;
	GValue _tmp89_;
	DesktopAgnosticConfigBackend* _tmp90_;
	GValue _tmp91_ = {0};
	GValue _tmp92_;
	GValue _tmp93_;
	GValue _tmp94_;
	DesktopAgnosticConfigBackend* _tmp95_;
	GValueArray* _tmp96_ = NULL;
	GValueArray* _tmp97_;
	GValue _tmp98_;
	GValueArray* _tmp99_;
	gboolean _tmp100_ = FALSE;
	gboolean _tmp101_;
	gboolean _tmp102_;
	GValueArray* _tmp103_;
	GValue _tmp104_ = {0};
	GValue _tmp105_ = {0};
	GValue _tmp106_ = {0};
	GValueArray* _tmp107_;
	GValue _tmp108_;
	GValueArray* _tmp109_;
	GValue _tmp110_;
	GValueArray* _tmp111_;
	GValue _tmp112_;
	GValueArray* _tmp113_;
	GValue _tmp114_ = {0};
	DesktopAgnosticConfigBackend* _tmp115_;
	GValue _tmp116_;
	DesktopAgnosticConfigBackend* _tmp117_;
	GValue _tmp118_ = {0};
	GValue _tmp119_;
	GValue _tmp120_;
	GValue _tmp121_;
	DesktopAgnosticConfigBackend* _tmp122_;
	GValueArray* _tmp123_ = NULL;
	GValueArray* _tmp124_;
	GValue _tmp125_;
	GValueArray* _tmp126_;
	gboolean _tmp127_ = FALSE;
	gboolean _tmp128_;
	gboolean _tmp129_;
	GValueArray* _tmp130_;
	GValue _tmp131_ = {0};
	GValue _tmp132_ = {0};
	GValue _tmp133_ = {0};
	GValueArray* _tmp134_;
	GValue _tmp135_;
	GValueArray* _tmp136_;
	GValue _tmp137_;
	GValueArray* _tmp138_;
	GValue _tmp139_;
	GValueArray* _tmp140_;
	GValue _tmp141_ = {0};
	DesktopAgnosticConfigBackend* _tmp142_;
	GValue _tmp143_;
	DesktopAgnosticConfigBackend* _tmp144_;
	GValue _tmp145_ = {0};
	GValue _tmp146_;
	GValue _tmp147_;
	GValue _tmp148_;
	DesktopAgnosticConfigBackend* _tmp149_;
	GValueArray* _tmp150_ = NULL;
	GValueArray* _tmp151_;
	GValue _tmp152_;
	GValueArray* _tmp153_;
	gboolean _tmp154_ = FALSE;
	gboolean _tmp155_;
	gboolean _tmp156_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_value_init (&_tmp0_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp0_, FALSE);
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp0_;
	_tmp1_ = self->priv->cfg;
	_tmp2_ = expected;
	desktop_agnostic_config_backend_set_bool (_tmp1_, "numeric", "boolean", g_value_get_boolean (&_tmp2_), &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp3_ = self->priv->cfg;
	desktop_agnostic_config_backend_get_value (_tmp3_, "numeric", "boolean", &_tmp4_, &_inner_error_);
	_tmp5_ = _tmp4_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp6_ = expected;
	_tmp7_ = _tmp5_;
	test_case_assert_equals (self, &_tmp6_, &_tmp7_, &_inner_error_);
	G_IS_VALUE (&_tmp7_) ? (g_value_unset (&_tmp7_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp8_ = self->priv->cfg;
	_tmp9_ = desktop_agnostic_config_backend_get_bool (_tmp8_, "numeric", "boolean", &_inner_error_);
	_tmp10_ = _tmp9_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp11_ = expected;
	_vala_assert (g_value_get_boolean (&_tmp11_) == _tmp10_, "(bool)expected == cfg.get_bool (\"numeric\", \"boolean\")");
	g_value_init (&_tmp12_, G_TYPE_INT);
	g_value_set_int (&_tmp12_, 10);
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp12_;
	_tmp13_ = self->priv->cfg;
	_tmp14_ = expected;
	desktop_agnostic_config_backend_set_int (_tmp13_, "numeric", "integer", g_value_get_int (&_tmp14_), &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp15_ = self->priv->cfg;
	desktop_agnostic_config_backend_get_value (_tmp15_, "numeric", "integer", &_tmp16_, &_inner_error_);
	_tmp17_ = _tmp16_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp18_ = expected;
	_tmp19_ = _tmp17_;
	test_case_assert_equals (self, &_tmp18_, &_tmp19_, &_inner_error_);
	G_IS_VALUE (&_tmp19_) ? (g_value_unset (&_tmp19_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp20_ = self->priv->cfg;
	_tmp21_ = desktop_agnostic_config_backend_get_int (_tmp20_, "numeric", "integer", &_inner_error_);
	_tmp22_ = _tmp21_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp23_ = expected;
	_vala_assert (g_value_get_int (&_tmp23_) == _tmp22_, "(int)expected == cfg.get_int (\"numeric\", \"integer\")");
	g_value_init (&_tmp24_, G_TYPE_FLOAT);
	g_value_set_float (&_tmp24_, 2.718f);
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp24_;
	_tmp25_ = self->priv->cfg;
	_tmp26_ = expected;
	desktop_agnostic_config_backend_set_float (_tmp25_, "numeric", "float", g_value_get_float (&_tmp26_), &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp27_ = self->priv->cfg;
	desktop_agnostic_config_backend_get_value (_tmp27_, "numeric", "float", &_tmp28_, &_inner_error_);
	_tmp29_ = _tmp28_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp30_ = expected;
	_tmp31_ = _tmp29_;
	test_case_assert_equals (self, &_tmp30_, &_tmp31_, &_inner_error_);
	G_IS_VALUE (&_tmp31_) ? (g_value_unset (&_tmp31_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp32_ = self->priv->cfg;
	_tmp33_ = desktop_agnostic_config_backend_get_float (_tmp32_, "numeric", "float", &_inner_error_);
	_tmp34_ = _tmp33_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp35_ = expected;
	_vala_assert (g_value_get_float (&_tmp35_) == _tmp34_, "(float)expected == cfg.get_float (\"numeric\", \"float\")");
	g_value_init (&_tmp36_, G_TYPE_STRING);
	g_value_set_string (&_tmp36_, "Quux baz");
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp36_;
	_tmp37_ = self->priv->cfg;
	_tmp38_ = expected;
	desktop_agnostic_config_backend_set_string (_tmp37_, "misc", "string", g_value_get_string (&_tmp38_), &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp39_ = self->priv->cfg;
	desktop_agnostic_config_backend_get_value (_tmp39_, "misc", "string", &_tmp40_, &_inner_error_);
	_tmp41_ = _tmp40_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp42_ = expected;
	_tmp43_ = _tmp41_;
	test_case_assert_equals (self, &_tmp42_, &_tmp43_, &_inner_error_);
	G_IS_VALUE (&_tmp43_) ? (g_value_unset (&_tmp43_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp44_ = self->priv->cfg;
	_tmp45_ = desktop_agnostic_config_backend_get_string (_tmp44_, "misc", "string", &_inner_error_);
	_tmp46_ = _tmp45_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp47_ = expected;
	_tmp48_ = _tmp46_;
	_vala_assert (g_strcmp0 (g_value_get_string (&_tmp47_), _tmp48_) == 0, "(string)expected == cfg.get_string (\"misc\", \"string\")");
	_g_free0 (_tmp48_);
	_tmp49_ = g_value_array_new ((guint) 3);
	_g_value_array_free0 (expected_array);
	expected_array = _tmp49_;
	g_value_init (&_tmp50_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp50_, FALSE);
	G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
	item_1 = _tmp50_;
	g_value_init (&_tmp51_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp51_, TRUE);
	G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
	item_2 = _tmp51_;
	g_value_init (&_tmp52_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp52_, FALSE);
	G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
	item_3 = _tmp52_;
	_tmp53_ = expected_array;
	_tmp54_ = item_1;
	g_value_array_append (_tmp53_, &_tmp54_);
	_tmp55_ = expected_array;
	_tmp56_ = item_2;
	g_value_array_append (_tmp55_, &_tmp56_);
	_tmp57_ = expected_array;
	_tmp58_ = item_3;
	g_value_array_append (_tmp57_, &_tmp58_);
	_tmp59_ = expected_array;
	g_value_init (&_tmp60_, G_TYPE_VALUE_ARRAY);
	g_value_set_boxed (&_tmp60_, _tmp59_);
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp60_;
	_tmp61_ = self->priv->cfg;
	_tmp62_ = expected;
	desktop_agnostic_config_backend_set_list (_tmp61_, "list", "boolean", g_value_get_boxed (&_tmp62_), &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp63_ = self->priv->cfg;
	desktop_agnostic_config_backend_get_value (_tmp63_, "list", "boolean", &_tmp64_, &_inner_error_);
	_tmp65_ = _tmp64_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp66_ = expected;
	_tmp67_ = _tmp65_;
	test_case_assert_equals (self, &_tmp66_, &_tmp67_, &_inner_error_);
	G_IS_VALUE (&_tmp67_) ? (g_value_unset (&_tmp67_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp68_ = self->priv->cfg;
	_tmp69_ = desktop_agnostic_config_backend_get_list (_tmp68_, "list", "boolean", &_inner_error_);
	_tmp70_ = _tmp69_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp71_ = expected;
	_tmp72_ = _tmp70_;
	_tmp73_ = test_case_array_equals (self, g_value_get_boxed (&_tmp71_), _tmp72_, &_inner_error_);
	_tmp74_ = _tmp73_;
	_g_value_array_free0 (_tmp72_);
	_tmp75_ = _tmp74_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_vala_assert (_tmp75_, "array_equals ((ValueArray)expected,                           cfg.get_list (\"list\", \"boolean\"))");
	_tmp76_ = g_value_array_new ((guint) 3);
	_g_value_array_free0 (expected_array);
	expected_array = _tmp76_;
	g_value_init (&_tmp77_, G_TYPE_INT);
	g_value_set_int (&_tmp77_, 10);
	G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
	item_1 = _tmp77_;
	g_value_init (&_tmp78_, G_TYPE_INT);
	g_value_set_int (&_tmp78_, 20);
	G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
	item_2 = _tmp78_;
	g_value_init (&_tmp79_, G_TYPE_INT);
	g_value_set_int (&_tmp79_, 30);
	G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
	item_3 = _tmp79_;
	_tmp80_ = expected_array;
	_tmp81_ = item_1;
	g_value_array_append (_tmp80_, &_tmp81_);
	_tmp82_ = expected_array;
	_tmp83_ = item_2;
	g_value_array_append (_tmp82_, &_tmp83_);
	_tmp84_ = expected_array;
	_tmp85_ = item_3;
	g_value_array_append (_tmp84_, &_tmp85_);
	_tmp86_ = expected_array;
	g_value_init (&_tmp87_, G_TYPE_VALUE_ARRAY);
	g_value_set_boxed (&_tmp87_, _tmp86_);
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp87_;
	_tmp88_ = self->priv->cfg;
	_tmp89_ = expected;
	desktop_agnostic_config_backend_set_list (_tmp88_, "list", "integer", g_value_get_boxed (&_tmp89_), &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp90_ = self->priv->cfg;
	desktop_agnostic_config_backend_get_value (_tmp90_, "list", "integer", &_tmp91_, &_inner_error_);
	_tmp92_ = _tmp91_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp93_ = expected;
	_tmp94_ = _tmp92_;
	test_case_assert_equals (self, &_tmp93_, &_tmp94_, &_inner_error_);
	G_IS_VALUE (&_tmp94_) ? (g_value_unset (&_tmp94_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp95_ = self->priv->cfg;
	_tmp96_ = desktop_agnostic_config_backend_get_list (_tmp95_, "list", "integer", &_inner_error_);
	_tmp97_ = _tmp96_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp98_ = expected;
	_tmp99_ = _tmp97_;
	_tmp100_ = test_case_array_equals (self, g_value_get_boxed (&_tmp98_), _tmp99_, &_inner_error_);
	_tmp101_ = _tmp100_;
	_g_value_array_free0 (_tmp99_);
	_tmp102_ = _tmp101_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_vala_assert (_tmp102_, "array_equals ((ValueArray)expected,                           cfg.get_list (\"list\", \"integer\"))");
	_tmp103_ = g_value_array_new ((guint) 3);
	_g_value_array_free0 (expected_array);
	expected_array = _tmp103_;
	g_value_init (&_tmp104_, G_TYPE_FLOAT);
	g_value_set_float (&_tmp104_, 10.5f);
	G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
	item_1 = _tmp104_;
	g_value_init (&_tmp105_, G_TYPE_FLOAT);
	g_value_set_float (&_tmp105_, 20.6f);
	G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
	item_2 = _tmp105_;
	g_value_init (&_tmp106_, G_TYPE_FLOAT);
	g_value_set_float (&_tmp106_, 30.7f);
	G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
	item_3 = _tmp106_;
	_tmp107_ = expected_array;
	_tmp108_ = item_1;
	g_value_array_append (_tmp107_, &_tmp108_);
	_tmp109_ = expected_array;
	_tmp110_ = item_2;
	g_value_array_append (_tmp109_, &_tmp110_);
	_tmp111_ = expected_array;
	_tmp112_ = item_3;
	g_value_array_append (_tmp111_, &_tmp112_);
	_tmp113_ = expected_array;
	g_value_init (&_tmp114_, G_TYPE_VALUE_ARRAY);
	g_value_set_boxed (&_tmp114_, _tmp113_);
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp114_;
	_tmp115_ = self->priv->cfg;
	_tmp116_ = expected;
	desktop_agnostic_config_backend_set_list (_tmp115_, "list", "float", g_value_get_boxed (&_tmp116_), &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp117_ = self->priv->cfg;
	desktop_agnostic_config_backend_get_value (_tmp117_, "list", "float", &_tmp118_, &_inner_error_);
	_tmp119_ = _tmp118_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp120_ = expected;
	_tmp121_ = _tmp119_;
	test_case_assert_equals (self, &_tmp120_, &_tmp121_, &_inner_error_);
	G_IS_VALUE (&_tmp121_) ? (g_value_unset (&_tmp121_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp122_ = self->priv->cfg;
	_tmp123_ = desktop_agnostic_config_backend_get_list (_tmp122_, "list", "float", &_inner_error_);
	_tmp124_ = _tmp123_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp125_ = expected;
	_tmp126_ = _tmp124_;
	_tmp127_ = test_case_array_equals (self, g_value_get_boxed (&_tmp125_), _tmp126_, &_inner_error_);
	_tmp128_ = _tmp127_;
	_g_value_array_free0 (_tmp126_);
	_tmp129_ = _tmp128_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_vala_assert (_tmp129_, "array_equals ((ValueArray)expected,                           cfg.get_list (\"list\", \"float\"))");
	_tmp130_ = g_value_array_new ((guint) 3);
	_g_value_array_free0 (expected_array);
	expected_array = _tmp130_;
	g_value_init (&_tmp131_, G_TYPE_STRING);
	g_value_set_string (&_tmp131_, "Quux");
	G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
	item_1 = _tmp131_;
	g_value_init (&_tmp132_, G_TYPE_STRING);
	g_value_set_string (&_tmp132_, "Baz");
	G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
	item_2 = _tmp132_;
	g_value_init (&_tmp133_, G_TYPE_STRING);
	g_value_set_string (&_tmp133_, "Foo");
	G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
	item_3 = _tmp133_;
	_tmp134_ = expected_array;
	_tmp135_ = item_1;
	g_value_array_append (_tmp134_, &_tmp135_);
	_tmp136_ = expected_array;
	_tmp137_ = item_2;
	g_value_array_append (_tmp136_, &_tmp137_);
	_tmp138_ = expected_array;
	_tmp139_ = item_3;
	g_value_array_append (_tmp138_, &_tmp139_);
	_tmp140_ = expected_array;
	g_value_init (&_tmp141_, G_TYPE_VALUE_ARRAY);
	g_value_set_boxed (&_tmp141_, _tmp140_);
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
	expected = _tmp141_;
	_tmp142_ = self->priv->cfg;
	_tmp143_ = expected;
	desktop_agnostic_config_backend_set_list (_tmp142_, "list", "string", g_value_get_boxed (&_tmp143_), &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp144_ = self->priv->cfg;
	desktop_agnostic_config_backend_get_value (_tmp144_, "list", "string", &_tmp145_, &_inner_error_);
	_tmp146_ = _tmp145_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp147_ = expected;
	_tmp148_ = _tmp146_;
	test_case_assert_equals (self, &_tmp147_, &_tmp148_, &_inner_error_);
	G_IS_VALUE (&_tmp148_) ? (g_value_unset (&_tmp148_), NULL) : NULL;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp149_ = self->priv->cfg;
	_tmp150_ = desktop_agnostic_config_backend_get_list (_tmp149_, "list", "string", &_inner_error_);
	_tmp151_ = _tmp150_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_tmp152_ = expected;
	_tmp153_ = _tmp151_;
	_tmp154_ = test_case_array_equals (self, g_value_get_boxed (&_tmp152_), _tmp153_, &_inner_error_);
	_tmp155_ = _tmp154_;
	_g_value_array_free0 (_tmp153_);
	_tmp156_ = _tmp155_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_vala_assert (_tmp156_, "array_equals ((ValueArray)expected,                           cfg.get_list (\"list\", \"string\"))");
	test_case_test_set_empty_list (self, "boolean", &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	test_case_test_set_empty_list (self, "integer", &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	test_case_test_set_empty_list (self, "float", &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	test_case_test_set_empty_list (self, "string", &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_value_array_free0 (expected_array);
		G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
		G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
		G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
		G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
		return;
	}
	_g_value_array_free0 (expected_array);
	G_IS_VALUE (&item_3) ? (g_value_unset (&item_3), NULL) : NULL;
	G_IS_VALUE (&item_2) ? (g_value_unset (&item_2), NULL) : NULL;
	G_IS_VALUE (&item_1) ? (g_value_unset (&item_1), NULL) : NULL;
	G_IS_VALUE (&expected) ? (g_value_unset (&expected), NULL) : NULL;
}


static void test_case_update_notify_value (TestCase* self, GMainContext* ctx, const gchar* value, guint counter_expected, GError** error) {
	DesktopAgnosticConfigBackend* _tmp0_;
	const gchar* _tmp1_;
	guint _tmp5_;
	guint _tmp6_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (value != NULL);
	_tmp0_ = self->priv->cfg;
	_tmp1_ = value;
	desktop_agnostic_config_backend_set_string (_tmp0_, "misc", "string", _tmp1_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	g_usleep ((gulong) 250000);
	while (TRUE) {
		GMainContext* _tmp2_;
		gboolean _tmp3_ = FALSE;
		GMainContext* _tmp4_;
		_tmp2_ = ctx;
		_tmp3_ = g_main_context_pending (_tmp2_);
		if (!_tmp3_) {
			break;
		}
		_tmp4_ = ctx;
		g_main_context_iteration (_tmp4_, FALSE);
	}
	_tmp5_ = self->priv->notify_counter;
	_tmp6_ = counter_expected;
	_vala_assert (_tmp5_ == _tmp6_, "this.notify_counter == counter_expected");
}


static void _test_case_on_string_changed_desktop_agnostic_config_notify_func (const gchar* group, const gchar* key, GValue* value, gpointer self) {
	test_case_on_string_changed (self, group, key, value);
}


static void _test_case_on_string_changed2_desktop_agnostic_config_notify_func (const gchar* group, const gchar* key, GValue* value, gpointer self) {
	test_case_on_string_changed2 (self, group, key, value);
}


static void test_case_test_notify (TestCase* self, GError** error) {
	GMainLoop* _tmp0_;
	GMainContext* _tmp1_ = NULL;
	GMainContext* ctx;
	DesktopAgnosticConfigBackend* _tmp2_;
	DesktopAgnosticConfigBackend* _tmp3_;
	GMainContext* _tmp4_;
	GMainContext* _tmp5_;
	DesktopAgnosticConfigBackend* _tmp6_;
	GMainContext* _tmp7_;
	DesktopAgnosticConfigBackend* _tmp8_;
	GMainContext* _tmp9_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->ml;
	_tmp1_ = g_main_loop_get_context (_tmp0_);
	ctx = _tmp1_;
	_tmp2_ = self->priv->cfg;
	desktop_agnostic_config_backend_notify_add (_tmp2_, "misc", "string", _test_case_on_string_changed_desktop_agnostic_config_notify_func, self, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp3_ = self->priv->cfg;
	desktop_agnostic_config_backend_notify_add (_tmp3_, "misc", "string", _test_case_on_string_changed2_desktop_agnostic_config_notify_func, self, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp4_ = ctx;
	test_case_update_notify_value (self, _tmp4_, "Bar foo", (guint) 1, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp5_ = ctx;
	test_case_update_notify_value (self, _tmp5_, "Foo quux", (guint) 5, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp6_ = self->priv->cfg;
	desktop_agnostic_config_backend_notify_remove (_tmp6_, "misc", "string", _test_case_on_string_changed_desktop_agnostic_config_notify_func, self, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp7_ = ctx;
	test_case_update_notify_value (self, _tmp7_, "Bar quux", (guint) 8, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp8_ = self->priv->cfg;
	desktop_agnostic_config_backend_notify_remove (_tmp8_, "misc", "string", _test_case_on_string_changed2_desktop_agnostic_config_notify_func, self, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp9_ = ctx;
	test_case_update_notify_value (self, _tmp9_, "Baz foo", (guint) 8, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


static void test_case_test_invalid_func (TestCase* self, TestCaseGetCfgFunc func, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		TestCaseGetCfgFunc _tmp0_;
		DesktopAgnosticConfigBackend* _tmp1_;
		GError* _tmp2_;
		_tmp0_ = func;
		_tmp1_ = self->priv->cfg;
		_tmp0_ (_tmp1_, "foo", "bar", &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
		_tmp2_ = g_error_new_literal (ASSERTION_ERROR, ASSERTION_ERROR_NOT_REACHED, "Key should have been nonexistent.");
		_inner_error_ = _tmp2_;
		goto __catch0_g_error;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = err;
		if (!g_error_matches (_tmp3_, DESKTOP_AGNOSTIC_CONFIG_ERROR, DESKTOP_AGNOSTIC_CONFIG_ERROR_KEY_NOT_FOUND)) {
			GError* _tmp4_;
			GError* _tmp5_;
			_tmp4_ = err;
			_tmp5_ = _g_error_copy0 (_tmp4_);
			_inner_error_ = _tmp5_;
			_g_error_free0 (err);
			goto __finally0;
		}
		_g_error_free0 (err);
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


static void test_case_test_invalid (TestCase* self, GError** error) {
	DesktopAgnosticConfigBackend* _tmp0_;
	DesktopAgnosticConfigBackend* _tmp1_;
	DesktopAgnosticConfigBackend* _tmp2_;
	DesktopAgnosticConfigBackend* _tmp3_;
	DesktopAgnosticConfigBackend* _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->cfg;
	test_case_test_invalid_func (self, (TestCaseGetCfgFunc) desktop_agnostic_config_backend_get_bool, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp1_ = self->priv->cfg;
	test_case_test_invalid_func (self, (TestCaseGetCfgFunc) desktop_agnostic_config_backend_get_float, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp2_ = self->priv->cfg;
	test_case_test_invalid_func (self, (TestCaseGetCfgFunc) desktop_agnostic_config_backend_get_int, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp3_ = self->priv->cfg;
	test_case_test_invalid_func (self, (TestCaseGetCfgFunc) desktop_agnostic_config_backend_get_string, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp4_ = self->priv->cfg;
	test_case_test_invalid_func (self, (TestCaseGetCfgFunc) desktop_agnostic_config_backend_get_list, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


gint test_case_main (gchar** args, int args_length1) {
	gint result = 0;
	GError * _inner_error_ = NULL;
	{
		TestCase* _tmp0_;
		TestCase* test;
		TestCase* _tmp1_;
		TestCase* _tmp2_;
		TestCase* _tmp3_;
		TestCase* _tmp4_;
		_tmp0_ = test_case_new (&_inner_error_);
		test = _tmp0_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == ASSERTION_ERROR) {
				goto __catch1_assertion_error;
			}
			goto __catch1_g_error;
		}
		_tmp1_ = test;
		test_case_test_defaults (_tmp1_, &_inner_error_);
		if (_inner_error_ != NULL) {
			_test_case_unref0 (test);
			if (_inner_error_->domain == ASSERTION_ERROR) {
				goto __catch1_assertion_error;
			}
			goto __catch1_g_error;
		}
		_tmp2_ = test;
		test_case_test_set (_tmp2_, &_inner_error_);
		if (_inner_error_ != NULL) {
			_test_case_unref0 (test);
			if (_inner_error_->domain == ASSERTION_ERROR) {
				goto __catch1_assertion_error;
			}
			goto __catch1_g_error;
		}
		_tmp3_ = test;
		test_case_test_invalid (_tmp3_, &_inner_error_);
		if (_inner_error_ != NULL) {
			_test_case_unref0 (test);
			if (_inner_error_->domain == ASSERTION_ERROR) {
				goto __catch1_assertion_error;
			}
			goto __catch1_g_error;
		}
		_tmp4_ = test;
		test_case_test_notify (_tmp4_, &_inner_error_);
		if (_inner_error_ != NULL) {
			_test_case_unref0 (test);
			if (_inner_error_->domain == ASSERTION_ERROR) {
				goto __catch1_assertion_error;
			}
			goto __catch1_g_error;
		}
		_test_case_unref0 (test);
	}
	goto __finally1;
	__catch1_assertion_error:
	{
		GError* assertion = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		assertion = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = assertion;
		_tmp6_ = _tmp5_->message;
		g_critical ("test-config.vala:400: Assertion Error: %s", _tmp6_);
		result = EXIT_ASSERTION;
		_g_error_free0 (assertion);
		return result;
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp7_ = err;
		_tmp8_ = _tmp7_->message;
		g_critical ("test-config.vala:405: Error: %s", _tmp8_);
		result = EXIT_EXCEPTION;
		_g_error_free0 (err);
		return result;
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
	result = EXIT_SUCCESS;
	return result;
}


int main (int argc, char ** argv) {
	g_type_init ();
	return test_case_main (argv, argc);
}


static void value_test_case_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_test_case_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		test_case_unref (value->data[0].v_pointer);
	}
}


static void value_test_case_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = test_case_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_test_case_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_test_case_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		TestCase* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = test_case_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_test_case_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	TestCase** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = test_case_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_test_case (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecTestCase* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TEST_CASE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_test_case (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEST_CASE), NULL);
	return value->data[0].v_pointer;
}


void value_set_test_case (GValue* value, gpointer v_object) {
	TestCase* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEST_CASE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TEST_CASE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		test_case_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		test_case_unref (old);
	}
}


void value_take_test_case (GValue* value, gpointer v_object) {
	TestCase* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEST_CASE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TEST_CASE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		test_case_unref (old);
	}
}


static void test_case_class_init (TestCaseClass * klass) {
	test_case_parent_class = g_type_class_peek_parent (klass);
	TEST_CASE_CLASS (klass)->finalize = test_case_finalize;
	g_type_class_add_private (klass, sizeof (TestCasePrivate));
}


static void test_case_instance_init (TestCase * self) {
	self->priv = TEST_CASE_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void test_case_finalize (TestCase* obj) {
	TestCase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TEST_CASE, TestCase);
	_g_object_unref0 (self->priv->cfg);
	_g_main_loop_unref0 (self->priv->ml);
}


GType test_case_get_type (void) {
	static volatile gsize test_case_type_id__volatile = 0;
	if (g_once_init_enter (&test_case_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_test_case_init, value_test_case_free_value, value_test_case_copy_value, value_test_case_peek_pointer, "p", value_test_case_collect_value, "p", value_test_case_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (TestCaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) test_case_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TestCase), 0, (GInstanceInitFunc) test_case_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType test_case_type_id;
		test_case_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TestCase", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&test_case_type_id__volatile, test_case_type_id);
	}
	return test_case_type_id__volatile;
}


gpointer test_case_ref (gpointer instance) {
	TestCase* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void test_case_unref (gpointer instance) {
	TestCase* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		TEST_CASE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



