/* test-vfs-file-monitor.c generated by valac 0.20.1, the Vala compiler
 * generated from test-vfs-file-monitor.vala, do not modify */

/*
 * Desktop Agnostic Library: Test for the file monitor implementations.
 *
 * Copyright (C) 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <libdesktop-agnostic/vfs.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_TEST_FILE_MONITOR (test_file_monitor_get_type ())
#define TEST_FILE_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TEST_FILE_MONITOR, TestFileMonitor))
#define TEST_FILE_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TEST_FILE_MONITOR, TestFileMonitorClass))
#define IS_TEST_FILE_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TEST_FILE_MONITOR))
#define IS_TEST_FILE_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TEST_FILE_MONITOR))
#define TEST_FILE_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TEST_FILE_MONITOR, TestFileMonitorClass))

typedef struct _TestFileMonitor TestFileMonitor;
typedef struct _TestFileMonitorClass TestFileMonitorClass;
typedef struct _TestFileMonitorPrivate TestFileMonitorPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
typedef struct _ParamSpecTestFileMonitor ParamSpecTestFileMonitor;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TestFileMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TestFileMonitorPrivate * priv;
};

struct _TestFileMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (TestFileMonitor *self);
};

struct _ParamSpecTestFileMonitor {
	GParamSpec parent_instance;
};


static gpointer test_file_monitor_parent_class = NULL;
static DesktopAgnosticVFSFile* test_file_monitor_file;
static DesktopAgnosticVFSFile* test_file_monitor_file = NULL;
static DesktopAgnosticVFSFileMonitor* test_file_monitor_monitor;
static DesktopAgnosticVFSFileMonitor* test_file_monitor_monitor = NULL;

gpointer test_file_monitor_ref (gpointer instance);
void test_file_monitor_unref (gpointer instance);
GParamSpec* param_spec_test_file_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_test_file_monitor (GValue* value, gpointer v_object);
void value_take_test_file_monitor (GValue* value, gpointer v_object);
gpointer value_get_test_file_monitor (const GValue* value);
GType test_file_monitor_get_type (void) G_GNUC_CONST;
enum  {
	TEST_FILE_MONITOR_DUMMY_PROPERTY
};
static void test_file_monitor_on_change (DesktopAgnosticVFSFileMonitor* monitor, DesktopAgnosticVFSFile* file, DesktopAgnosticVFSFile* other, DesktopAgnosticVFSFileMonitorEvent event);
static gboolean test_file_monitor_do_emit (void);
gint test_file_monitor_main (gchar** args, int args_length1);
static void _test_file_monitor_on_change_desktop_agnostic_vfs_file_monitor_changed (DesktopAgnosticVFSFileMonitor* _sender, DesktopAgnosticVFSFile* file, DesktopAgnosticVFSFile* other, DesktopAgnosticVFSFileMonitorEvent event, gpointer self);
static gboolean _test_file_monitor_do_emit_gsource_func (gpointer self);
TestFileMonitor* test_file_monitor_new (void);
TestFileMonitor* test_file_monitor_construct (GType object_type);
static void test_file_monitor_finalize (TestFileMonitor* obj);


static void test_file_monitor_on_change (DesktopAgnosticVFSFileMonitor* monitor, DesktopAgnosticVFSFile* file, DesktopAgnosticVFSFile* other, DesktopAgnosticVFSFileMonitorEvent event) {
	gchar* _tmp0_;
	gchar* evt_str;
	DesktopAgnosticVFSFileMonitorEvent _tmp1_;
	const gchar* _tmp7_;
	DesktopAgnosticVFSFile* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	DesktopAgnosticVFSFile* _tmp12_;
	g_return_if_fail (monitor != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = g_strdup ("?");
	evt_str = _tmp0_;
	_tmp1_ = event;
	switch (_tmp1_) {
		case DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_CHANGED:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("Changed");
			_g_free0 (evt_str);
			evt_str = _tmp2_;
			break;
		}
		case DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_CREATED:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("Created");
			_g_free0 (evt_str);
			evt_str = _tmp3_;
			break;
		}
		case DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_DELETED:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("Deleted");
			_g_free0 (evt_str);
			evt_str = _tmp4_;
			break;
		}
		case DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("Attribute Changed");
			_g_free0 (evt_str);
			evt_str = _tmp5_;
			break;
		}
		case DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_UNKNOWN:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("Unknown");
			_g_free0 (evt_str);
			evt_str = _tmp6_;
			break;
		}
		default:
		break;
	}
	_tmp7_ = evt_str;
	_tmp8_ = file;
	_tmp9_ = desktop_agnostic_vfs_file_get_uri (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = _tmp10_;
	g_message ("test-vfs-file-monitor.vala:53: %s: %s", _tmp7_, _tmp11_);
	_g_free0 (_tmp11_);
	_tmp12_ = other;
	if (_tmp12_ != NULL) {
		DesktopAgnosticVFSFile* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		_tmp13_ = other;
		_tmp14_ = desktop_agnostic_vfs_file_get_uri (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = _tmp15_;
		g_message ("test-vfs-file-monitor.vala:56:  * other: %s", _tmp16_);
		_g_free0 (_tmp16_);
	}
	_g_free0 (evt_str);
}


static gboolean test_file_monitor_do_emit (void) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	{
		DesktopAgnosticVFSFile* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		gchar* filename;
		DesktopAgnosticVFSFile* _tmp6_ = NULL;
		DesktopAgnosticVFSFile* other;
		DesktopAgnosticVFSFileMonitor* _tmp7_;
		_tmp0_ = test_file_monitor_file;
		_tmp1_ = desktop_agnostic_vfs_file_get_path (_tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = g_build_filename (_tmp3_, "test-vfs-file.txt", NULL);
		_tmp5_ = _tmp4_;
		_g_free0 (_tmp3_);
		filename = _tmp5_;
		_tmp6_ = desktop_agnostic_vfs_file_new_for_path (filename, &_inner_error_);
		other = _tmp6_;
		if (_inner_error_ != NULL) {
			_g_free0 (filename);
			goto __catch0_g_error;
		}
		_tmp7_ = test_file_monitor_monitor;
		desktop_agnostic_vfs_file_monitor_emit (_tmp7_, other, DESKTOP_AGNOSTIC_VFS_FILE_MONITOR_EVENT_CREATED);
		_g_object_unref0 (other);
		_g_free0 (filename);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp8_ = err;
		_tmp9_ = _tmp8_->message;
		g_critical ("test-vfs-file-monitor.vala:70: Error: %s", _tmp9_);
		_g_error_free0 (err);
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = FALSE;
	return result;
}


static void _test_file_monitor_on_change_desktop_agnostic_vfs_file_monitor_changed (DesktopAgnosticVFSFileMonitor* _sender, DesktopAgnosticVFSFile* file, DesktopAgnosticVFSFile* other, DesktopAgnosticVFSFileMonitorEvent event, gpointer self) {
	test_file_monitor_on_change (_sender, file, other, event);
}


static gboolean _test_file_monitor_do_emit_gsource_func (gpointer self) {
	gboolean result;
	result = test_file_monitor_do_emit ();
	return result;
}


gint test_file_monitor_main (gchar** args, int args_length1) {
	gint result = 0;
	gchar** _tmp0_;
	gint _tmp0__length1;
	GError * _inner_error_ = NULL;
	_tmp0_ = args;
	_tmp0__length1 = args_length1;
	if (_tmp0__length1 < 2) {
		FILE* _tmp1_;
		gchar** _tmp2_;
		gint _tmp2__length1;
		const gchar* _tmp3_;
		_tmp1_ = stderr;
		_tmp2_ = args;
		_tmp2__length1 = args_length1;
		_tmp3_ = _tmp2_[0];
		fprintf (_tmp1_, "Usage: %s [FILE | DIRECTORY FILE] \n", _tmp3_);
		result = 1;
		return result;
	}
	{
		gchar** _tmp4_;
		gint _tmp4__length1;
		const gchar* _tmp5_;
		const gchar* path;
		const gchar* _tmp6_;
		DesktopAgnosticVFSFile* _tmp7_ = NULL;
		DesktopAgnosticVFSFile* _tmp8_;
		DesktopAgnosticVFSFile* _tmp9_;
		DesktopAgnosticVFSFileMonitor* _tmp10_ = NULL;
		DesktopAgnosticVFSFileMonitor* _tmp11_;
		GMainLoop* _tmp12_;
		GMainLoop* mainloop;
		gboolean _tmp13_ = FALSE;
		gchar** _tmp14_;
		gint _tmp14__length1;
		gboolean _tmp18_;
		GMainLoop* _tmp19_;
		DesktopAgnosticVFSFileMonitor* _tmp20_;
		DesktopAgnosticVFSFileMonitor* _tmp21_;
		gboolean _tmp22_;
		gboolean _tmp23_;
		desktop_agnostic_vfs_init (&_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
		_tmp4_ = args;
		_tmp4__length1 = args_length1;
		_tmp5_ = _tmp4_[1];
		path = _tmp5_;
		_tmp6_ = path;
		_tmp7_ = desktop_agnostic_vfs_file_new_for_path (_tmp6_, &_inner_error_);
		_tmp8_ = _tmp7_;
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
		_g_object_unref0 (test_file_monitor_file);
		test_file_monitor_file = _tmp8_;
		_tmp9_ = test_file_monitor_file;
		_tmp10_ = desktop_agnostic_vfs_file_monitor (_tmp9_);
		_g_object_unref0 (test_file_monitor_monitor);
		test_file_monitor_monitor = _tmp10_;
		_tmp11_ = test_file_monitor_monitor;
		g_signal_connect (_tmp11_, "changed", (GCallback) _test_file_monitor_on_change_desktop_agnostic_vfs_file_monitor_changed, NULL);
		_tmp12_ = g_main_loop_new (NULL, FALSE);
		mainloop = _tmp12_;
		_tmp14_ = args;
		_tmp14__length1 = args_length1;
		if (_tmp14__length1 == 3) {
			DesktopAgnosticVFSFile* _tmp15_;
			DesktopAgnosticVFSFileType _tmp16_;
			DesktopAgnosticVFSFileType _tmp17_;
			_tmp15_ = test_file_monitor_file;
			_tmp16_ = desktop_agnostic_vfs_file_get_file_type (_tmp15_);
			_tmp17_ = _tmp16_;
			_tmp13_ = _tmp17_ == DESKTOP_AGNOSTIC_VFS_FILE_TYPE_DIRECTORY;
		} else {
			_tmp13_ = FALSE;
		}
		_tmp18_ = _tmp13_;
		if (_tmp18_) {
			g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, _test_file_monitor_do_emit_gsource_func, NULL, NULL);
		}
		_tmp19_ = mainloop;
		g_main_loop_run (_tmp19_);
		_tmp20_ = test_file_monitor_monitor;
		desktop_agnostic_vfs_file_monitor_cancel (_tmp20_);
		_tmp21_ = test_file_monitor_monitor;
		_tmp22_ = desktop_agnostic_vfs_file_monitor_get_cancelled (_tmp21_);
		_tmp23_ = _tmp22_;
		_vala_assert (_tmp23_, "monitor.cancelled");
		desktop_agnostic_vfs_shutdown (&_inner_error_);
		if (_inner_error_ != NULL) {
			_g_main_loop_unref0 (mainloop);
			goto __catch1_g_error;
		}
		_g_main_loop_unref0 (mainloop);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		GError* _tmp24_;
		const gchar* _tmp25_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp24_ = err;
		_tmp25_ = _tmp24_->message;
		g_critical ("test-vfs-file-monitor.vala:102: VFS Error: %s", _tmp25_);
		result = 1;
		_g_error_free0 (err);
		return result;
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
	result = 0;
	return result;
}


int main (int argc, char ** argv) {
	g_type_init ();
	return test_file_monitor_main (argv, argc);
}


TestFileMonitor* test_file_monitor_construct (GType object_type) {
	TestFileMonitor* self = NULL;
	self = (TestFileMonitor*) g_type_create_instance (object_type);
	return self;
}


TestFileMonitor* test_file_monitor_new (void) {
	return test_file_monitor_construct (TYPE_TEST_FILE_MONITOR);
}


static void value_test_file_monitor_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_test_file_monitor_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		test_file_monitor_unref (value->data[0].v_pointer);
	}
}


static void value_test_file_monitor_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = test_file_monitor_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_test_file_monitor_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_test_file_monitor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		TestFileMonitor* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = test_file_monitor_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_test_file_monitor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	TestFileMonitor** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = test_file_monitor_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_test_file_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecTestFileMonitor* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TEST_FILE_MONITOR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_test_file_monitor (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEST_FILE_MONITOR), NULL);
	return value->data[0].v_pointer;
}


void value_set_test_file_monitor (GValue* value, gpointer v_object) {
	TestFileMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEST_FILE_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TEST_FILE_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		test_file_monitor_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		test_file_monitor_unref (old);
	}
}


void value_take_test_file_monitor (GValue* value, gpointer v_object) {
	TestFileMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEST_FILE_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TEST_FILE_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		test_file_monitor_unref (old);
	}
}


static void test_file_monitor_class_init (TestFileMonitorClass * klass) {
	test_file_monitor_parent_class = g_type_class_peek_parent (klass);
	TEST_FILE_MONITOR_CLASS (klass)->finalize = test_file_monitor_finalize;
}


static void test_file_monitor_instance_init (TestFileMonitor * self) {
	self->ref_count = 1;
}


static void test_file_monitor_finalize (TestFileMonitor* obj) {
	TestFileMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TEST_FILE_MONITOR, TestFileMonitor);
}


GType test_file_monitor_get_type (void) {
	static volatile gsize test_file_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&test_file_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_test_file_monitor_init, value_test_file_monitor_free_value, value_test_file_monitor_copy_value, value_test_file_monitor_peek_pointer, "p", value_test_file_monitor_collect_value, "p", value_test_file_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (TestFileMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) test_file_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TestFileMonitor), 0, (GInstanceInitFunc) test_file_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType test_file_monitor_type_id;
		test_file_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TestFileMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&test_file_monitor_type_id__volatile, test_file_monitor_type_id);
	}
	return test_file_monitor_type_id__volatile;
}


gpointer test_file_monitor_ref (gpointer instance) {
	TestFileMonitor* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void test_file_monitor_unref (gpointer instance) {
	TestFileMonitor* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		TEST_FILE_MONITOR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



